"""
Contains lists of proper nouns which should survice decapitalization in bibliographies

Attributes:
    CONTINENTNAMES: names for contintents
    
    OCEANNAMES: names for oceans
    
    CITIES: names for cities having hosted workshops and conferences or whose dialect has received attention 
    
    COUNTRIES: names of countries 
    
    LANGUAGENAMES: names of languages 
    
    OCCURREDREPLACEMENTS: other replacements which have occurred in books by Language Science Press
    
    EXCLUDES: legitimate proper nouns which should be excluded nevertheless since they are homographs with common words, e.g. the language "Some". 

"""

CONTINENTNAMES=["""Africa""",
"""Asia""",
"""America""",
"""Australia""",
"""Europe""",
"""African""",
"""Asian""",
"""American""",
"""Australian""",
  ]

OCEANNAMES=["""Atlantic Ocean""",
"""Pacific Ocean""",
"""Indian Ocean""",
"""Atlantic""",
"""Pacific""",
"""Mediterranean"""
  ]

CITIES = [
  """Cambridge""",
  """Oxford""",
  """London""",
  """New York""",
  """Chicago""",
  """Berkeley""",
  """Paris"""  
  ]

COUNTRIES=[
"""Afghanistan""",
"""Albania""",
"""Algeria""",
"""Andorra""",
"""Angola""",
"""Antigua""",
"""Barbuda""",
"""Argentina""",
"""Armenia""",
"""Aruba""",
"""Australia""",
"""Austria""",
"""Azerbaijan""",
"""Bahamas""",
"""Bahrain""",
"""Bangladesh""",
"""Barbados""",
"""Belarus""",
"""Belgium""",
"""Belize""",
"""Benin""",
"""Bermuda""",
"""Bhutan""",
"""Bolivia""",
"""Bosnia""",
"""Herzegovina""",
"""Botswana""",
"""Brazil""",
"""Brunei""",
"""Bulgaria""",
"""Burkina Faso""",
"""Upper Volta""",
"""Myanmar""",
"""Burma""",
"""Burundi""",
"""Cambodia""",
"""Cameroon""",
"""Canada""",
"""Cape Verde""",
"""Central African Republic""",
"""Chad""",
"""Chile""",
"""China""",
"""Colombia""",
"""Comoros""",
"""Congo""",
"""Costa Rica""",
"""Côte d'Ivoire""",
"""Croatia""",
"""Cuba""",
"""Cyprus""",
"""Czech Republic""",
"""Denmark""",
"""Djibouti""",
"""Dominica""",
"""Dominican Republic""",
"""East Timor""",
"""Ecuador""",
"""Egypt""",
"""El Salvador""",
"""Equatorial Guinea""",
"""Eritrea""",
"""Estonia""",
"""Ethiopia""",
"""Fiji""",
"""Finland""",
"""France""",
"""Faroe Islands""",
"""Gabon""",
"""The Gambia""",
"""Georgia""",
"""Germany""",
"""Ghana""",
"""Greece""",
"""Grenada""",
"""Guatemala""",
"""Guinea""",
"""Guinea-Bissau""",
"""Guyana""",
"""Haiti""",
"""Honduras""",
"""Hungary""",
"""Iceland""",
"""India""",
"""Indonesia""",
"""Iran""",
"""Iraq""",
"""Ireland""",
"""Israel""",
"""Italy""",
"""Ivory Coast""",
"""Côte d'Ivoire""",
"""Jamaica""",
"""Japan""",
"""Jordan""",
"""Kazakhstan""",
"""Kenya""",
"""Kiribati""",
"""Korea""",
"""North Korea""",
"""South Korea""",
"""Kuwait""",
"""Kyrgyzstan""",
"""Laos""",
"""Latvia""",
"""Lebanon""",
"""Lesotho""",
"""Liberia""",
"""Libya""",
"""Liechtenstein""",
"""Lithuania""",
"""Luxembourg""",
"""Republic of Macedonia""",
"""Madagascar""",
"""Malawi""",
"""Malaysia""",
"""Maldives""",
"""Mali""",
"""Malta""",
"""Marshall Islands""",
"""Mauritania""",
"""Mauritius""",
"""Mexico""",
"""Federated States of Micronesia""",
"""Moldova""",
"""Monaco""",
"""Mongolia""",
"""Montenegro""",
"""Morocco""",
"""Mozambique""",
"""Myanmar""",
"""Namibia""",
"""Nauru""",
"""Nepal""",
"""Netherlands""",
"""New Zealand""",
"""Aotearoa""",
"""Nicaragua""",
"""Niger""",
"""Nigeria""",
"""Niue""",
"""North Korea""",
"""Norway""",
"""Oman""",
"""Pakistan""",
"""Palau""",
"""Panama""",
"""Papua New Guinea""",
"""Paraguay""",
"""Peru""",
"""Philippines""",
"""Poland""",
"""Portugal""",
"""Puerto Rico""",
"""Qatar""",
"""Romania""",
"""Russia""",
"""Rwanda""",
"""Saint Kitts""",
"""Nevis""",
"""Saint Lucia""",
"""Saint Vincent""",
"""Grenadines""",
"""Samoa""",
"""San Marino""",
"""São Tomé""",
"""Príncipe""",
"""Saudi Arabia""",
"""Senegal""",
"""Serbia""",
"""Seychelles""",
"""Sierra Leone""",
"""Singapore""",
"""Slovakia""",
"""Slovenia""",
"""Solomon Islands""",
"""Somalia""",
"""South Africa""",
"""South Korea""",
"""South Sudan""",
"""Spain""",
"""Sri Lanka""",
"""Sudan""",
"""Suriname""",
"""Swaziland""",
"""Sweden""",
"""Switzerland""",
"""Syria""",
"""Taiwan""",
"""Republic of China""",
"""Tajikistan""",
"""Tanzania""",
"""Tatarstan""",
"""Thailand""",
"""Tibet""",
"""Togo""",
"""Tonga""",
"""Trinidad""",
"""Tobago""",
"""Tunisia""",
"""Turkey""",
"""Turkmenistan""",
"""Tuvalu""",
"""Uganda""",
"""Ukraine""",
"""United Arab Emirates""",
"""United Kingdom""",
"""United States""",
"""Uruguay""",
"""Uzbekistan""",
"""Vanuatu""",
"""Vatican City """,
"""Holy See""",
"""Venezuela""",
"""Vietnam""",
"""Yemen""",
"""Zaire""",
"""Democratic Republic of the Congo""",
"""Zambia""",
"""Zimbabwe"""
  ]

LANGUAGENAMES=[
"""Algonquian""",
"""Polish""",
"""English""",
"""French""",
"""Spanish""",
"""German""",
"""Dutch""",
"""Japanese""",
"""Aariya""",
"""Adap""",
"""Aduge""",
"""Adzera""",
"""Ahe""",
"""Ahirani""",
"""Aiku""",
"""Alaguilac""",
"""Amapá Creole""",
"""Amerax""",
"""Amikoana""",
"""Ammonite""",
"""Anasi""",
"""Arafundi""",
"""Arakanese""",
"""Arakwal""",
"""Aramanik""",
"""Atuence""",
"""Auvergnat""",
"""Ayi""",
"""Baga Binari""",
"""Baga Kaloum""",
"""Baga Sobané""",
"""Bahau River Kenyah""",
"""Bainouk-Samik""",
"""Bakung Kenyah""",
"""Balau""",
"""Banawá""",
"""Bandjigali""",
"""Belgian Sign Language""",
"""Bemba""",
"""Bengkulu""",
"""Berawan""",
"""Beti""",
"""Bhalay""",
"""Bikaru""",
"""Bisu""",
"""Borna""",
"""Bubia""",
"""Bugan""",
"""Buso""",
"""Buxinhua""",
"""Buya""",
"""Buyang""",
"""Cagua""",
"""Brazilian Calão""",
"""Catalonian Calo""",
"""Portuguese Calão""",
"""Spanish Caló""",
"""Carútana""",
"""Cataelano Mandaya""",
"""Cauca""",
"""Chamari""",
"""Chaungtha""",
"""Chetco""",
"""Chilean Quechua""",
"""Chimakum""",
"""Chipiajes""",
"""Chittagonian""",
"""Chol""",
"""Tila""",
"""Nagrandan""",
"""Nicoya""",
"""Chorotega""",
"""Orisi""",
"""Orotinya""",
"""Chuanqiandian Cluster Miao""",
"""Chuj""",
"""Ixtatán""",
"""Chumash""",
"""Coxima""",
"""Coyaima""",
"""Cumeral""",
"""Darang Deng""",
"""Dayao Yi""",
"""Degaru""",
"""Desiya""",
"""Dhanwar""",
"""Dombe""",
"""Dororo""",
"""Durango Nahuatl""",
"""Eastern Lalu""",
"""Edomite""",
"""Elpaputih""",
"""Emiliano-Romagnolo""",
"""Enim""",
"""Europanto""",
"""Falam Chin""",
"""Foma""",
"""Gabutamon""",
"""Gamo-Gofa-Dawro""",
"""Garreh-Ajuran""",
"""Gascon""",
"""Gbati-ri""",
"""Duoluo""",
"""Hagei""",
"""Qau""",
"""Geman Deng""",
"""Gengle""",
"""Gey""",
"""Gowlan""",
"""Lingaayat""",
"""Nand""",
"""Ranya""",
"""Pindare""",
"""Tembe of Gurupi""",
"""Zutiua""",
"""Gugu Mini""",
"""Guliguli""",
"""Gyalrong""",
"""Hmong Njua""",
"""Horuru""",
"""Huastec""",
"""San Luís Potosí""",
"""Huastec""",
"""Southeastern""",
"""Iapama""",
"""Ibilo""",
"""Idesa""",
"""Ihievbe""",
"""Imeraguen""",
"""Indo-Portuguese""",
"""Inpui Naga""",
"""Ipeka-Tapuia""",
"""Ir""",
"""Itutang""",
"""Ixil""",
"""Chajul""",
"""Ixil""",
"""Nebaj""",
"""Izere""",
"""Jakalteko""",
"""Western""",
"""Jaruára""",
"""Judeo-Berber""",
"""K'iche'""",
"""Cunén""",
"""K'iche'""",
"""Eastern""",
"""K'iche'""",
"""Joyabaj""",
"""K'iche'""",
"""San Andrés""",
"""K'iche'""",
"""West Central""",
"""Kabixí""",
"""Kahayan""",
"""Kahumamahon Saluan""",
"""Kakauhua""",
"""Kakihum""",
"""Kamba""",
"""Kang""",
"""Kannada Kurumba""",
"""Kaqchikel""",
"""Akatenango Southwestern""",
"""Kaqchikel""",
"""Eastern""",
"""Kaqchikel""",
"""Norman""",
"""Kaqchikel""",
"""Santa María de Jesús""",
"""Kaqchikel""",
"""Santo Domingo Xenacoj""",
"""Kaqchikel""",
"""South Central""",
"""Kaqchikel""",
"""Southern""",
"""Kaqchikel""",
"""Western""",
"""Kaqchikel""",
"""Yepocapa Southwestern""",
"""Karipuna""",
"""Karon Dori""",
"""Katingan""",
"""Kayan River Kenyah""",
"""Kayort""",
"""Kayu Agung""",
"""Kela""",
"""Khalaj""",
"""Khao""",
"""Khiamniungan Naga""",
"""Khlor""",
"""Khua""",
"""Khuai""",
"""Khumi Awa Chin""",
"""Kiorr""",
"""Kisankasa""",
"""Kofa""",
"""Kohoroxitari""",
"""Kolum So Dogon""",
"""Kon Keu""",
"""Kpatili""",
"""Krui""",
"""Kuanhua""",
"""Kuku-Mangk""",
"""Kukura""",
"""Kunfal""",
"""Kunggara""",
"""Kwak""",
"""Laba""",
"""Lachirioag Zapotec""",
"""Lahta Karen""",
"""Lahu Shi""",
"""Lalia""",
"""Lama""",
"""Lamam""",
"""Lambichhong""",
"""Land Dayak""",
"""Lang'e""",
"""Languedocien""",
"""Laopang""",
"""Laos Sign Language""",
"""Laura""",
"""Lematang""",
"""Lenca""",
"""Limousin""",
"""Lingkhim""",
"""Lintang""",
"""Loarki""",
"""Lonzo""",
"""Lopi""",
"""Lower Pokomo""",
"""Lui""",
"""Lumba-Yakkha""",
"""Madang""",
"""Mahakam Kenyah""",
"""Mahei""",
"""Malakhel""",
"""Malay""",
"""Maligo""",
"""Malinguat""",
"""Mam""",
"""Central""",
"""Mam""",
"""Southern""",
"""Mam""",
"""Tajumulco""",
"""Mam""",
"""Todos Santos Cuchumatán""",
"""Maramba""",
"""Maskoy Pidgin""",
"""Mawayana""",
"""Maya""",
"""Chan Santa Cruz""",
"""Mea""",
"""Mediak""",
"""Mengisa""",
"""Mimi""",
"""Mina""",
"""Mirgan""",
"""Moabite""",
"""Moinba""",
"""Muji Yi""",
"""Muko-Muko""",
"""Munda""",
"""Mundari""",
"""N'Ko""",
"""Natagaimas""",
"""Natügu""",
"""Navarro-Labourdin Basque""",
"""Naxi""",
"""Ndonde Hamba""",
"""Ngombe""",
"""Ngong""",
"""Bangni""",
"""Nishang""",
"""Tagin""",
"""Nocamán""",
"""Nootka""",
"""Kizolo""",
"""Nora""",
"""North Korowai""",
"""Northern Nambikuára""",
"""Northern Zhuang""",
"""Northwestern Tamang""",
"""Norwegian Bokmål""",
"""Nyadu""",
"""Nyeng""",
"""Occidental""",
"""Odut""",
"""Ogan""",
"""Old Indic""",
"""Old Persian""",
"""Old Turkish""",
"""Omati""",
"""Omejes""",
"""Ontenu""",
"""Orokaiva""",
"""Oropom""",
"""Palembang""",
"""Palu""",
"""Pamona""",
"""Panang""",
"""Pao""",
"""Parsi""",
"""Parsi-Dari""",
"""Patla-Chicontla Totonac""",
"""Pelende""",
"""Penesak""",
"""Phangduwali""",
"""Piru""",
"""Pokangá""",
"""Ponares""",
"""Pongyong""",
"""Poqomam""",
"""Eastern""",
"""Poqomam""",
"""Southern""",
"""Poqomchi'""",
"""Western""",
"""Potiguára""",
"""Provençal""",
"""Pu Ko""",
"""Pubian""",
"""Puimei Naga""",
"""Pula Yi""",
"""Punan Merap""",
"""Purum Naga""",
"""Pa Kembaloh""",
"""Puwa Yi""",
"""Quetzaltepec Mixe""",
"""Rajbanshi""",
"""Ranau""",
"""Rawas""",
"""Rufiji""",
"""Sakan""",
"""Sangab Mandaya""",
"""Sansu""",
"""Sara Dunjo""",
"""Sarawak Bisaya""",
"""Savara""",
"""Selako""",
"""Semendo""",
"""Serawai""",
"""Seru""",
"""Shakara""",
"""Shempire Senoufo""",
"""Shuadit""",
"""Silt'e""",
"""Sindang Kelingi""",
"""Singapore Sign Language""",
"""Sizaki""",
"""Skagit""",
"""Snohomish""",
"""Songa""",
"""Souletin Basque""",
"""South Ucayali Ashéninka""",
"""South Wemale""",
"""Southeastern Puebla Nahuatl""",
"""Southern Betsimisaraka Malagasy""",
"""Southern Lolopo""",
"""Southern Marakwet""",
"""Southern Pesisir""",
"""Southern Zhuang""",
"""Southwest Gbaya""",
"""Southwestern Nisu""",
"""Southwestern Tamang""",
"""Suba""",
"""Subi""",
"""Kukra""",
"""Nicaraguan Tawahka""",
"""Panamahka""",
"""Ulwa""",
"""Sungkai""",
"""Jaun-Jaun""",
"""Naturalis""",
"""Surigaonon""",
"""Syenara Senoufo""",
"""Tacanec""",
"""Taensa""",
"""Tai Pao""",
"""Takpa""",
"""Ilputih""",
"""Ilwaki""",
"""Tangshewi""",
"""Tanjong""",
"""Tapeba""",
"""Tareng""",
"""Tarpia""",
"""Tasmanian""",
"""Tawang Monpa""",
"""Teke-Nzikou""",
"""Tetete""",
"""Thu Lao""",
"""Thudam""",
"""Tingal""",
"""Tingui-Boto""",
"""Tlalitzlipa Nahuatl""",
"""Toala'""",
"""Tobo""",
"""Tomedes""",
"""Tomyang""",
"""Itundu""",
"""Logananga""",
"""Mese""",
"""Ndogbang""",
"""Ndokbiakat""",
"""Ndoktuna""",
"""Ni Nyo'o""",
"""Tupinikin""",
"""Tushan Names""",
"""Tutong 1""",
"""Tz'utujil""",
"""Western""",
"""Tzeltal""",
"""Bachajón""",
"""Tzotzil""",
"""Chamula""",
"""Tzotzil""",
"""Chenalhó""",
"""Tzotzil""",
"""Huixtán""",
"""Tzotzil""",
"""San Andrés Larrainzar""",
"""Tzotzil""",
"""Zinacantán""",
"""Uokha""",
"""Upper Baram Kenyah""",
"""Upper Tanudan Kalinga""",
"""Uradhi""",
"""Vasekela Bushman""",
"""Pak""",
"""Sasar""",
"""Wagawaga""",
"""Walo Kumbe Dogon""",
"""Warduji""",
"""Welaung""",
"""Western Frisian""",
"""Wirangu""",
"""Wumeng Yi""",
"""Xiandao""",
"""Xinca""",
"""Yamongeri""",
"""Sibao-Yamphe""",
"""Yangbye""",
"""Yangho""",
"""Yarsun""",
"""Yarí""",
"""Yauma""",
"""Poli""",
"""Yofo""",
"""Yoti""",
"""Yiddish Sign Language""",
"""Yinglish""",
"""Gorminang""",
"""Jir'jorond""",
"""Yola""",
"""Yos""",
"""Yuanjiang-Mojiang Yi""",
"""Yugh""",
"""Zarphatic""",
"""Kala""",
"""No-Penge""",
"""Miyemu""",
"""Narak""",
"""Eastern Maring""",
"""Kambegl""",
"""Karamba""",
"""Timbunki""",
"""Tsuwenki""",
"""Gomia""",
"""Kebai""",
"""Chuave""",
"""Sua""",
"""Nomane""",
"""Kia""",
"""Marigl""",
"""Golin""",
"""Yuri""",
"""Salt-Yui""",
"""Tabare""",
"""Kuman""",
"""Yongomugi""",
"""Kunjip""",
"""Kup-Minj""",
"""Mid-Wahgi""",
"""Pukamigl-Andegabu""",
"""Sapan""",
"""Misman""",
"""Simai""",
"""Yaosakor Asmat""",
"""Esaun""",
"""Komasma""",
"""Pirabanak""",
"""Senggo""",
"""Tiau""",
"""Vakam""",
"""Diuwe""",
"""Tamnim Citak""",
"""North Asmat""",
"""Tarya""",
"""Yamur""",
"""Kamberau""",
"""Sempan""",
"""Edera Awyu""",
"""Jair Awyu""",
"""Central Awyu""",
"""North Awyu""",
"""South Awyu""",
"""Wambon""",
"""Mandobo Atas""",
"""Mandobo Bawah""",
"""Tayan""",
"""Wanggom""",
"""Sawi""",
"""Tsakwambo""",
"""Tokuni""",
"""Kwer""",
"""Kasuwa""",
"""Toemoetoe""",
"""Yonggom""",
"""Nimtep Weng""",
"""Faiwolmin""",
"""Wopkeimin""",
"""Upper August River""",
"""Suganga""",
"""Setaman""",
"""Telefol""",
"""Tifal""",
"""Urapmin""",
"""Ngalum""",
"""Sibil""",
"""Tangko""",
"""Oksapmin""",
"""Lower Grand Valley Hitigima""",
"""Lower Kimbin""",
"""Upper Bele""",
"""Upper Pyramid""",
"""Mid Grand Valley Dani""",
"""Upper Grand Valley Dani""",
"""Western Dani of Pyramid""",
"""Sinak Nduga""",
"""Ninia Yali""",
"""Landikma""",
"""Pass Valley""",
"""Nggem""",
"""Wano""",
"""Kandepe""",
"""Kapona""",
"""Laiagam""",
"""Lapalama 1""",
"""Lapalama 2""",
"""Layapo""",
"""Mae""",
"""Maramuni""",
"""Sari""",
"""Sau""",
"""Tayato""",
"""Yandapo""",
"""Porgera""",
"""Tipinini""",
"""Kyaka""",
"""Lembena""",
"""Nete""",
"""Nipa""",
"""Waola""",
"""Erave""",
"""West Kewa""",
"""Samberigi""",
"""South Nakama""",
"""West Nek""",
"""South Nuk""",
"""West Numanggang""",
"""Gusan""",
"""Mamaa""",
"""Sauk""",
"""West Urii""",
"""Nekgini""",
"""Neko""",
"""Ngaing""",
"""Rawa""",
"""Ufim""",
"""Som""",
"""Weliki""",
"""Northern Yau""",
"""Central Wantoat""",
"""Wapu""",
"""Yagawak""",
"""Degenan""",
"""Forak""",
"""Guya""",
"""Gwahamere""",
"""Gwapti""",
"""Gwahatike""",
"""Molet""",
"""Muratayak""",
"""Yagomi""",
"""Kewieng""",
"""Nokopo""",
"""Wandabong""",
"""Nankina""",
"""Yout Wam""",
"""Fanic""",
"""Parec""",
"""Wamora""",
"""Wana""",
"""Wemo""",
"""Naga""",
"""Nigac""",
"""Mape""",
"""Sene""",
"""Kovai""",
"""Yoangen""",
"""North Migabac""",
"""South Migabac""",
"""Momare""",
"""Kumukio""",
"""Yangeborong""",
"""Somba""",
"""West-Central Mese""",
"""Zezagi""",
"""Nabak""",
"""Nomu""",
"""Ziwe""",
"""Sialum""",
"""Central Komba""",
"""East Komba""",
"""West Central Komba""",
"""West Komba""",
"""South Selepet""",
"""North Timbe""",
"""South Timbe""",
"""Zia""",
"""Ambasi""",
"""Binandere Proper""",
"""Mado""",
"""Baruga""",
"""Tafota Baruga""",
"""Doghoro""",
"""Yega""",
"""Gaina""",
"""Hunjara-Kaina Ke""",
"""Orokaiva""",
"""Yekora""",
"""Isabi""",
"""Pamusa""",
"""West Gimi""",
"""Bohena""",
"""Kongi""",
"""Lunube Mado""",
"""Upper Asaro""",
"""Zuhuzuho""",
"""Inoke-Yate""",
"""Kamano""",
"""Kanite""",
"""Keyagana""",
"""Hira""",
"""Hua""",
"""Kamate""",
"""Kami-Kulaka""",
"""Kotom""",
"""Move""",
"""Ologuti""",
"""Fowe""",
"""Kemanimowe""",
"""Keto""",
"""Kolepa""",
"""Komoigaleka""",
"""Komongu""",
"""Laiya""",
"""Lambau""",
"""Olumba""",
"""Ona""",
"""Wando""",
"""Yamofowe""",
"""Yandime""",
"""Yaweyuha""",
"""Kosena""",
"""Usarufa""",
"""Northeast Awa""",
"""South Awa""",
"""Tauna""",
"""Owenia""",
"""Oyana""",
"""Kambaira""",
"""Arau-Varosia""",
"""Arokaara""",
"""Saiqora""",
"""Tairora""",
"""Haaviqinra-Oraura""",
"""Omwunra-Toqura""",
"""Vaira-Ntosara""",
"""Veqaura""",
"""Vinaata-Konkompira""",
"""Waffa""",
"""Kenati""",
"""Malas""",
"""Brem""",
"""Mauwake""",
"""Moere""",
"""Musar""",
"""Huar""",
"""Jagahala""",
"""Bau""",
"""Gumalu""",
"""Isebe""",
"""Urukun""",
"""Panim""",
"""Sihan""",
"""Baimak""",
"""Gal""",
"""Garus""",
"""Matepi""",
"""Mawan""",
"""Nake""",
"""Rapting""",
"""Rempi""",
"""Saruga""",
"""Utu""",
"""Wagi""",
"""Murupi""",
"""Samosa""",
"""Wamas""",
"""Yoidik""",
"""Kare""",
"""Kein""",
"""Munit""",
"""Maiani""",
"""Mala""",
"""Miani""",
"""Yaben""",
"""Ukuriguma""",
"""Yarawata""",
"""Pal""",
"""Mawak""",
"""Pamosu""",
"""Wanambre""",
"""Tai""",
"""Kobon""",
"""Anamgura""",
"""Moresada""",
"""Utarmbung""",
"""Wadaginam""",
"""Nend""",
"""Aki""",
"""Paynamar""",
"""Sileibi""",
"""Gants""",
"""Musak""",
"""Dumpu""",
"""Sausi""",
"""Kolom""",
"""Lemio""",
"""Pulabu""",
"""Siroi""",
"""Bongu""",
"""Male""",
"""Sam""",
"""Jilim""",
"""Kwato""",
"""Ogea""",
"""Rerau""",
"""Uya""",
"""Yangulam""",
"""Sop""",
"""Sumau""",
"""Urigina""",
"""Tauya""",
"""Wasembo""",
"""Dumun""",
"""Ganglau""",
"""Saep""",
"""Yabong""",
"""Waskia""",
"""Okbap""",
"""Omban""",
"""Onya""",
"""Una""",
"""Deibula""",
"""Korupun""",
"""Sela""",
"""Sisibna""",
"""Kosarek""",
"""Tiple""",
"""Nalca""",
"""Nipsan""",
"""Dao""",
"""Mee""",
"""Simori""",
"""Yabi""",
"""Wolani""",
"""Abun Ji""",
"""Abun Tat""",
"""Cheju Island""",
"""Chollado""",
"""Hamgyongdo""",
"""Hwanghaedo""",
"""Kyongsangdo""",
"""P'yong'ando""",
"""Seoul""",
"""Porome""",
"""Pele""",
"""Hruso""",
"""Namome""",
"""Alto Navarro Septentrional""",
"""Avalan""",
"""Labourdin""",
"""Western Low Navarrese""",
"""Basque""",
"""Souletin""",
"""Biscayan""",
"""Guipuzcoan""",
"""Roncalese""",
"""Fly River""",
"""Kandoashi""",
"""Sui""",
"""Hauruha""",
"""Bou""",
"""Daminyu""",
"""Jaru""",
"""Jinjo""",
"""Wulanga""",
"""Barka""",
"""Bitama""",
"""Ilit""",
"""Marda""",
"""Sokodasa""",
"""Takazze-Setiit""",
"""Tigray""",
"""Tika""",
"""Koyta""",
"""Mogareb""",
"""Santora""",
"""Maisawiet""",
"""Maisefa""",
"""Maite""",
"""Maiyah""",
"""Sirir""",
"""Dakunza""",
"""Dekoka""",
"""Dewiya""",
"""Disoha""",
"""Gombo""",
"""Guba""",
"""Jemhwa""",
"""Kukwaya""",
"""Mandura""",
"""Metemma""",
"""Modea""",
"""Sai""",
"""Sese""",
"""Sirba""",
"""Wenbera""",
"""Yaso""",
"""Dabuso""",
"""Fadashi""",
"""Gobato""",
"""Mayu""",
"""Shuru""",
"""Undu""",
"""Santa Rosa""",
"""San Ignacio de Velazco""",
"""San Javier""",
"""San Miguel""",
"""Santiago""",
"""Münkü""",
"""East Sakhalin Gilyak""",
"""North Sakhalin Gilyak""",
"""Pitayo""",
"""Amung""",
"""Enggipilu""",
"""Damal""",
"""Yatê""",
"""Soloto""",
"""Kipea""",
"""Miluk""",
"""Sipisi""",
"""Sauri""",
"""Gesda Dae""",
"""Neao""",
"""Tunggare""",
"""Demisa""",
"""Nisa""",
"""Tefaro""",
"""Woria""",
"""Tualatin-Yamhill""",
"""Yoncalla""",
"""Gros Ventre""",
"""Nawathinehena""",
"""Cheyenne""",
"""Northern East Cree""",
"""Plains Cree""",
"""Western York Cree""",
"""Southern East Cree""",
"""Western Swampy Cree""",
"""Woods Cree""",
"""Western Montagnais""",
"""Western Naskapi""",
"""Unami""",
"""Mahican""",
"""Loup A""",
"""Passamaquoddy""",
"""Southern Micmac""",
"""Narrangansett""",
"""Pequot-Mohegan""",
"""Stockbridge""",
"""Piscataway""",
"""Powhatan""",
"""Wampano""",
"""Wampanoag""",
"""Western Abenaki""",
"""Meskwakie""",
"""Sac""",
"""Peoria""",
"""Minnesota Border Chippewa""",
"""Red Lake Chippewa""",
"""Turtle Mountain Chippewa""",
"""Upper Michigan-Wisconsin Chippewa""",
"""Eastern Ojibwa""",
"""Berens River Ojibwa""",
"""Lac Seul Ojibwa""",
"""Lake of the Woods Ojibwa""",
"""Rainy River Ojibwa""",
"""Western Ojibwa""",
"""Ottawa""",
"""Winisk River Ojibwa""",
"""Potawatomi""",
"""Shawnee""",
"""Menominee""",
"""Piegan""",
"""Wiyot""",
"""Yurok""",
"""Narau""",
"""Murkim""",
"""Barka""",
"""Lebir""",
"""Lere""",
"""Village Bokobaru""",
"""New Busa""",
"""Wawa""",
"""Shanga""",
"""Bounou""",
"""Gomboro""",
"""Kiembara""",
"""Gweetaawu""",
"""Lower Gio""",
"""River Cess Gio""",
"""Upper Gio""",
"""Guse""",
"""Gwéò""",
"""Naò""",
"""Wáádú""",
"""Yiligele""",
"""Klan""",
"""Taan""",
"""Yaan""",
"""Yoo""",
"""Mann""",
"""Ngen""",
"""Bokwa""",
"""N'da""",
"""Tuka""",
"""Gbin""",
"""Miamu""",
"""Jeli""",
"""Bungase""",
"""Dwera""",
"""Gyogo""",
"""Hwela""",
"""Ntoleh""",
"""Tonjon""",
"""Ganadugu""",
"""San""",
"""Segou""",
"""Sikasso""",
"""Somono""",
"""Standard Bambara""",
"""Wasulu""",
"""White Bolon""",
"""Kong Jula""",
"""Tagboussikan""",
"""Bö""",
"""Koulounkalan""",
"""Maninka-Mori""",
"""Wasulu""",
"""Konyanka Maninka""",
"""Manya""",
"""Sankaran Maninka""",
"""Koyaga""",
"""Sagaka""",
"""Siaka""",
"""Finanga""",
"""Koroka""",
"""Mahouka""",
"""Tenenga""",
"""Nafana""",
"""Odienneka""",
"""Sienkoka""",
"""Toudougouka""",
"""Vandougouka""",
"""Wasulu""",
"""Karanjan""",
"""Worodougouka""",
"""Nouna""",
"""Safané""",
"""Mandinka""",
"""Kenieba Maninka""",
"""Nyoxolonkan""",
"""Xaasongaxango""",
"""Mankaliya""",
"""Mongo""",
"""Ney""",
"""Nieni""",
"""Sambaya""",
"""Sengbe""",
"""Kounte Lele""",
"""Tangalto Lele""",
"""Yombiro Lele""",
"""Mixifore""",
"""Northern Kono""",
"""Vai""",
"""Musaia""",
"""Sulima""",
"""Kono""",
"""Liberia Kpelle""",
"""Bunde""",
"""Gizima""",
"""Wubomei""",
"""Ziema""",
"""Toma""",
"""Hembeh""",
"""Lukasa""",
"""Tahamba""",
"""Wawana""",
"""Wulukoha""",
"""Zialo""",
"""Gbendembu""",
"""Koya""",
"""Laia""",
"""Libisegahun""",
"""Magbiambo""",
"""Nagbanmba""",
"""Ngoahu""",
"""Ribbi""",
"""Sanda""",
"""Kpa""",
"""Sewawa""",
"""Waanjama""",
"""Jèrè""",
"""Kukoma""",
"""Kure""",
"""Sankuma""",
"""Sogokiri""",
"""Sya""",
"""Tankri""",
"""Vore""",
"""Yaba""",
"""Sogokiré""",
"""Syabéré""",
"""Voré""",
"""Zara""",
"""Duungooma""",
"""Kpango""",
"""Kpeego""",
"""Southern Seeku""",
"""Korondougou""",
"""Kotya""",
"""Pondori""",
"""Tiéyaxo Bozo""",
"""Gadyaga""",
"""Kinbakka""",
"""Xenqenna""",
"""Wapi""",
"""Beli""",
"""Sinagen""",
"""Gnau""",
"""Timingir""",
"""Urita""",
"""Weril""",
"""Werir""",
"""Bukiyip""",
"""Filifita""",
"""Iwam-Nagalemb""",
"""Nagipaem""",
"""Supari""",
"""South Kombio""",
"""West-Central Kombio""",
"""West Torricelli""",
"""West Yambes""",
"""Wasep Yam""",
"""Wusyep Tep""",
"""Wusyep Yehre""",
"""Laeko-Libuat""",
"""Masan""",
"""Bungain""",
"""Hagi""",
"""Segi""",
"""Urimo""",
"""Wiarumus""",
"""Minidien""",
"""Nabi""",
"""Yil""",
"""Yahang""",
"""Siliput""",
"""Aruop""",
"""Bragat""",
"""Yangum Gel""",
"""Yangum Mon""",
"""Yangkolen""",
"""Wanap""",
"""Yeri""",
"""Walman""",
"""Kabore One""",
"""North Aunalei""",
"""South Aunalei""",
"""Northern One""",
"""Kwamtim One""",
"""Southern One""",
"""Seta""",
"""Seti""",
"""Wom""",
"""Yis""",
"""Andegerebinha""",
"""Western Anmatyerre""",
"""Antekerrepenh""",
"""Ikngerripenhe""",
"""Mparntwe Arrernte""",
"""Kaytetye""",
"""Lower Southern Aranda""",
"""Banggarla""",
"""Guyani""",
"""Turra""",
"""Ngadjuri""",
"""Nugunu""",
"""Wirangu""",
"""Nangu""",
"""Nawurtu""",
"""Mangala""",
"""Southern inland Nyangumarta""",
"""Hansen River Warlpiri""",
"""Lander River Warlpiri""",
"""North-western Warlpiri""",
"""South-western Warlpiri""",
"""Southern Warlpiri""",
"""Western Warlpiri""",
"""Wanyjirra""",
"""Mudbura""",
"""Eastern Ngarinman""",
"""Wurlayi""",
"""Nyininy""",
"""Ngardi""",
"""Warumungu""",
"""Manyjilyjara""",
"""Puditara""",
"""Wangkajunga""",
"""Yulparitja""",
"""Wanman""",
"""Yulparija""",
"""Yankunytjatjara""",
"""Yankunytjatjara""",
"""Kokata""",
"""Pini""",
"""Girramy""",
"""Gulnguy""",
"""Mamu""",
"""Ngadjan""",
"""Yugambal""",
"""Yalarnnga""",
"""Ganai""",
"""Yanda""",
"""Gangulu""",
"""Giya""",
"""Warungu""",
"""Gungabula""",
"""Guwamu""",
"""Kunggari""",
"""Mandandanyi""",
"""Margany""",
"""Wadjigu""",
"""Yirandhali""",
"""Bindal-Gorton""",
"""Bindal-Mount Elliot""",
"""Gugu Warra""",
"""Mithaka""",
"""Dirari""",
"""Ngamini""",
"""Pirlatapa""",
"""Yawarawarga""",
"""Bidjara""",
"""Dhiraila""",
"""Garandala""",
"""Kalali""",
"""Mambangura""",
"""Mingbari""",
"""Ngurawarla""",
"""Punthamara""",
"""Wongkumara""",
"""Yarumarra""",
"""Wangganguru""",
"""Wanggamala""",
"""Pirriya""",
"""Nganyaywana""",
"""Yindjilandji""",
"""Warluwara""",
"""Yanyuwa""",
"""Wulguru""",
"""Yuru""",
"""Kuuku-Ya'u""",
"""Umpila""",
"""Umbindhamu""",
"""Pakanha""",
"""Flinders Island""",
"""Kuku-Muminh""",
"""Kuku-Ugbanh""",
"""Kuku-Uwanh""",
"""Wik-Iiyanh""",
"""Wik-Mungkan""",
"""Wik-Epa""",
"""Wik-Me'anha""",
"""Wik-Ngandjara""",
"""Wikngenchera""",
"""Wamin""",
"""Gugadj""",
"""Mbariman-Gudhinma""",
"""Umbuygamu""",
"""Ngawun""",
"""Mbara""",
"""Gurdjar""",
"""Walangama""",
"""Aritinngitigh""",
"""Gudang""",
"""Leningitij""",
"""Mbiywom""",
"""Mpalityan-Lutigh""",
"""Ngkot""",
"""Tyanngayt-Mamngayt-Ntrwangayt-Ntrangit""",
"""Atampaya""",
"""Yadhaykenu""",
"""Wuthathi""",
"""Yinwum""",
"""Ikaranggal""",
"""Thaypan""",
"""Koko Dhawa""",
"""Yir-Yoront""",
"""Tagalaka""",
"""Kawarrang-Ogh Undjan""",
"""Oykangand""",
"""Ulkulu""",
"""Kuuk-Yak""",
"""Thayore""",
"""Dharumbal""",
"""Malgana""",
"""Wajarri""",
"""Nhanda""",
"""Kalarko""",
"""Ngadjunmaya""",
"""Pinigura""",
"""Dhalandji""",
"""Thiin""",
"""Wariyangga""",
"""Jaburarra""",
"""West Ngarluma""",
"""Nijadali""",
"""Pantikura""",
"""Tjurruru""",
"""Yindjibarndi""",
"""Nhuwala""",
"""Nyamal""",
"""Southern Inggarda""",
"""Yugumbir""",
"""Guwar""",
"""Muruwari""",
"""Cameeragal""",
"""Wonarua""",
"""Worimi""",
"""Sydney""",
"""Northern Inland Yuin""",
"""Southern Coastal Yuin""",
"""Southern Inland Yuin""",
"""Yaygir""",
"""Kabikabi""",
"""Wagawaga""",
"""Wuliwuli""",
"""Pallanganmiddang""",
"""Yorta Yorta""",
"""Western Victoria""",
"""Woiwurrung""",
"""Warrnambool""",
"""Upper Riverland""",
"""Narrinyeri""",
"""Northern Sunraysia""",
"""Guyinbaraay""",
"""Waalaraay""",
"""Wirriyaraay""",
"""Yuwaalaraay""",
"""Yuwaalayaay""",
"""Wangaaybuwan""",
"""Wayilwan""",
"""Wiradhuri""",
"""Warrgamay""",
"""Kula""",
"""Wiljakali""",
"""Yarli""",
"""Kuku-Nyungkul""",
"""Muluridyi""",
"""Njakali""",
"""Dyaabugay""",
"""Madyay""",
"""Yidiny""",
"""Djarrwark""",
"""Gaalpu""",
"""Golumala""",
"""Ngaymil""",
"""Rirratjingu""",
"""Wangurri""",
"""Manggalili""",
"""Munyuku""",
"""Gupapuyngu""",
"""Walangu""",
"""Wubulkarra""",
"""Dhuwaya""",
"""Djapu""",
"""Liyagalawumirr""",
"""Liyagawumirr""",
"""Marrakulu""",
"""Marrangu""",
"""Dhuwal""",
"""Djadiwitjibi""",
"""Manyarring""",
"""Mildjingi""",
"""Murrungun""",
"""Wulaki""",
"""Ganalbingu""",
"""Mandjalpingu""",
"""Gurjindi""",
"""Rongba""",
"""Rongmahbrogpa""",
"""Rtahu""",
"""Southern Baima""",
"""Western Baima""",
"""Zhongu""",
"""Hbrugchu""",
"""Jone""",
"""Northern Khams""",
"""Southern Khams""",
"""Western Khams""",
"""Tseku""",
"""Nubra Ladakhi""",
"""Shamma""",
"""Purik""",
"""Zangskari""",
"""Spiti Bhoti""",
"""Mayar""",
"""Stod""",
"""Tukpa""",
"""Tichurong""",
"""Humla""",
"""Namrung""",
"""Prok""",
"""Sama""",
"""Tsum""",
"""Western Helambu Sherpa""",
"""Kagate""",
"""Lhomi""",
"""Upper Mustang""",
"""Mugali""",
"""Ramechap""",
"""Solu""",
"""Walungge""",
"""Brokpake""",
"""Upper Groma""",
"""Northern Thimphu""",
"""Wang-The""",
"""Layakha""",
"""Lunanakha""",
"""Sikkimese""",
"""Lakha""",
"""Dartsemdo""",
"""Dbus""",
"""Dru""",
"""Gtsang""",
"""Hanniu""",
"""Jad""",
"""Kongbo""",
"""Marchha""",
"""Mngahris""",
"""Nganshuenkuan""",
"""Panakha-Panags""",
"""Paurong""",
"""Takpa""",
"""Utsang""",
"""Chunmat""",
"""Tang""",
"""Ura""",
"""Nupbikha""",
"""Middle Kheng""",
"""Upper Kheng""",
"""Kurtokha""",
"""Chalikha""",
"""Phobjikha""",
"""Olekha""",
"""Tshangla""",
"""Chak""",
"""Rana""",
"""Khorla""",
"""Nyak""",
"""Philim""",
"""Uiya""",
"""Kyaura""",
"""Laprak""",
"""Lamjung Gurung""",
"""Tamu Kyi""",
"""Southern Gurung""",
"""Phu""",
"""Syang""",
"""Tukche""",
"""Kerounja""",
"""Outer-Eastern Tamang""",
"""Rasuwa""",
"""Southwestern""",
"""Trisuli""",
"""Tangbe""",
"""Tetang""",
"""Kaike""",
"""Tolchha""",
"""Sunam""",
"""Zhangzhung""",
"""Pangjungkho Boli""",
"""Yerjungkhu Boli""",
"""Darma""",
"""Rangkas""",
"""Kanashi""",
"""Kinnauri""",
"""Shumcho""",
"""Chamba-Lahuli""",
"""Eastern Pattani""",
"""Tinani""",
"""Mech""",
"""Dimasa""",
"""Kachari""",
"""Halam""",
"""Jamatia""",
"""Noatia""",
"""Riang""",
"""Riang""",
"""Tippera""",
"""Usui""",
"""Tiwa""",
"""Deori""",
"""A'chick""",
"""A'we""",
"""Abeng""",
"""Achik""",
"""Chisak""",
"""Dacca""",
"""Ganching""",
"""Kamrup""",
"""Matchi""",
"""Harigaya""",
"""Satpariya""",
"""Tintekiya""",
"""Wanang""",
"""Rangdania""",
"""Ruga""",
"""Chairel""",
"""Dzili""",
"""Enkun""",
"""Hkaku""",
"""Kauri""",
"""Shidan""",
"""Singpho""",
"""Taman""",
"""Sengmai""",
"""Burma Pyu""",
"""Chak""",
"""Chakpa""",
"""Ganaan""",
"""Kadu""",
"""Phayeng""",
"""Sengmai""",
"""Makyan Naga""",
"""Changnyu""",
"""Chen""",
"""Chingkao""",
"""Chinglang""",
"""Choha""",
"""Gelekidoria""",
"""Hopao""",
"""Jakphang""",
"""Kongon""",
"""Longching""",
"""Longkhai""",
"""Longmein""",
"""Longwa""",
"""Mohung""",
"""Mon""",
"""Mulung""",
"""Ngangching""",
"""Sang""",
"""Shamnyuyanga""",
"""Shanlang""",
"""Shengha""",
"""Shunyuo""",
"""Sima""",
"""Sowa""",
"""Tableng""",
"""Tabu""",
"""Tamkhungnyuo""",
"""Tang""",
"""Tobunyuo""",
"""Tolamleinyua""",
"""Totok""",
"""Changnoi""",
"""Horu Muthun""",
"""Kulung Muthun""",
"""Laju""",
"""Ponthai""",
"""Have""",
"""Higsho""",
"""Higtsii""",
"""Hkaluk""",
"""Kimsin""",
"""Langshin""",
"""Longphi""",
"""Longri""",
"""Lungchang""",
"""Lungri""",
"""Mawrang""",
"""Miti""",
"""Moklum""",
"""Mosang""",
"""Mungray""",
"""Myimu""",
"""Ngemu""",
"""Ponthai""",
"""Rongrang""",
"""Ronrang""",
"""Sangche""",
"""Sangtai""",
"""Sangwal""",
"""Sanke""",
"""Saukrang""",
"""Taipi""",
"""Tikhak""",
"""Tonglim""",
"""Tulim""",
"""Yogli""",
"""Yongkuk""",
"""Tutsa Naga""",
"""Longchuan""",
"""Luxi""",
"""Maingtha""",
"""Lashi""",
"""Zaiwa""",
"""Polo""",
"""South Hpon""",
"""Gawan Naw'""",
"""Hlo'lan""",
"""Laking""",
"""Lawng Hsu""",
"""Wa Khawk""",
"""Zagaran Mran""",
"""Pela""",
"""Rakhine""",
"""Danu""",
"""Merguese""",
"""Palaw""",
"""Yaw""",
"""Old Burmese""",
"""Tavoyan""",
"""Taungyo""",
"""Laomian""",
"""Pyen""",
"""Hwethom""",
"""Khaskhong""",
"""Mung""",
"""White Khoany""",
"""Sangkong""",
"""Cosao""",
"""Enu""",
"""Kaduo""",
"""Mpi""",
"""Asong""",
"""Chepya""",
"""Muda""",
"""Haohai""",
"""Haya""",
"""Phana'""",
"""Sila""",
"""Youle Jinuo""",
"""Na""",
"""Nyi""",
"""Shehleh""",
"""Lahu Shi""",
"""Samatao""",
"""Miqie""",
"""Shuangbo Lolopho""",
"""Yao'an Lolopho""",
"""Kuamasi""",
"""Sonaga""",
"""Xishanba Lalo""",
"""Dongshanba Lalo""",
"""Xuzhang Lalo""",
"""Southern Lalo""",
"""Yangliu""",
"""Talu""",
"""Hua Lisu""",
"""Hwa Lisu""",
"""Lu Shi Lisu""",
"""Pai Lisu""",
"""White Lisu""",
"""Tanglang""",
"""Lamu""",
"""Lawu""",
"""Limi""",
"""Mili""",
"""Naluo Yi""",
"""Samatu""",
"""Phuma""",
"""Muzi""",
"""Southern Muji""",
"""Qila Muji""",
"""Thopho""",
"""Moji""",
"""Labo Phowa""",
"""Zokhuo""",
"""Phukha""",
"""Nisi""",
"""Xinping Nisu""",
"""Southern Nisu""",
"""Nyisu""",
"""Southern Awu Yi""",
"""Samei""",
"""Sanie""",
"""Chesu""",
"""Wuding Naisu""",
"""Hezhang Yi""",
"""Weining Yi""",
"""Dafang""",
"""Qian Xi""",
"""Huili Yi""",
"""Yinuo Yi""",
"""Yishengzha Yi""",
"""Phuza""",
"""Phupha""",
"""Phola""",
"""Southern Sani""",
"""Azhe""",
"""Northern Nusu""",
"""Southern Nusu""",
"""Wupijiang""",
"""Pholo""",
"""Sadu""",
"""Mango""",
"""Mantsi""",
"""Maza""",
"""Mondzi""",
"""Muangphe""",
"""Pai-lang""",
"""Suphanburi""",
"""Lisu""",
"""Ersu""",
"""Lizu""",
"""Tosu""",
"""Guiqiong""",
"""Narua""",
"""Lichiang""",
"""Lutien""",
"""Western Namuyi""",
"""Shixing""",
"""Western Muya""",
"""Luhua""",
"""Weigu""",
"""Yadu""",
"""Heihu""",
"""Jiaochang""",
"""Longxi""",
"""Mianchi""",
"""Sanlong""",
"""Taoping""",
"""Queyu""",
"""Tshobdun""",
"""Lixian""",
"""Maerkang""",
"""Xiaojin""",
"""Rtau""",
"""Puxi""",
"""Zongke""",
"""Ergali""",
"""Guanyingqiao""",
"""Muerzong""",
"""Siyaowu""",
"""Taiyanghe""",
"""Xiaoyili""",
"""Yelong""",
"""Tangut""",
"""Zhaba""",
"""Western Dhimal""",
"""Toto""",
"""Zakhring""",
"""Gongduk""",
"""Rengjongmu""",
"""Tamsangmu""",
"""Lhokpu""",
"""Western Chepang""",
"""Tamali""",
"""Takale""",
"""Thabanggi""",
"""Wale""",
"""Tapnanggi""",
"""Western Magar""",
"""Khambu""",
"""Mahakulung""",
"""Namlung""",
"""Pelmung""",
"""Pidisoi""",
"""Sotang""",
"""Tamachhang""",
"""Dimali""",
"""Hedangpa""",
"""Kharlali""",
"""Parali""",
"""Rakheli""",
"""Sambya""",
"""Halumbung""",
"""Khartamche""",
"""Khotang""",
"""Phali""",
"""Samarung""",
"""Tana""",
"""Tongeccha""",
"""Southern Bantawa""",
"""Western Bantawa""",
"""Waling""",
"""Camling""",
"""Puma""",
"""Belhariya""",
"""Chhulung""",
"""Chintang""",
"""Northern Yakha""",
"""Southern Yakha""",
"""Mulgaon-Wangtang""",
"""Sunsari""",
"""Bumdemba""",
"""Panthare""",
"""Phedappe""",
"""Taplejunge""",
"""Madhavpur""",
"""Ratnawati""",
"""Ubu""",
"""Dobo Lo""",
"""Khaling""",
"""Namber Sacha""",
"""Proca Lo""",
"""Rokhung""",
"""Wayu""",
"""Eastern Thulung""",
"""Lannachyo""",
"""Northern Thulung""",
"""Southern Thulung""",
"""Dorunkecha""",
"""Kharbari""",
"""Lamdija""",
"""Makpa""",
"""Khaling""",
"""Sungdel""",
"""Baktapur""",
"""Citlang""",
"""Dolkhali""",
"""Kathmandu-Pathan-Kirtipur""",
"""Sindhupalchok Pahri""",
"""Totali""",
"""Sindhupalcok""",
"""Western Thami""",
"""Geba Karen""",
"""Geko Karen""",
"""Western Kayah""",
"""Manumanaw Karen""",
"""Yinbaw Karen""",
"""Yintale Karen""",
"""Zayein Karen""",
"""Southern Pa'o""",
"""Kawkareik""",
"""Pa'an""",
"""Ratchaburi Pwo Karen""",
"""Tavoy""",
"""Tuan Tet""",
"""Mae Sarieng""",
"""Omkoi""",
"""Dermuha""",
"""Panapu""",
"""Wewaw""",
"""Lish""",
"""Sherdukpen""",
"""Bualkhaw Chin""",
"""Falam Chin""",
"""Shonshe""",
"""Zokhua""",
"""Hmar""",
"""Sakechep""",
"""Thangkachep""",
"""Le""",
"""Mizo""",
"""Ngente""",
"""Ralte""",
"""Tlau""",
"""Pankhu""",
"""Tawr Chin""",
"""Tlongsai""",
"""Shendu""",
"""Upper Zyphe""",
"""Senthang Chin""",
"""Zotung Chin""",
"""Syriem""",
"""Mulsom""",
"""Chiru""",
"""Chothe Naga""",
"""Koireng""",
"""Lamkang""",
"""Moyon Naga""",
"""Ranglong""",
"""Sorbung""",
"""Tarao Naga""",
"""Vaiphei""",
"""Ngawn Chin""",
"""Simte""",
"""Siyin Chin""",
"""Zou""",
"""Dapzal""",
"""Dim""",
"""Dimpi""",
"""Lamzang""",
"""Lousau""",
"""Saizang""",
"""Sihzang""",
"""Telzang""",
"""Tuichiap""",
"""Purum""",
"""Ralte""",
"""Sokte""",
"""Changsen""",
"""Hawkip""",
"""Jangshen""",
"""Kaokeep""",
"""Khongzai""",
"""Kipgen""",
"""Langiung""",
"""Sairang""",
"""Shithlou""",
"""Singson""",
"""Thangngen""",
"""Matupi Daai""",
"""Paletwa Daai""",
"""Thui Phum""",
"""Tlam Tlaih""",
"""Va Lang""",
"""Khyang""",
"""Lemyo""",
"""Minbu""",
"""Saingbaun""",
"""Sandoway""",
"""Thayetmyo""",
"""Sumtu Chin""",
"""Mro Chin""",
"""Khami""",
"""Khimi""",
"""Khumi""",
"""Khuni""",
"""Khweymi""",
"""Kumi""",
"""Ngala""",
"""Yindi""",
"""Rengmitca""",
"""Dzuna""",
"""Kehena""",
"""Khonoma""",
"""Kohima""",
"""Mima""",
"""Mozome""",
"""Nali""",
"""Tengima""",
"""Tenyidie""",
"""Chokri Naga""",
"""Khezha Naga""",
"""Poumei Naga""",
"""Pochuri Naga""",
"""Keteneneyu""",
"""Lazemi""",
"""Zhimomi""",
"""Zumomi""",
"""Chongli""",
"""Dordar""",
"""Longla""",
"""Mongsen Khari""",
"""Kyon""",
"""Kyong""",
"""Kyou""",
"""Live""",
"""Ndreng""",
"""Tsontsu""",
"""Phelongre""",
"""Photsimi""",
"""Pirr""",
"""Purr""",
"""Thukumi""",
"""Makuri Naga""",
"""Para Naga""",
"""Pherrongre""",
"""Yimchungru""",
"""Tikhir""",
"""Wai""",
"""Mirlong""",
"""Rong Kethang""",
"""Meitei""",
"""Pangal""",
"""Maring Naga""",
"""Khunggoi""",
"""Kupome""",
"""Phadang""",
"""Ukhrul""",
"""Ngatan""",
"""T. Khullen""",
"""Willong Circle""",
"""Mzieme Naga""",
"""Paren""",
"""Thangal Naga""",
"""Heqing""",
"""Jianchuan""",
"""Lanping""",
"""Yunlong""",
"""Nujiang""",
"""Xiangyun""",
"""Caijia""",
"""Longjia""",
"""Milang""",
"""Komkar""",
"""Pasi""",
"""Shimong""",
"""Padam""",
"""Tangam""",
"""Pailibo""",
"""Ramo""",
"""Tagin""",
"""Galo""",
"""Nyishi""",
"""Sajalong""",
"""Idu-Mishmi""",
"""Mru""",
"""Nu River""",
"""Gwaza""",
"""Miko""",
"""Hpungsi""",
"""Htiselwang""",
"""Kunlang""",
"""Longmi""",
"""Matwanly""",
"""Mutwang""",
"""Rawang""",
"""Serhta""",
"""Serwang""",
"""Tangsarr""",
"""Taron""",
"""Wadamkong""",
"""Wahke""",
"""Zithung""",
"""Raute""",
"""Rawat""",
"""Fu-Guang""",
"""Ji-Cha""",
"""Yi-Liu""",
"""Ying-Yi""",
"""Qujiang Hakka-Shibei Shaoguan Tuhua""",
"""Longqu""",
"""Jinhua""",
"""Oujiang""",
"""Lin-Shao""",
"""Piling""",
"""Su-Hu-Jia""",
"""Tiaoxi""",
"""Yongjiang""",
"""Taizhou""",
"""Wuzhou""",
"""Taigao""",
"""Tongjing""",
"""Jishu""",
"""Luoshao""",
"""Shaanxi""",
"""Yage""",
"""Jixi""",
"""Qide""",
"""Xiuyi""",
"""Yanzhou""",
"""Jinyu Chinese""",
"""Literary Chinese""",
"""Gangou""",
"""Hezhou""",
"""Ho""",
"""Huabei Guanhua""",
"""Jinghuai Guanhua""",
"""Taibei Mandarin""",
"""Xibei Guanhua""",
"""Xinan Guanhua""",
"""Tangwang""",
"""Wutunhua""",
"""Middle Chinese""",
"""Old Chinese""",
"""Huizhou""",
"""Ning-Long""",
"""Sanhsien""",
"""Tingzhou""",
"""Tonggu""",
"""Yue-Tai""",
"""Yuebei""",
"""Yuezhong""",
"""Yugui""",
"""Min Bei""",
"""Min Dong""",
"""Min Nan""",
"""Mn Zhong""",
"""Pu-Xian""",
"""Fuzhou""",
"""Xinghua""",
"""Shantou""",
"""Chaochow""",
"""Chaozhou""",
"""Fukienese""",
"""Hainan""",
"""Sanso""",
"""Hokkien""",
"""Leizhou""",
"""Longdu""",
"""Teochew""",
"""Fujian""",
"""Zhenan Min""",
"""Min Zhong Chinese""",
"""Putian""",
"""Xianyou""",
"""Xinghua""",
"""Gaolei""",
"""Guinan""",
"""Qinlian""",
"""Siyi""",
"""Toishanese""",
"""Vancouver Cantonese""",
"""Yuehai""",
"""Waxianghua""",
"""Longshan""",
"""Southern Tujia""",
"""Nam""",
"""Timur""",
"""Yapsi-Taja""",
"""Vitou""",
"""Bonerif""",
"""Dabe""",
"""Jofotek-Bromnya""",
"""Keder""",
"""Kwinsu""",
"""Ittik-Tor""",
"""Kwesten""",
"""Mander""",
"""Maremgi""",
"""Cupeño""",
"""Island Takic""",
"""Luiseño""",
"""Tongva""",
"""Tübatulabal""",
"""Hopi""",
"""Panamint""",
"""Northern Shoshoni""",
"""Western Shoshoni""",
"""Southern Paiute""",
"""Ute""",
"""North Northern Paiute""",
"""South Northern Paiute""",
"""Omomil""",
"""Yaqui""",
"""Highland Puebla Nahuatl""",
"""Huaxcaleca Nahuatl""",
"""Isthmus-Mecayapan Nahuatl""",
"""Isthmus-Pajapan Nahuatl""",
"""Tabasco Nahuatl""",
"""Northern Oaxaca Nahuatl""",
"""Ometepec Nahuatl""",
"""Pipil""",
"""Santa María La Alta Nahuatl""",
"""Sierra Negra Nahuatl""",
"""Southeastern Puebla Nahuatl""",
"""Zacatlán-Ahuacatlán-Tepetzintla Nahuatl""",
"""Classical Nahuatl""",
"""Morelos Nahuatl""",
"""Northern Puebla Nahuatl""",
"""Tetelcingo Nahuatl""",
"""Tlamacazapa Nahuatl""",
"""Pochutec""",
"""Temascaltepec Nahuatl""",
"""Western Durango Nahuatl""",
"""Michoacán Nahuatl""",
"""La Mesa del Nayar Cora""",
"""Presidio de los Reyes Cora""",
"""San Francisco Cora""",
"""Santa Teresa Cora""",
"""Rosarito Cora""",
"""San Blasito Cora""",
"""San Juan Corapan Cora""",
"""San Andrés Cohamiata""",
"""San Sebastián-Santa Catarina""",
"""Jova""",
"""Opata""",
"""Lowland Huarijío""",
"""Lowland Tarahumara""",
"""Northern Tarahumara""",
"""Southwestern Tarahumara""",
"""Sonora Pima Bajo""",
"""Tohono O'odam""",
"""Southwestern Tepehuan""",
"""Tepecano""",
"""Tubar""",
"""Wanyi""",
"""South-Eastern-Tasmanian-Hinterland""",
"""Guwidj""",
"""Munumburru""",
"""Ngarnawu""",
"""Wolyamidi""",
"""Wurla""",
"""Kwini""",
"""Miwa""",
"""Wilawila""",
"""Miwa""",
"""Wunambal""",
"""Unggumi""",
"""Winjarumi""",
"""Unggumi""",
"""Worrorra""",
"""Nëhup""",
"""Tuhup""",
"""Yuhup""",
"""Nadëb""",
"""Tofanma""",
"""Haila'er""",
"""Qiqiha'er""",
"""Bargu""",
"""Khori""",
"""Khori""",
"""Barguzin""",
"""Bohaan""",
"""Bulagat""",
"""Ekhirit""",
"""Ninzne-Udinsk""",
"""Oka""",
"""Tunka""",
"""Unga""",
"""Halh""",
"""Khotogoit""",
"""Sartul""",
"""Tsongol""",
"""Ejine""",
"""Jirim""",
"""Jo-Uda""",
"""Jostu""",
"""Ordos""",
"""Shilingol""",
"""Tumut""",
"""Ulanchab""",
"""Dörböt""",
"""Oirat""",
"""Sart Qalmaq""",
"""Torgut""",
"""Kitan""",
"""Middle Mongol""",
"""Kundur""",
"""Tongren""",
"""Suonanba""",
"""Wangjiaji""",
"""Kangjia""",
"""Minhe""",
"""Pehuenche""",
"""Picunche""",
"""Southern Foothill Yokuts""",
"""Valley Yokuts""",
"""Palewyami Yokuts""",
"""Bezshagh""",
"""Tapanta""",
"""Bzyb""",
"""Samurzakan""",
"""Bezhedukh""",
"""Natuzaj""",
"""Shapsug""",
"""Xakuchi""",
"""Ubykh""",
"""Kituhwa""",
"""Otali""",
"""Overhill-Middle Cherokee""",
"""Laurentian""",
"""Oneida""",
"""Onondaga""",
"""Seneca""",
"""Susquehannock""",
"""Tuscarora""",
"""Wyandot""",
"""Tsafiki""",
"""Totoro""",
"""Canari""",
"""Miriei""",
"""Moi""",
"""Tinam""",
"""Uran""",
"""Mansim""",
"""Western Coastal Tasmanian""",
"""Kiowa""",
"""Nambe""",
"""Pojoaque""",
"""San Ildefonso""",
"""San Juan""",
"""Santa Clara""",
"""Tesuque""",
"""Sandia""",
"""Taos""",
"""Picuris Northern Tiwa""",
"""Arabela""",
"""Záparo""",
"""Nungali""",
"""Ngarnga""",
"""Gudandji""",
"""Wambaya""",
"""Kvanxidatl""",
"""Munin""",
"""Rikvani""",
"""Zilo""",
"""Tindi""",
"""Zibirkhalin""",
"""Godoberi""",
"""Gakvari""",
"""Gigatl""",
"""Tokita""",
"""Andalal-Gxdatl""",
"""Bacadin""",
"""Batlux""",
"""Hid""",
"""Karax""",
"""Kaxib""",
"""Keleb""",
"""Kunzakh""",
"""Salatav""",
"""Shulanin""",
"""Untib""",
"""Zakataly""",
"""Zaqatala""",
"""Bezhta""",
"""Tlyadaly""",
"""Hunzib""",
"""Xvarshi""",
"""Chirag""",
"""Cudaxar""",
"""Dejbuk""",
"""Itsari""",
"""Kajtak""",
"""Kubachi""",
"""Muirin""",
"""Sirzin""",
"""Uraxa-Axusha""",
"""Xarbuk""",
"""Khinalugh""",
"""Kumux""",
"""Vicxin""",
"""Vixlin""",
"""Gekxun""",
"""Keren""",
"""Koshan""",
"""Anykh""",
"""Garkin""",
"""Gjunej""",
"""Kiuri""",
"""Kubachi""",
"""Quba""",
"""Stal""",
"""Yergyuch""",
"""Dzhek""",
"""Kryz""",
"""Xaput""",
"""Yergyudzh""",
"""Ixreko-Muxrek""",
"""Shina""",
"""Mikik""",
"""Misles""",
"""Oghuz""",
"""Oktomberi""",
"""Melkhin""",
"""Ploskost""",
"""Ingush""",
"""Islands Estonian""",
"""Middle Estonian""",
"""Northwestern Estonian""",
"""Northeastern Coastal Estonian""",
"""Seto""",
"""Tartu""",
"""Lower Luzh""",
"""Oredezh""",
"""Soykin""",
"""Novgorod""",
"""Olonets Karelian""",
"""Southern Karelian""",
"""Tver""",
"""Livvi""",
"""Western Livonian""",
"""Ludian""",
"""Häme""",
"""Peräpohja""",
"""Savo""",
"""South Pohjanmaa""",
"""Southeastern Finnish""",
"""Southwestern Finnish""",
"""Kven Finnish""",
"""Torne Valley Finnish""",
"""Vittangi Finnish""",
"""Prionezh""",
"""Southern Veps""",
"""West Vod""",
"""Csango""",
"""Danube-Tisza""",
"""King's Pass Hungarian""",
"""Northeast Hungarian""",
"""Northwest Hungarian""",
"""Oberwart""",
"""Székely""",
"""West Danube""",
"""West Hungarian""",
"""Surgut Khanty""",
"""Northern Khanti""",
"""Southern Khanti""",
"""Vach""",
"""Southern Khanty""",
"""Northern Vogul""",
"""Southern Vogul""",
"""Western Vogul""",
"""Yaran""",
"""Moksha""",
"""South Permyak""",
"""Zyuzdin""",
"""South Udmurt""",
"""Inari Sami""",
"""Kemi Sami""",
"""Yokan""",
"""Ter Sami""",
"""Torne""",
"""Pite Sami""",
"""Ume Sami""",
"""Tundra Enets""",
"""Tundra Yurak""",
"""Koibal""",
"""Samoyed Koibal""",
"""Srednyaya Ob-Ket""",
"""Taz""",
"""Tym""",
"""Mator""",
"""Taigi""",
"""Khatang""",
"""Kiksht""",
"""Klatsop""",
"""Chinuk Wawa""",
"""Wasco-Wishram""",
"""Southern Ninam""",
"""Western Yanomami""",
"""Nanomam""",
"""Yanamam""",
"""Yanomam""",
"""Yanomay""",
"""Yaroame""",
"""Yanoma""",
"""Huambisa""",
"""Shuar""",
"""Sliammon""",
"""Cowichan""",
"""Musqueam""",
"""Nanaimo""",
"""Southern Lushootseed""",
"""Muckleshoot""",
"""Nisqually""",
"""Puyallup""",
"""Snoqualmie""",
"""Suquh""",
"""Nooksack""",
"""Pentlatch""",
"""Sechelt""",
"""Squamish""",
"""Saanich""",
"""Samish""",
"""Semiahmoo""",
"""Songish""",
"""Sooke""",
"""Ts'ooke""",
"""Skokomish""",
"""Western Shuswap""",
"""Thompson""",
"""Wenatchi""",
"""Pend D'oreille""",
"""Spokane""",
"""Lake""",
"""Sanpoil""",
"""Southern Okanogan""",
"""Tillamook""",
"""Upper Chehalis""",
"""Marti Ke""",
"""Maridjabin""",
"""Marri Yedi""",
"""Marridan""",
"""Marrisjabin""",
"""Marithiel""",
"""Mariyedi""",
"""Marriammu""",
"""Manda""",
"""Maranunggu""",
"""Saburi""",
"""Tallau""",
"""Shatt""",
"""Eref""",
"""Gadjira""",
"""Sila""",
"""Njalgulgule""",
"""Nyala""",
"""Aka-Kede""",
"""Oko-Juwoi""",
"""Aka-Cari""",
"""Aka-Kora""",
"""Akar-Bale""",
"""San Francisco""",
"""Santa Clara""",
"""Santa Cruz""",
"""Soledad""",
"""Mutsun""",
"""Rumsen""",
"""Plains Miwok""",
"""Western Central Sierra Miwok""",
"""Northern Sierra Miwok""",
"""Southern Sierra Miwok""",
"""Huimen""",
"""Marin Miwok""",
"""Lake Miwok""",
"""Muguani""",
"""Akabafa""",
"""Averi""",
"""Chimona""",
"""Dea""",
"""Jimuni""",
"""Karira""",
"""Mesari""",
"""Minjori""",
"""Muaturaina""",
"""Nami""",
"""Numba""",
"""Oko""",
"""Wakue""",
"""Gora-Bomahouji""",
"""Zuwadza""",
"""Lahada""",
"""Omani""",
"""West Koita""",
"""Mountain Koiali""",
"""Viryal""",
"""Yakut""",
"""South Quchani""",
"""West Quchani""",
"""Cawdur""",
"""Esari""",
"""Goklen""",
"""Khasarli""",
"""Nerezim""",
"""Nokhurli""",
"""Salyr""",
"""Saryq""",
"""Teke""",
"""Yomud""",
"""Kuvakan""",
"""Yurmaty""",
"""Tevriz""",
"""Tobol""",
"""Tyumen""",
"""Zabolotny""",
"""Tom""",
"""Kasimov""",
"""Middle Tatar""",
"""Tepter""",
"""Ural""",
"""Western Tatar""",
"""Pecheneg""",
"""Southeastern Karakalpak""",
"""Southern Kazakh""",
"""Western Kazakh""",
"""Southern Kirghiz""",
"""Central Nogai""",
"""White Nogai""",
"""Northern Crimean""",
"""Southern Crimean""",
"""Urum""",
"""Karachay""",
"""Galits""",
"""Northwestern Karaim""",
"""Trakay""",
"""Krymchak""",
"""Khaikent""",
"""Khasavyurt""",
"""Mengda""",
"""Aynallu""",
"""Baharlu""",
"""Bayat""",
"""Karapapakh""",
"""Kars""",
"""Kirkuk""",
"""Moqaddam""",
"""Nafar""",
"""Pishagchi""",
"""Qajar""",
"""Qaragozlu""",
"""Shahsavani""",
"""Tabriz""",
"""Kipchak""",
"""Oghuz""",
"""Southern Uzbek""",
"""Baku""",
"""Borcala""",
"""Derbend""",
"""Ganja""",
"""Karapapak""",
"""Lenkaran""",
"""Nakhchivan""",
"""Nukha""",
"""Ordubad""",
"""Qabala""",
"""Qazakh""",
"""Quba""",
"""Qyzylbash""",
"""Salyan""",
"""Shamakhi""",
"""Shusha""",
"""Terekeme""",
"""Yerevan""",
"""Zaqatala""",
"""Salchuq""",
"""Maritime Gagauzi""",
"""Gerlovo Turks""",
"""Karamanli""",
"""Kyzylbash""",
"""Surguch""",
"""Tozluk Turks""",
"""Yuruk""",
"""Dinler""",
"""Edirne""",
"""Eskisehir""",
"""Gaziantep""",
"""Karamanli""",
"""Razgrad""",
"""Rumelian""",
"""Urfa""",
"""West Yugur""",
"""Ili Turki""",
"""Old Uighur""",
"""Akto Türkmen""",
"""Central Uyghur""",
"""Charchan""",
"""Dolan""",
"""Hotan""",
"""Ili""",
"""Kashgar-Yarkand""",
"""Khotan-Kerya""",
"""Kucha""",
"""Kumul""",
"""Lop""",
"""Lopnor""",
"""Qarashahr""",
"""Turfan""",
"""Urumqi""",
"""Yengi Hissar""",
"""Talangit""",
"""Middle Chulym""",
"""Northeastern Tuvin""",
"""Southeastern Tuvin""",
"""Tuba-Kizhi""",
"""Western Tuvin""",
"""Kacha""",
"""Kamassian""",
"""Kyzyl""",
"""Sagai""",
"""Shor""",
"""Mrassa""",
"""Turkic Khalaj""",
"""Dorasque""",
"""Sabanero""",
"""Valiente""",
"""Chuana""",
"""Teribe""",
"""Coroma""",
"""Salitre-Cabagra""",
"""Estrella""",
"""Telire""",
"""Ujarrás""",
"""Malayo""",
"""Chimila""",
"""Duit""",
"""Barro Negro Tunebo""",
"""Central Tunebo""",
"""Western Tunebo""",
"""Maléku Jaíka""",
"""Rama""",
"""Pech""",
"""Kusgilo""",
"""Chali""",
"""Koma of Begi""",
"""Koma of Daga""",
"""Uduk""",
"""Marensé""",
"""Koyraboro Senni Songhai""",
"""Tondi Songway Kiini""",
"""Koyra Chiini""",
"""Tadaksahak""",
"""Azawagh""",
"""Tasawaq""",
"""Cuchudua""",
"""Jurua""",
"""Mamoria""",
"""Pauini""",
"""Tukurina""",
"""Paumarm""",
"""Uaiai""",
"""Suruahá""",
"""Apalachee""",
"""Koasati""",
"""Seminole""",
"""Mikasuki""",
"""Choctaw""",
"""Mahas""",
"""Old Nubian""",
"""Haraza""",
"""Kenuzi""",
"""Kafir""",
"""Kuldaji""",
"""Kurtala""",
"""Kururu""",
"""Kadaru""",
"""Uncunwee""",
"""Dilling""",
"""El Hugeirat""",
"""Karko""",
"""Wali""",
"""Shelkota""",
"""Urrti""",
"""Ketiar Krau""",
"""Krau""",
"""Kuala Tembeling""",
"""Pulau Guai""",
"""Ulu Ceres""",
"""Ulu Tembeling""",
"""Jarum""",
"""Jeher""",
"""Kedah""",
"""Kensiu Batu""",
"""Kensiu Siong""",
"""Kentaq Nakil""",
"""Plus""",
"""Ulu Selama""",
"""Kintaq""",
"""Batek Iga""",
"""Batek Nong""",
"""Batek Teq""",
"""Jehai""",
"""Minriq""",
"""Mintil""",
"""Sabüm""",
"""Semnam""",
"""Kenderong""",
"""Kenering""",
"""Lanoh Kobak""",
"""Po-Klo""",
"""Sakai of Plus Korbu""",
"""Sungai Piah""",
"""Tanjong Rambutan""",
"""Tembe'""",
"""Ulu Kinta""",
"""Bidor""",
"""Bil""",
"""Cameron""",
"""Jelai""",
"""Lipis""",
"""Orang Tanjong of Ulu Langat""",
"""Perak I""",
"""Perak II""",
"""Sungkai""",
"""Telom""",
"""Ulu Kampar""",
"""Kuala Langot Besisi""",
"""Malakka Besisi""",
"""Selangor Sakai""",
"""Sisi""",
"""Ulu Langat Orang Bukit""",
"""Semelai""",
"""Temoq""",
"""Traw""",
"""Talieng""",
"""Bahnar Bonom""",
"""Golar""",
"""Jolong""",
"""Kontum""",
"""Krem""",
"""Tolo""",
"""Monom""",
"""Hre""",
"""Rabah""",
"""Sedang-Rengao""",
"""Western Rengao""",
"""Dak Sut Sedang""",
"""Greater Sedang""",
"""Kon Hring Sedang""",
"""Kotua Sedang""",
"""Todrah""",
"""Katua""",
"""Jeh Mang Ram""",
"""Kayong""",
"""Romam""",
"""Takua""",
"""Kalop""",
"""Kodu""",
"""Lac""",
"""Laya""",
"""Nop""",
"""Pru""",
"""Rion""",
"""Sop""",
"""Sre""",
"""Tala""",
"""Tring""",
"""Maa""",
"""Chalun""",
"""Dor""",
"""Jro""",
"""Mro""",
"""Prang""",
"""Tamun""",
"""Vajieng""",
"""Voqtwaq""",
"""Mnong Gar""",
"""Mnong Kwanh""",
"""Mnong Rolom""",
"""Bu Dang""",
"""Bu Nar""",
"""Bu Rung""",
"""Dih Bri""",
"""Préh""",
"""Kraol""",
"""Prang""",
"""Bulo""",
"""Tampuan""",
"""Kru'ng 2""",
"""Sou""",
"""Nyaheun""",
"""Kranyeu""",
"""Riyao""",
"""Tamal Euy""",
"""Sok""",
"""Trieng""",
"""Western Katu""",
"""Phuong""",
"""Tong""",
"""Ong""",
"""Kamuan'""",
"""Leem""",
"""Palee'n""",
"""Pasoom""",
"""Bru Kok Sa-At""",
"""Mangkong""",
"""Tri""",
"""Western Bru""",
"""So Phong""",
"""So Slouy""",
"""So Trong""",
"""Kuay""",
"""Kuy Anthua""",
"""Kuy Antra""",
"""Kuy May""",
"""Kuy Mlor""",
"""Nheu""",
"""Nyeu""",
"""Cherrapunji""",
"""Khynrium""",
"""Lyngngam""",
"""Khasi""",
"""War""",
"""Batau""",
"""Jowai""",
"""Lakadong""",
"""Martiang""",
"""Mynso""",
"""Nongtalang""",
"""Raliang""",
"""Rymbai""",
"""Shangpung""",
"""Sumer""",
"""Sutnga""",
"""Nongtung""",
"""Megam""",
"""War-Khasi""",
"""Man Met""",
"""Mok""",
"""Tai Loi""",
"""U""",
"""Kháng Clau""",
"""Upper Lamet""",
"""Phang""",
"""Samtao""",
"""Phang""",
"""Kentung Wa""",
"""La""",
"""Son""",
"""Wa Lon""",
"""Wu""",
"""Parauk""",
"""Palaung-Riang""",
"""Raojin""",
"""Shwe Palaung""",
"""Yinchia""",
"""Rumai Palaung""",
"""Southern Khmer""",
"""Sisaket""",
"""Surin""",
"""Old Khmer""",
"""Khroong""",
"""Luang Prabang""",
"""Lyy""",
"""Rok""",
"""Sayabury""",
"""U""",
"""Yuan""",
"""Khuen""",
"""Mlabri""",
"""Mal""",
"""Phai""",
"""Pray 3""",
"""Phong-Kniang""",
"""Theen""",
"""Puoc""",
"""Bugan""",
"""Kemiehua""",
"""Mang""",
"""Pegu""",
"""Ye""",
"""Nyahkur""",
"""Old Mon""",
"""Manjhi""",
"""Bijori""",
"""Birhor""",
"""Lohara""",
"""Mundari""",
"""Koda""",
"""Majhwar""",
"""Turi""",
"""Mahali""",
"""Karmali""",
"""Lohari-Santali""",
"""Mahali""",
"""Manjhi""",
"""Paharia""",
"""Bouriya""",
"""Mawasi""",
"""Ruma""",
"""Plains Geta'""",
"""Munda Orissa Gadaba""",
"""Upper Bondo""",
"""Juang""",
"""Dudh Kharia""",
"""Mirdha-Kharia""",
"""Sora""",
"""Katchal""",
"""Nancowry""",
"""Trinkut""",
"""Great Nicobar""",
"""Little Nicobar""",
"""Milo""",
"""Sambelong""",
"""Tafwap""",
"""Somray""",
"""Sa'och""",
"""Suoy""",
"""Ruc""",
"""Sach""",
"""Kha Phong""",
"""Malang""",
"""Malieng""",
"""Maleng""",
"""Pakatan""",
"""Ly Ha""",
"""Phong""",
"""Toum""",
"""Mon""",
"""Boi Bi""",
"""Moi 1""",
"""Mol""",
"""Mual""",
"""Thang""",
"""Wang""",
"""Nguôn""",
"""Northern Vietnamese""",
"""Southern Vietnamese""",
"""Western Isirawa""",
"""Kauwera""",
"""Kwerba Mamberamo""",
"""Sasawa""",
"""Serikenam""",
"""Trimuris""",
"""Samarokena""",
"""Charrúa""",
"""Güenoa""",
"""Gooniyandi""",
"""Buniabura""",
"""Doma""",
"""Jari""",
"""Mori""",
"""Moikodi""",
"""Nawaru""",
"""Yareba""",
"""Katawixi""",
"""Yameo""",
"""Yagua""",
"""Mena""",
"""Meni""",
"""Pimuru""",
"""Utabi""",
"""Mouwase""",
"""Southern Yukaghir""",
"""Northern Yukaghir""",
"""Yukaghir Omok""",
"""Ibaraki""",
"""Tochigi""",
"""Chichibu""",
"""Gunma""",
"""Kanagawa""",
"""Tama""",
"""Shitamachi""",
"""Morioka""",
"""Nambu""",
"""Shimokita""",
"""Shōnai""",
"""Tsugaru""",
"""Fukushima""",
"""Kesen""",
"""Mogami""",
"""Sendai""",
"""Yamagata""",
"""Yonezawa""",
"""Nagaoka""",
"""Niigata""",
"""Uonuma""",
"""Western Mikawa""",
"""Mino""",
"""Nagoya""",
"""Izu""",
"""Hokushin""",
"""Nanshin""",
"""Okushin""",
"""Tōshin""",
"""Shizuoka""",
"""Yamanashi""",
"""Hachijō""",
"""Ōmuta-ben""",
"""Chikuho-ben""",
"""Hakata-ben""",
"""Hita-ben""",
"""Kumamoto-ben""",
"""Sasebo-ben""",
"""Saga-ben""",
"""Tsushima-ben""",
"""Miyazaki-ben""",
"""Ōita-ben""",
"""Osumi-ben""",
"""Satsuma-ben""",
"""Hiroshima""",
"""Iwami""",
"""Okayama""",
"""Tajima""",
"""Tango""",
"""Tottori""",
"""Yamaguchi""",
"""Kanazawa""",
"""Noto""",
"""Sado""",
"""Toyama""",
"""Kobe""",
"""Gosho""",
"""Muromachi""",
"""Maizuru""",
"""Ise""",
"""Shima""",
"""Oku-yoshino""",
"""Shiga""",
"""Wakasa""",
"""Wakayama""",
"""Semba""",
"""Senshū""",
"""Iyo-ben""",
"""Kagawa-ben""",
"""Tokushima-ben""",
"""Yonago-ben""",
"""Yilan Creole Japanese""",
"""Old Japanese""",
"""West Oki-No-Erabu""",
"""Sani""",
"""Southern Amami-Oshima""",
"""Yoron""",
"""Naha""",
"""Shuri""",
"""Torishima""",
"""Hatoma""",
"""Ishigaki""",
"""Kabira""",
"""Kohama""",
"""Kuroshima""",
"""Shiraho""",
"""Sonai""",
"""Taketomi""",
"""Yonaguni""",
"""Miyako-Jima""",
"""Tarama-Minna""",
"""Xinka-Jumaytepeque""",
"""Xinca-Guazacapan""",
"""Xinca-Sinacantan""",
"""Xinca-Yupiltepeque""",
"""New River Shasta""",
"""Shasta""",
"""Woccon""",
"""Nakota""",
"""Southern Stoney""",
"""Ponca""",
"""Osage""",
"""Quapaw""",
"""Wisconsin""",
"""Missouria""",
"""Oto""",
"""Hidatsa""",
"""Ofo""",
"""Tutelo""",
"""NE Tasmanian Dialect Chain""",
"""Kaluli""",
"""Ologo""",
"""Walulu""",
"""Sonia""",
"""Kasua""",
"""Onobasulu""",
"""North Beami""",
"""Western Edolo""",
"""Moskona""",
"""Yugh""",
"""Pumpokol""",
"""Kott""",
"""Karitiâna""",
"""Kayabí""",
"""Xingú Asuriní""",
"""Tambéopé""",
"""Tembekuá""",
"""Teüi""",
"""Pai Tavytera""",
"""Izoceño""",
"""Tapieté""",
"""Western Bolivian Guaraní""",
"""Xetá""",
"""Pauserna""",
"""Sirionó""",
"""Yuqui""",
"""Cocamilla""",
"""Curacirari""",
"""Curucicuri""",
"""Paguana""",
"""Tupinambá""",
"""Tupí""",
"""Suruí Do Pará""",
"""Tocantins Asurini""",
"""Tembe""",
"""Turiwára""",
"""Apiaká""",
"""Júma""",
"""Karipúna""",
"""Paranawát""",
"""Kagwahiv""",
"""Karipuna Jaci Paraná""",
"""Mialát""",
"""Tenharim""",
"""Parintintín""",
"""Uru-Eu-Wau-Wau""",
"""Wiraféd""",
"""Guajá""",
"""Tacunyape""",
"""Urubú-Kaapor""",
"""Wajapuku""",
"""Zo'é""",
"""Xipaya""",
"""Sateré-Mawé""",
"""Cinta Larga""",
"""Zoró""",
"""Salamãi""",
"""Suruí""",
"""Mundurukú""",
"""Urumi""",
"""Sakirabia""",
"""Kepkiriwát""",
"""Tuparí""",
"""Wayoró""",
"""Tabajari""",
"""Tyrewuju""",
"""Mayongong""",
"""Wayumara""",
"""Palmela""",
"""Pauxi""",
"""Urucuiana""",
"""Yebarana""",
"""Matipuhy""",
"""Pimenteira""",
"""Coyaima""",
"""Rio Negro""",
"""Río Casacará""",
"""Río Maracas""",
"""Yrapa""",
"""De'cuana""",
"""Ihuruana""",
"""Pawiyana""",
"""Sikiana""",
"""Ikpeng""",
"""Pará Arára""",
"""Yaruma""",
"""Cumanagoto""",
"""Pémono""",
"""Wokiare""",
"""Pauxiana""",
"""Sapara""",
"""Tamanaku""",
"""Patamona""",
"""Macushi""",
"""Camaracota""",
"""Camaracoto""",
"""Ingariko""",
"""Taulipang""",
"""Taurepan""",
"""Jawaperi""",
"""Waimiri""",
"""Ferejdan""",
"""Fereydan""",
"""Gurian""",
"""Imeretian""",
"""Imerxev""",
"""Imerxev Kartlian""",
"""Ingilo""",
"""Kaxetian""",
"""Meskhur-Javakhuri""",
"""Moxev""",
"""Mtiul""",
"""Pshav""",
"""Racha-Lexchxum""",
"""Tush""",
"""Xevsur""",
"""Old Georgian""",
"""Chxala""",
"""Samurzakan-Zugdidi""",
"""Senaki""",
"""Vice-Arxava""",
"""Xopa""",
"""Mingrelian""",
"""Lentex""",
"""Lower Bal""",
"""Upper Bal""",
"""Parecís""",
"""Saraveca""",
"""Waurá""",
"""Yawalapití""",
"""Palikúr""",
"""Quirruba""",
"""Maipure""",
"""Yavitero""",
"""Apolista""",
"""Toa""",
"""Wayuu""",
"""Western Garifuna""",
"""Lokono""",
"""Taino""",
"""Baré""",
"""Guinau""",
"""Yabaâna""",
"""Siusy-Tapuya""",
"""Unhun""",
"""Tariana""",
"""Cabiyarí""",
"""Piapoco""",
"""Warekena Velha""",
"""Uainuma-Mariate""",
"""Yucuna""",
"""Resígaro""",
"""Passe""",
"""Maragua""",
"""Manao""",
"""Uirina""",
"""Xiriâna""",
"""Mapidian""",
"""Mawakwa""",
"""Atorai""",
"""Joaquiniano""",
"""Magiana""",
"""Loreto""",
"""Paunaca""",
"""Guana""",
"""Tereno""",
"""Ashéninka Pajonal""",
"""Ashéninka Perené""",
"""Pichis Ashéninka""",
"""Ucayali-Yurúa Ashéninka""",
"""Asháninka""",
"""Caquinte""",
"""Nanti""",
"""Nomatsiguenga""",
"""Pacaguara-Mercier""",
"""Machinere""",
"""Yine""",
"""Morike""",
"""Yanesha'""",
"""Southern Limba""",
"""Western Limba""",
"""Mansoanka""",
"""Mbulungish""",
"""Krim""",
"""Mmani""",
"""Peninsula Sherbro""",
"""Shenge Sherbro""",
"""Sitia Sherbro""",
"""Liaro""",
"""Teng""",
"""Tung""",
"""Tengia""",
"""Warn""",
"""Deng""",
"""Kongba""",
"""Kongbaa""",
"""Kpo""",
"""Managobla""",
"""Senje""",
"""Tee""",
"""Toldil""",
"""Baga Manduri""",
"""Bombali""",
"""Kholifa""",
"""Konike""",
"""Koya""",
"""Malal""",
"""Masingbi""",
"""Ribia""",
"""Sanda""",
"""Western Temne""",
"""Yoni""",
"""Nalu""",
"""Fjaalib""",
"""Kantohe""",
"""Mane""",
"""Naga""",
"""Cur""",
"""Likes-Utsia""",
"""Lund""",
"""Sarar""",
"""Teixeira Pinto""",
"""Tsaamo""",
"""Yu""",
"""Shadal""",
"""Papel""",
"""Bliss""",
"""Esulalu""",
"""Fluvial""",
"""Huluf""",
"""Selek""",
"""Kerak""",
"""Mlomp""",
"""Kuwaataay""",
"""Elun""",
"""Bandial""",
"""Gusilay""",
"""Fonyi""",
"""Kalounaye""",
"""Kombo""",
"""Narang""",
"""Kagbaaga""",
"""Kajoko""",
"""Kamona""",
"""Biafada""",
"""Padee""",
"""Saawii""",
"""Palor""",
"""Diobass""",
"""Hasab""",
"""Sebikotane""",
"""Sindia""",
"""Gunyamoolo""",
"""Bainouk-Gunyuno""",
"""Gubeeher-Gufangor-Gubelor""",
"""Northeast Bainounk""",
"""Kobiana""",
"""Kano-Katsina""",
"""Sokoto""",
"""Barkoundouba""",
"""Bitinkoore""",
"""Bogandé""",
"""Dallol""",
"""Fada Ngurma""",
"""Gourmantche""",
"""Jelgoore""",
"""Liptaakoore""",
"""Ouhiguyua""",
"""Seeba-Yaga""",
"""Garoua""",
"""Gombe""",
"""Kambariire""",
"""Maroua""",
"""Ngaondéré""",
"""Nomadic Fulfulde""",
"""Bagirmi Fulfulde""",
"""Bakuure""",
"""Djougoure""",
"""Korakuure""",
"""Tchabankeere""",
"""Western Macina""",
"""Kebu Fula""",
"""Krio Fula""",
"""Toucouleur""",
"""Fadyut-Palmerin""",
"""Niominka""",
"""Segum""",
"""Sine""",
"""Bassari""",
"""Bedik""",
"""Wamey""",
"""Lebu Wolof""",
"""Cayor""",
"""Dyolof""",
"""Jander""",
"""Lebou""",
"""Ndyanger""",
"""Ase""",
"""Daja""",
"""Efifa""",
"""Esuku""",
"""Gedegede""",
"""Ibaram""",
"""Ikorom""",
"""Iyani""",
"""Usokun""",
"""Inedua""",
"""Ogua""",
"""Zarama""",
"""Avianwu""",
"""Aviele""",
"""Ekperi""",
"""Ivhiadaobi""",
"""South Ibie""",
"""Uwepa-Uwano""",
"""Uzairue""",
"""Iuleha""",
"""Ivhimion""",
"""Ora""",
"""Igueben""",
"""Igwe""",
"""Ikpeshi""",
"""Sasaru""",
"""Ivbie North""",
"""Okpela""",
"""Ososo""",
"""Uhami""",
"""Ukue""",
"""Makeke""",
"""Oja""",
"""Ojirami""",
"""Oma""",
"""Bekuma""",
"""Ebunn-Oke""",
"""Ebunn-Ugbo""",
"""Eko""",
"""Ekpe""",
"""Igbo-Ola-Oke""",
"""Igbo-Ola-Sale""",
"""Ikaran-Ele""",
"""Ikaran-Oke""",
"""Ikpesa""",
"""Imoga""",
"""Lankpese""",
"""Ogbe-Oke""",
"""Ogbe-Sale""",
"""Ogugu""",
"""Onumo""",
"""Okpe""",
"""Oloma""",
"""Elu""",
"""Emede""",
"""Enhwe""",
"""Ibiede""",
"""Imiv""",
"""Irri""",
"""Itebiege""",
"""Iwire""",
"""Iyede""",
"""Iyede-Ami""",
"""Iyowo""",
"""Ofagbe""",
"""Ole""",
"""Olomoro""",
"""Owe""",
"""Oyede""",
"""Ozoro""",
"""Ume""",
"""Unogboko""",
"""Uti""",
"""Uzere""",
"""Okpe""",
"""Agbon""",
"""Udu""",
"""Ujevwe""",
"""Uvbie""",
"""Lamja""",
"""Tola""",
"""Samba Daka""",
"""Samba Jangani""",
"""Samba Nnakenyare""",
"""Samba of Mapeo""",
"""Taram""",
"""Gaa""",
"""Nyanjang""",
"""Nyasunda""",
"""Njanga""",
"""Ju Naare""",
"""Langa""",
"""Sunu Torbi""",
"""Njerep""",
"""Yeni""",
"""Somyev""",
"""Twendi""",
"""Ndunda""",
"""Kumbere""",
"""Nduvum""",
"""Ngoro""",
"""Nudoo""",
"""Nugane""",
"""Nujum""",
"""Vute Mbanjo""",
"""Nizaa""",
"""Gambai""",
"""Kong""",
"""Mankim""",
"""Nditam""",
"""Tige""",
"""Twumwu""",
"""Mashi""",
"""Naki""",
"""Ncane""",
"""Noone""",
"""Nsari""",
"""Bekwarra""",
"""Bete""",
"""Basua""",
"""Boje""",
"""Boki""",
"""Boorim""",
"""Eastern Bokyi""",
"""Irruan""",
"""Iruan""",
"""Kwakwagom""",
"""Nsadop""",
"""Oku""",
"""Osokom""",
"""Oyokom""",
"""Wula""",
"""Bumaji""",
"""Bebi""",
"""Bishiri""",
"""Bisu""",
"""Busi""",
"""Obe""",
"""Oboso""",
"""Okorogung""",
"""Okorotung""",
"""Utugwang""",
"""Ubang""",
"""Ukpe""",
"""Bishuo""",
"""Buru""",
"""Busuu""",
"""Ekajuk""",
"""Nnam""",
"""Nsele""",
"""Nta""",
"""Obang""",
"""Southern Ejagham""",
"""Bendeghe Etung""",
"""Ekwe""",
"""Northern Etung""",
"""Southern Etung""",
"""Nkum""",
"""Ekparabong""",
"""Ikumtale""",
"""Odaje""",
"""Fang""",
"""Nagumi""",
"""Labir""",
"""Guru""",
"""Gar Duguri""",
"""Northeast Duguri""",
"""Southwest Duguri""",
"""Bobar""",
"""Gingwak""",
"""Kanam""",
"""Ligri""",
"""Kulung""",
"""Mbaru""",
"""Ruhu""",
"""Mama""",
"""Mbula""",
"""Koshin""",
"""Basho""",
"""Bitieku""",
"""Takamanda""",
"""Kendem""",
"""Lower Kenyang""",
"""Upper Kenyang""",
"""Mbu'""",
"""Mundabli""",
"""Bakundumu""",
"""Bekeni""",
"""Bemili""",
"""Kyanzi""",
"""Suwa""",
"""Bera""",
"""Nyaku""",
"""Kaiku""",
"""Kango""",
"""Komo""",
"""Uélé""",
"""Buru""",
"""Hanga""",
"""Tungu""",
"""Benge""",
"""Kiba""",
"""Leboa-Le""",
"""Yewu""",
"""Mongbapele""",
"""Ndundusana""",
"""Liliká""",
"""Lilikó""",
"""Ngbee""",
"""Nyanga-li""",
"""Ngbinda""",
"""Boguru""",
"""Enenga""",
"""Galwa""",
"""Mpongwe""",
"""Nkomi""",
"""Orungu""",
"""Pinji""",
"""Simba""",
"""Tsogo""",
"""Viya""",
"""Kpa""",
"""Letia""",
"""Lefa""",
"""Tingong""",
"""Tibea""",
"""Barombi""",
"""Bisoo""",
"""Mbang""",
"""Yabyang""",
"""Yakalak""",
"""Yapoma""",
"""Yassuku""",
"""Basso""",
"""Bibeng""",
"""Bon""",
"""Diboum""",
"""Log""",
"""Mbang""",
"""Mpo""",
"""Ndokama""",
"""Ndokbele""",
"""Ndokpenda""",
"""Nyamtam""",
"""Mahongwe""",
"""Wumbvu""",
"""Osamayi""",
"""Ngom""",
"""Sake""",
"""Western Kele""",
"""Tombidi""",
"""Balong""",
"""Mwambong""",
"""Mwamenam""",
"""Ninong""",
"""Northern Bakossi""",
"""Southern Bakossi""",
"""Western Bakossi""",
"""Bafun""",
"""Balondo""",
"""Baneka""",
"""Manehas""",
"""Bakaka""",
"""Kekem""",
"""Melong""",
"""Santchou""",
"""Nkongho""",
"""Mvumbo""",
"""Kwasio""",
"""Shiwa""",
"""Besembo""",
"""Mbonjoku""",
"""Ngbako""",
"""Beten""",
"""Kwakum""",
"""Til""",
"""Bobili""",
"""Dondi""",
"""Mambaya""",
"""Pori Kinda""",
"""Jasoa""",
"""Mpyemo""",
"""Kamsili""",
"""Ukhwejo""",
"""Piiga""",
"""Kunabembe""",
"""Mbobyeng""",
"""Menzime""",
"""Mpomam""",
"""Bomwali""",
"""Byep""",
"""Bikeng""",
"""Kol North""",
"""Kol South""",
"""Mbwaanz""",
"""Sekunda""",
"""Melan So""",
"""Nzime""",
"""Njyem""",
"""Yambe""",
"""Bapuku""",
"""Batanga""",
"""Benga""",
"""Bomudi""",
"""Moganda""",
"""Bodele""",
"""Bomui""",
"""Bweko""",
"""Iyasa""",
"""Mapanga""",
"""Marry""",
"""Mogana""",
"""Mooma""",
"""One""",
"""Vendo""",
"""Mungo""",
"""Oli""",
"""Pongo""",
"""Malimba""",
"""Isu""",
"""Oli-Bidiman""",
"""Ekombe""",
"""Lokoko""",
"""Lokundu""",
"""Lolue""",
"""Londo""",
"""Longolo""",
"""Lotanga""",
"""Mbonge""",
"""Wumboko""",
"""Seki""",
"""Yelinda""",
"""Yembana""",
"""Yengono""",
"""Zaman""",
"""Essele""",
"""Mvo-Nangkok""",
"""Mvog-Namve""",
"""Manyok""",
"""Bebil""",
"""Bafeuk""",
"""Bamvele""",
"""Bane""",
"""Beti""",
"""Enoah""",
"""Evouzok""",
"""Fong""",
"""Mbida-Bani""",
"""Mvete""",
"""Mvog-Niengue""",
"""Omvang""",
"""Yabeka""",
"""Yabekanga""",
"""Yabekolo""",
"""Make""",
"""Mvae""",
"""Ntum""",
"""Ogowe""",
"""Southeast Bobe""",
"""Southwest Bobe""",
"""Mpongo""",
"""Nkole""",
"""Ntomba""",
"""Sakanyi""",
"""Saw""",
"""Soko""",
"""Sengele""",
"""Inja""",
"""Keembo""",
"""Nkimbe""",
"""Yaamba""",
"""Yaikole""",
"""Yaisu""",
"""Yangonda""",
"""Ekonda Mongo""",
"""Konda""",
"""Kutu""",
"""Longo""",
"""Longombe""",
"""Mpama""",
"""Nkundo""",
"""Ntomba-Bikoro""",
"""Ntomba-Inongo""",
"""Panga""",
"""Wangata""",
"""Yalima""",
"""Ngando""",
"""Ngende""",
"""Ngombe""",
"""Ngongo""",
"""Pianga""",
"""Lele""",
"""Wongo""",
"""Djia""",
"""Sakata""",
"""Dengese""",
"""Kusu""",
"""Tetela""",
"""Yela""",
"""Busu Djanga""",
"""Empesa Poko""",
"""Esumbu""",
"""Iliku""",
"""Kangana""",
"""Kumba""",
"""Kunda""",
"""Limpesa""",
"""Lipoto""",
"""Lusengo Poto""",
"""Mongala Poto""",
"""Mongo""",
"""Ngundi""",
"""Bwela""",
"""Tembo""",
"""Poko""",
"""South Lobala""",
"""Tanda""",
"""Zamba""",
"""Loi""",
"""Makutu""",
"""Mampoko""",
"""Lingala""",
"""Moi""",
"""Mpama""",
"""Hamba""",
"""Kongola-Meno""",
"""Lokalo""",
"""Ngongo""",
"""Saka""",
"""Songomeno""",
"""Bembe""",
"""Lipanja""",
"""Lobo""",
"""Mbinga""",
"""Ndobo""",
"""Kutu""",
"""Monia""",
"""Likila""",
"""Litoka""",
"""Bozaba""",
"""Maboko""",
"""Moliba""",
"""Molunga""",
"""Ebuku""",
"""Likaw""",
"""Lingonda""",
"""Bokoy""",
"""Bolupi""",
"""Elowa""",
"""Doko""",
"""Wiindza-Baali""",
"""Mbila""",
"""Monzamboli""",
"""Yaliambi""",
"""Egbuta""",
"""Ndolo""",
"""Kwanga""",
"""Mbowe""",
"""Mbumi""",
"""Mdundulu""",
"""Mishulundu""",
"""Mbowe""",
"""North Kwandu""",
"""South Kwandu""",
"""Mbukushu""",
"""Liyuwa""",
"""Makoma""",
"""Mulonga""",
"""Mwenyi""",
"""Simaa""",
"""Nyengo""",
"""Lombo""",
"""So""",
"""Likolo""",
"""Liutwa""",
"""Lombooki""",
"""Mbesa""",
"""Yari""",
"""Doondo""",
"""Ikeleve""",
"""Western Kituba""",
"""Central Kongo""",
"""East Kongo""",
"""Mboka""",
"""Ndingi""",
"""Nzamba""",
"""South Congo""",
"""South East Kongo""",
"""West Kongo""",
"""San Salvador Kongo""",
"""Suundi""",
"""Hungana""",
"""Suku""",
"""Yaka""",
"""Koyo""",
"""Likwala""",
"""Mbosi""",
"""Northern Bomitaba""",
"""Bonjo""",
"""Bonzio""",
"""Bwaka""",
"""Mbati of Mbaïki""",
"""Ngundi""",
"""Pande""",
"""Basese""",
"""Beka""",
"""Nzari""",
"""Northern Dibole""",
"""Southern Dibole""",
"""Mikaya-Bambengangale-Baluma""",
"""Dikuta""",
"""Luba-Katanga""",
"""Sanga""",
"""Kasenga""",
"""Mikebwe""",
"""Nonda""",
"""Bangubangu""",
"""Sanzi""",
"""Hemba""",
"""Bena Lulua""",
"""Kanyok""",
"""Luna""",
"""Lwalu""",
"""Mbagani""",
"""Western Kalebwe""",
"""Lushangi""",
"""Mashasha""",
"""Mbowela""",
"""Nkoya""",
"""Shasha""",
"""Kanandjoho""",
"""Kuya""",
"""Nyani""",
"""Ngul""",
"""Ombamba""",
"""Keteghe""",
"""Njiningi""",
"""Tegekali""",
"""Tchitchege""",
"""Tsaangi""",
"""Wandji""",
"""Vili of Ngounie""",
"""Sighu""",
"""Mosieno""",
"""Ngee""",
"""Wuumu""",
"""Teke-Kukuya""",
"""Teke-Ebo""",
"""Teke-Tsaayi""",
"""Yaka""",
"""Teke-Tyee""",
"""Yeci""",
"""Yongo""",
"""Phende""",
"""Sonde""",
"""Mbamba""",
"""Ngola""",
"""Njinga""",
"""Nsongo""",
"""Sama""",
"""Luvale""",
"""Mbunda""",
"""Mbwela""",
"""Nkangala""",
"""Nyemba""",
"""Kawiku""",
"""Kosa""",
"""Lunda Kalunda""",
"""Lunda Kambove""",
"""Lunda Ndembu""",
"""Ndembu""",
"""Ruund""",
"""Mbandieru""",
"""Zemba""",
"""Kwaludhi""",
"""Ngandyera""",
"""Mbalanhu""",
"""Ngandyera""",
"""Mwila""",
"""Ndombe""",
"""Umbundu""",
"""Vungunya""",
"""Lumbu""",
"""Ngubi""",
"""Vumbu""",
"""Sira""",
"""Tiene""",
"""Kempee""",
"""Ntswar""",
"""Mpuono""",
"""Songo""",
"""Lwel""",
"""Nzadi""",
"""Lundwe""",
"""Ila""",
"""Twa""",
"""Sala""",
"""Leya""",
"""Mala""",
"""Shanjo""",
"""Toka""",
"""Twa of Kafwe""",
"""We""",
"""Soli""",
"""Totela""",
"""Shanjo""",
"""Kabende""",
"""Lembue""",
"""Lomotua""",
"""Luunda""",
"""Mukula""",
"""Ng'umbo""",
"""Ngoma""",
"""Nwesi""",
"""Shila""",
"""Town Bemba""",
"""Twa of Bangweulu""",
"""Unga""",
"""Bisa""",
"""Lala""",
"""Luano""",
"""Swaka""",
"""Wulima""",
"""Lamba""",
"""Seba""",
"""Nsenga""",
"""Chipoka""",
"""Chitumbuka""",
"""Fililwa""",
"""Fungwe""",
"""Hewe""",
"""Kandawire""",
"""Nenya""",
"""Ngoni""",
"""Nthali""",
"""Poka""",
"""Senga""",
"""Wenya""",
"""Yombe""",
"""Malila""",
"""Nyika""",
"""Nyika""",
"""Mbwila""",
"""Poroto""",
"""Songwe""",
"""Kwa""",
"""Kwaafi""",
"""Nkwaamba""",
"""Ntili""",
"""Peemba""",
"""Siiwa""",
"""Sukuuma""",
"""Rungu""",
"""Tambo""",
"""Pimbwe""",
"""Tongwe""",
"""Rungwa""",
"""Mwamba""",
"""Ngonde""",
"""Nkonde""",
"""Nyakyusa""",
"""Selya""",
"""Kwange""",
"""Mamba""",
"""Semalinga""",
"""Semulu""",
"""Kolo""",
"""Kondoa""",
"""Mondo""",
"""Mbugwe""",
"""Mumoni""",
"""North Kitui""",
"""South Kitui""",
"""Igoji""",
"""Imenti""",
"""Miutini""",
"""Meru""",
"""Tigania""",
"""Ntugi""",
"""Tharaka""",
"""Thagichu""",
"""Embu""",
"""Mathira""",
"""Ndia""",
"""Northern Gikuyu""",
"""Southern Gikuyu""",
"""Mwimbi""",
"""Temi""",
"""Bukira""",
"""Bwirege""",
"""Kiroba""",
"""Nyabasi""",
"""Simbiti""",
"""Sweta""",
"""Suba""",
"""Suba-Simbiti""",
"""Ngurimi""",
"""Ndali""",
"""Siora""",
"""Kara""",
"""Isukha""",
"""Tiriki""",
"""Tachoni""",
"""Kabras""",
"""Ulubukusu""",
"""Ulubuya""",
"""Uludadiri""",
"""Ulukisu""",
"""Kisa""",
"""Marama""",
"""Nyore""",
"""Tachoni""",
"""Tsotso""",
"""Wanga""",
"""Marachi""",
"""Saamia""",
"""West Nyala""",
"""Menya""",
"""Sabi""",
"""Wesa""",
"""Gungu""",
"""Ludiopa""",
"""Luvuma""",
"""Sese""",
"""Gwere""",
"""Singa""",
"""Lamogi""",
"""Tenga""",
"""Syan""",
"""Hororo""",
"""Orutagwenda""",
"""Rutagwenda""",
"""Western Ruli""",
"""Talinga-Bwisi""",
"""Edangabo""",
"""Ekiziba""",
"""Ganda-Kiaka""",
"""Hamba""",
"""Hangiro""",
"""Mwani""",
"""Nyakisisa""",
"""Yoza""",
"""Longo""",
"""Joba""",
"""Nyindu""",
"""Havu""",
"""Hunde""",
"""Lindja""",
"""Longe-Longe""",
"""Ziba""",
"""Tembo""",
"""Shubi""",
"""Bwisha""",
"""Hutu""",
"""Igikiga""",
"""Mulenge""",
"""Rufumbira""",
"""Rutwa""",
"""Rundi""",
"""Rundi-Kitwa""",
"""Vinza""",
"""Sanza""",
"""Kumbule""",
"""Mate""",
"""Nande""",
"""Sanza""",
"""Shu""",
"""Swaga""",
"""Tangi""",
"""Yira""",
"""Mamba""",
"""Marangu""",
"""Mwika""",
"""Mashati""",
"""Mkuu""",
"""Usseri""",
"""Hai""",
"""Masama""",
"""Ng'uni""",
"""Siha""",
"""Gweno""",
"""Gimba""",
"""Kasigau""",
"""Kishamba""",
"""Mugange""",
"""Teri""",
"""Chawia""",
"""Mbale""",
"""Mbololo""",
"""Mwanda""",
"""Werugha""",
"""Ngazidja Comorian""",
"""Shindzwani""",
"""Ndzwani Comorian""",
"""Duruma""",
"""Jibana""",
"""Kambe""",
"""Kauma""",
"""Giryama""",
"""Rabai""",
"""Ribe""",
"""Segeju""",
"""Kinakomba""",
"""Malalulu""",
"""Ndera""",
"""Ndura""",
"""Zubaki""",
"""Katanga Swahili""",
"""Kivu Swahili""",
"""Lualaba Kingwana""",
"""Cutchi-Swahili""",
"""Interior Makwe""",
"""Nkojo""",
"""Nsimbwa""",
"""Wibo""",
"""Bajuni""",
"""Fundi""",
"""Matondoni""",
"""Mgao""",
"""Mrima""",
"""Mvita""",
"""Mwini""",
"""Pate""",
"""Pemba""",
"""Shamba""",
"""Siu""",
"""Unguja""",
"""Taveta""",
"""Zaramo""",
"""Kwere""",
"""Doe""",
"""Luguru""",
"""Megi""",
"""Tumba""",
"""Nyaugogo""",
"""Tumba""",
"""Shambala""",
"""Zigula""",
"""Kondoa""",
"""Kweny""",
"""Nkwifiya""",
"""Vidunda""",
"""Hehe""",
"""Ngoni""",
"""Vwanji""",
"""Konongo""",
"""Nyanyembe""",
"""Takama""",
"""Kiya""",
"""Sumbwa""",
"""Holoholo""",
"""North Binja""",
"""South Binja""",
"""Ibanda""",
"""Isopo""",
"""Iyoko""",
"""Lusenge""",
"""Mizulo""",
"""Kigyoma""",
"""Kinyabanga""",
"""Kinyamunsange""",
"""Kisede""",
"""Liliga""",
"""Mokpa""",
"""Ikumbure""",
"""Inyanga""",
"""Itiri""",
"""Ginyamunyinganyi""",
"""Girwana""",
"""Pogolo""",
"""Mpoto""",
"""Ngindo""",
"""Ndengereko""",
"""Mbunga""",
"""Nindi""",
"""Maviha""",
"""Vadonde""",
"""Vamakonde""",
"""Vamwalu""",
"""Vamwambe""",
"""Machinga""",
"""Makale""",
"""Mangoche""",
"""Massaninga""",
"""Tunduru Yao""",
"""Kunda""",
"""Manganja""",
"""Ngoni""",
"""Nyanja""",
"""Nyasa""",
"""Peta""",
"""Malawi Sena""",
"""Caia""",
"""Gombe""",
"""Gorongosa""",
"""Podzo""",
"""Rue""",
"""Sangwe""",
"""Nyungwe""",
"""Phimbi""",
"""Dondo""",
"""Garwe""",
"""Gova""",
"""Ndau""",
"""Shanga""",
"""Tonga""",
"""Govera""",
"""Jena""",
"""Mhari""",
"""Ngova""",
"""Nyubi""",
"""Gova""",
"""Nyongwe""",
"""Pfunde""",
"""Shan Gwe""",
"""Tande""",
"""Tavara""",
"""Toko""",
"""Harava""",
"""Kachikwakwa""",
"""Kwazwimba""",
"""Mbire""",
"""Njanja""",
"""Nobvu""",
"""Nohwe""",
"""Shawasha""",
"""Tsunga""",
"""Tawara-Daque""",
"""Bunji""",
"""Bvumba""",
"""Domba""",
"""Guta""",
"""Here""",
"""Hungwe""",
"""Jindwi""",
"""Karombe""",
"""Nyamuka""",
"""Nyatwe""",
"""Unyama""",
"""Tewe""",
"""Dema""",
"""Lilima""",
"""Nyai""",
"""Peri""",
"""Talahundra""",
"""Nambya""",
"""Khambani""",
"""Lambwe""",
"""Lengue""",
"""Ndonge""",
"""Tonga""",
"""Nyambe""",
"""Sewi""",
"""Hlubi""",
"""Phuthi""",
"""Bomvana""",
"""Cele""",
"""Gaika""",
"""Gealeka""",
"""Hlubi""",
"""Mfengu""",
"""Mpondo""",
"""Mpondomse""",
"""Ndlambe""",
"""Rhathabe""",
"""Thembu""",
"""Xesibe""",
"""Ngoni""",
"""Qwabe""",
"""South Ndebele""",
"""Konde""",
"""Putru""",
"""Changana""",
"""Gwamba""",
"""Hlave""",
"""Jonga""",
"""Kande""",
"""Luleke""",
"""N'walungu""",
"""Nhlanganu""",
"""Nkuma""",
"""Songa""",
"""Xonga""",
"""Mandla""",
"""Ndxhonge""",
"""Nhayi""",
"""Tshwa""",
"""Karungu""",
"""Maindo""",
"""Marale""",
"""Nyaringa""",
"""Lolo""",
"""Marenje""",
"""Takwane""",
"""Kokola""",
"""Enatthembo""",
"""Mitange""",
"""Malawi Lomwe""",
"""Empamela""",
"""Emwaja""",
"""Enaharra""",
"""Enlai""",
"""Enyara""",
"""Makhuwana""",
"""Naharra""",
"""Nampamela""",
"""Makhuwa-Moniga""",
"""Saka""",
"""Makhuwa-Shirima""",
"""Manyawa""",
"""Nathembo""",
"""Gananwa""",
"""Kgaga""",
"""Khutswe""",
"""Koni""",
"""Kopa""",
"""Lobedu""",
"""Masemola""",
"""Matlala-Moletshi""",
"""Pai""",
"""Phalaborwa""",
"""Pulana""",
"""Tlokwa""",
"""Tswene""",
"""Tswapong""",
"""Taung""",
"""Kenyi""",
"""Khakhae""",
"""Koma""",
"""Ngologa""",
"""Kgalagadi""",
"""Pedi""",
"""Phaleng""",
"""Rhiti""",
"""Shaga""",
"""Siwane""",
"""Kgatla""",
"""Kwena""",
"""Lete""",
"""Melete""",
"""Ngwaketse""",
"""Ngwatu""",
"""Rolong""",
"""Tawana""",
"""Thlaro""",
"""Tlahaping""",
"""Tlhaping""",
"""Tlharo""",
"""Tlokwa""",
"""Ilafuri""",
"""Lembetu""",
"""Manda""",
"""Mbedzi""",
"""Phani""",
"""Tavha-Tsindi""",
"""Belueli""",
"""East Bafwangada""",
"""Ineta""",
"""Mahaa""",
"""Makoda""",
"""Malamba""",
"""Wadimbisa""",
"""West Bafwangada""",
"""Mbo""",
"""Ndaka""",
"""Nyali""",
"""Vanuma""",
"""Kombe""",
"""Mbere""",
"""Ngoro""",
"""Tocenga""",
"""Tonjo""",
"""Tsinga""",
"""Nyokon""",
"""Tunen""",
"""Tuotomb""",
"""Nigii""",
"""Nubaca""",
"""Mmaala""",
"""Hijuk""",
"""Yangben""",
"""Southern Gunu""",
"""Oliti""",
"""Otank""",
"""Tiv""",
"""Batanga""",
"""Amayo""",
"""Olulu""",
"""Tinta""",
"""Esimbi""",
"""Ambo""",
"""Angwe""",
"""Kamino""",
"""Bitare""",
"""Modele""",
"""Befang""",
"""Obang""",
"""Okomanjang""",
"""Ushaku""",
"""Nee""",
"""Njee-Poantu""",
"""Nka'""",
"""Mkwet""",
"""Ngam""",
"""Ntii""",
"""Tungi'""",
"""Ghomálá North""",
"""Bameka""",
"""Bansoa""",
"""Ngemba""",
"""Kwa'""",
"""Bamendjing""",
"""Ungameha""",
"""Bamoungong""",
"""Batcham""",
"""Bamendjinda""",
"""Bamendjo""",
"""Bamenkumbo""",
"""Bamesso""",
"""Bamessingue""",
"""Ngwe""",
"""Yemba""",
"""Bamali""",
"""Bambalang""",
"""Bamun""",
"""Bangolan""",
"""Nde""",
"""Ti""",
"""Bafut""",
"""Beba""",
"""Bambui""",
"""Bamukumbit""",
"""Kpati""",
"""Nkwen""",
"""Anyang""",
"""Bagangu""",
"""Mangkunge""",
"""Mankon""",
"""Mbrerewi""",
"""Mbutu""",
"""Njong""",
"""Shomba""",
"""Songwa""",
"""Pinyin""",
"""Wat""",
"""Wiyeh""",
"""Mbe'""",
"""Jui""",
"""Koffa""",
"""Kom""",
"""Lus""",
"""Manang""",
"""Mbah""",
"""Mballa""",
"""Mbat""",
"""Mbibji""",
"""Ncha""",
"""Mfe""",
"""Nkot""",
"""Ntem""",
"""Ntong""",
"""Bangang""",
"""Banti""",
"""Bechati""",
"""Besali""",
"""Folepi""",
"""Iguambo""",
"""Nko""",
"""Njen""",
"""Ngoshie""",
"""Banya""",
"""Basa""",
"""Ikweri""",
"""Konda""",
"""Ngwo""",
"""Okorobi""",
"""Zang""",
"""Moghamo""",
"""Ngamambo""",
"""Ndemli""",
"""Bum""",
"""Kung""",
"""Fungom""",
"""Nyos""",
"""Oku""",
"""Lamnso'""",
"""Vengo""",
"""Bamunka""",
"""Wushi""",
"""Isu""",
"""Kuk""",
"""Laimbue""",
"""Weh""",
"""Zhoa""",
"""Busam""",
"""Manta""",
"""Menka""",
"""Osatu""",
"""Nde-Gbite""",
"""Viti""",
"""Tesu""",
"""Sambe""",
"""Toro""",
"""Eggon""",
"""Lijili""",
"""Tanjijili""",
"""Firan""",
"""Ganang""",
"""Izere""",
"""Kachichere""",
"""Kafanchan""",
"""Kagoro""",
"""Katab""",
"""Sholio""",
"""Cen""",
"""Du-Ropp-Rim""",
"""Fan-Foron-Heikpang""",
"""Gyell-Kuru-Vwang""",
"""Hoss""",
"""Eten""",
"""Zwall""",
"""Mbeci""",
"""Mbeji""",
"""Ikulu""",
"""Idon""",
"""Iku-Gora-Ankwa""",
"""Kachia""",
"""Kajuru""",
"""Minna""",
"""Kuturmi""",
"""Rukul""",
"""Horom""",
"""Legeri""",
"""Vaghat""",
"""Ya""",
"""Itarok""",
"""Itarok Oga Asa""",
"""Izini""",
"""Selyer""",
"""Yangkam""",
"""Bu""",
"""Che""",
"""Nindem""",
"""Kanufi""",
"""Mada""",
"""Ninzo""",
"""Numana""",
"""Numbu""",
"""Nunku""",
"""Rindre""",
"""Kamantan""",
"""Hyam""",
"""Kurmin Dangana""",
"""Shamang""",
"""Shang""",
"""Zhire""",
"""Koron Ache""",
"""Koron Panda""",
"""Gwara""",
"""Idun""",
"""Buzi""",
"""Nyenkpa""",
"""Panda""",
"""Tattara""",
"""Beezen""",
"""Lufu""",
"""Kapya""",
"""Yukuben""",
"""Aje""",
"""Arigidí""",
"""Erúsú""",
"""Ese""",
"""Igasi""",
"""Ojo""",
"""Oyin""",
"""Udo""",
"""Uro""",
"""Òge""",
"""Àhàn""",
"""Ede Nago""",
"""Awori""",
"""Aworo""",
"""Bunu""",
"""Egba""",
"""Ekiti""",
"""Gbedde""",
"""Igbonna""",
"""Ijebu""",
"""Ijesha""",
"""Ikale""",
"""Ila""",
"""Ilaje""",
"""Iworro""",
"""Jumu""",
"""Ondo""",
"""Owe""",
"""Oyo""",
"""Wo""",
"""Yagba""",
"""Ulukwumi""",
"""Mokole""",
"""Ilodji""",
"""Ede Idaca""",
"""Djama""",
"""Tschetti""",
"""Manigri-Kambolé Ede Nago""",
"""Isekiri""",
"""Anyugba""",
"""Ebu""",
"""Ibaji""",
"""Idah""",
"""Ife""",
"""Ogugu""",
"""Emughan""",
"""Okpeden""",
"""Otapha""",
"""Arughunya""",
"""Kugbo""",
"""Obulom""",
"""Anyama""",
"""Oloibiri""",
"""Ogbogolo""",
"""Ogbronuagum""",
"""Ikot Ekpene""",
"""Ukanafun""",
"""Efik""",
"""Enyong""",
"""Itak""",
"""Nsit""",
"""Ukwa""",
"""Etebi""",
"""Ito""",
"""Itu Mbon Uzo""",
"""Nkari""",
"""Ebughu""",
"""Uda""",
"""Ibino""",
"""Iko""",
"""Ilue""",
"""Idere""",
"""Ibot Obolo""",
"""Ngo""",
"""Okoroete""",
"""Unyeada""",
"""Okobo""",
"""Oro""",
"""Usaghade""",
"""Bomu""",
"""Dere""",
"""Kibangha""",
"""Boúe""",
"""Ken-Khana""",
"""Norkhana""",
"""Nyo-Kana""",
"""Yeghe""",
"""Tee""",
"""Kesari""",
"""Eleme""",
"""Bakpinka""",
"""Doko-Uyanga""",
"""Ugep""",
"""Nkukoli""",
"""Apiapum""",
"""Ekama""",
"""Oferikpe""",
"""Ofombonga""",
"""Ofonokpan""",
"""Okom""",
"""Osopong""",
"""Leyigha""",
"""Okuni""",
"""Olulumo""",
"""Mtezi""",
"""Ugbala""",
"""Uzekwe""",
"""Ufia""",
"""Ufiom""",
"""Abini""",
"""Adim""",
"""Erei""",
"""Etono""",
"""Agwagwune""",
"""Orum""",
"""Kohumono""",
"""Umon""",
"""Etono""",
"""Ikun""",
"""Ugbem""",
"""Utuma""",
"""Korop""",
"""Ukpet""",
"""Assaikio""",
"""Doma""",
"""Keana""",
"""Idoma South""",
"""Idoma West""",
"""Okpogu""",
"""Nkum Akpambe""",
"""Yala Ogoja""",
"""Ito""",
"""Oju""",
"""Worku""",
"""Ijiegu""",
"""Igbuduya""",
"""Ubye""",
"""Upata""",
"""Aluu""",
"""Apani""",
"""Egbedna""",
"""Elele""",
"""Emowhua""",
"""Ibaa""",
"""Igwuruta""",
"""Ipo""",
"""Isiokpo""",
"""Ndele""",
"""Obio""",
"""Ogbakiri""",
"""Omagwna""",
"""Omerelu""",
"""Omudioga""",
"""Rumuji""",
"""Ubima""",
"""Ikwo""",
"""Izi""",
"""Mgbo""",
"""Aniocha""",
"""Bonny-Opobo""",
"""Eche""",
"""Egbema""",
"""Mbaise""",
"""Ngwa""",
"""Nsa""",
"""Nsuka""",
"""Oguta""",
"""Ohuhu""",
"""Oka""",
"""Onitsha""",
"""Orlu""",
"""Owerri""",
"""Umuahia""",
"""Unwana""",
"""Igburu-Usomini""",
"""Ndoni""",
"""Ukwuani""",
"""Pindiga""",
"""Jan-Awei""",
"""Jiba""",
"""Garbabi""",
"""Gayam""",
"""Takum""",
"""Wannu""",
"""Wãpha""",
"""Eneeme""",
"""Kporo""",
"""Nama""",
"""Nzare""",
"""Jiru""",
"""Nye""",
"""Shoo""",
"""Bissaula""",
"""Donga""",
"""Eregba""",
"""Kente""",
"""Kumbo""",
"""Takum""",
"""Jenuwa""",
"""Kentin""",
"""Kunabe""",
"""Lissam""",
"""Bassa-Kontagora""",
"""Dungu""",
"""Niragu""",
"""Kaivi""",
"""Kinuku""",
"""Kono""",
"""Kurama""",
"""Mala""",
"""Ruma""",
"""Shuwa-Zamani""",
"""Surubu""",
"""Tumi""",
"""Vono""",
"""Shau""",
"""Si""",
"""Takaya""",
"""Ningi""",
"""Kudu""",
"""Gusu""",
"""Jere""",
"""Ribina""",
"""Panawa""",
"""Iguta""",
"""Janji""",
"""Tunzu""",
"""Ziriya""",
"""Tsuvadi""",
"""Ashen""",
"""Dabai""",
"""Lila""",
"""Ribah""",
"""Damakawa""",
"""Western Duka""",
"""Wuri""",
"""Jiir""",
"""Kag""",
"""Koor""",
"""Kur""",
"""Ror""",
"""Zuksun""",
"""Regi""",
"""Tiyal""",
"""Shama""",
"""Supana""",
"""Wayam-Rubu""",
"""Fungwa""",
"""Gurmana""",
"""Asebi""",
"""Awege""",
"""Azhiga""",
"""Cagere""",
"""Camajere""",
"""Cansu""",
"""Caundu""",
"""Ubwebwe""",
"""Lopa""",
"""Koto""",
"""Okene""",
"""Gade""",
"""Kaduna""",
"""Karu""",
"""Kuta""",
"""Louome""",
"""Ngenge""",
"""Tawari""",
"""Vwezhi""",
"""Gayegi""",
"""Gbagyi Nkwa""",
"""Izem""",
"""Jezhu""",
"""Kong""",
"""Kwali""",
"""Kwange""",
"""Paiko""",
"""Wahe""",
"""Gupa""",
"""Gbanmi-Sokun Kakanda""",
"""Kami""",
"""Kupa""",
"""Nupe Tako""",
"""Oko""",
"""Osayen""",
"""Ishe""",
"""Kakumo""",
"""Tita""",
"""Ega""",
"""Mobumrin Aizi""",
"""Tiagbamrin Aizi""",
"""Defa""",
"""Deple""",
"""Nigagba""",
"""Nyinagbi""",
"""Wané""",
"""Guebie""",
"""Kpakolo""",
"""Nekedi""",
"""Niabre""",
"""Zadie""",
"""Zebie""",
"""Kouya""",
"""Dlogo""",
"""Glibe""",
"""Jluko""",
"""Kagbo""",
"""Koyo""",
"""Nugbo""",
"""Nyago""",
"""Tiglu""",
"""Soubré""",
"""Kodia""",
"""Lozoua""",
"""Neyo""",
"""Kuwaa""",
"""Kplor""",
"""Gba Sor""",
"""Gbor""",
"""Hwen Gba Kon""",
"""Mabahn""",
"""Rivercess Bassa""",
"""Wedebo""",
"""Dorobo""",
"""Globo""",
"""Nyenebo""",
"""Trembo""",
"""Dediebo""",
"""Gederobo""",
"""Nyanoun""",
"""Tuobo""",
"""E Je""",
"""Fopo-Bua""",
"""Gbepo""",
"""Jedepo""",
"""Klepo""",
"""Nitiabo""",
"""Sabo""",
"""Tuobo""",
"""Webo""",
"""Palipo""",
"""Tienpo""",
"""Jabo""",
"""Nyabo""",
"""Wrelpo""",
"""Gbowe-Hran""",
"""Pie""",
"""Trepo""",
"""Wlepo""",
"""Wluwe-Hawlo""",
"""Yapo""",
"""Yrewe""",
"""Dapo""",
"""Glawlo""",
"""Honpo""",
"""Plapo""",
"""Tepo""",
"""Wlopo""",
"""Yrepo""",
"""Eastern Klaoh""",
"""West Central Klaoh""",
"""Western Klaoh""",
"""Tajuasohn""",
"""Kanneh""",
"""Konobo""",
"""Tchien""",
"""Twabo""",
"""Glio-Oubi""",
"""Fleo""",
"""Gboo""",
"""Neao""",
"""Nyeo""",
"""Zaa""",
"""Zagna""",
"""Zagne""",
"""Zibiao""",
"""Nidrou""",
"""Kabade""",
"""Nomopo""",
"""Putu""",
"""Sinkon""",
"""Waya""",
"""Gbaeson""",
"""Gbarbo""",
"""Gbo""",
"""Gborbo""",
"""Kpeaply""",
"""Pewa""",
"""Plo""",
"""Nyedebwa""",
"""Sémien""",
"""Tao""",
"""Gbugbla""",
"""Krobo""",
"""Ningo""",
"""Osu""",
"""Shai""",
"""Ga""",
"""Dogo""",
"""Hwe""",
"""Sikpi""",
"""Tado""",
"""Tala""",
"""Ayizo-Seto""",
"""Ayizo-Tori""",
"""Kadagbe""",
"""Ci Gbe""",
"""Defi Gbe""",
"""Eastern Xwla Gbe""",
"""Arohun""",
"""Gbekon""",
"""Kpase""",
"""Alada""",
"""Asento""",
"""Gbekon""",
"""Gun""",
"""Phela""",
"""Savi""",
"""Seto""",
"""Toli""",
"""Weme""",
"""Kotafon Gbe""",
"""Maxi Gbe""",
"""Saxwe""",
"""Se""",
"""Tofin Gbe""",
"""Weme Gbe""",
"""Western Xwla Gbe""",
"""Wudu""",
"""Xwela Gbe""",
"""Aguna""",
"""Agu""",
"""Anglo""",
"""Aveno""",
"""Awuna""",
"""Be""",
"""Gbin""",
"""Ho""",
"""Hudu""",
"""Kotafoa""",
"""Kpelen""",
"""Togo""",
"""Vlin""",
"""Vo""",
"""Anexo""",
"""Gliji""",
"""Gen""",
"""Kpessi""",
"""Waci Gbe""",
"""Tafi""",
"""Animere""",
"""Ikponu""",
"""Iwi""",
"""Litime""",
"""Logbo""",
"""Uma""",
"""Tuwuli""",
"""Upper Adele""",
"""Ananjubi""",
"""Balanka""",
"""Gikolodjya""",
"""Gilempla""",
"""Giseda""",
"""Gisème""",
"""Boro""",
"""Lolobi""",
"""Sekwa""",
"""Selee""",
"""Logba""",
"""Ogbru""",
"""Kos""",
"""Morie""",
"""Tioffo""",
"""Adioukrou""",
"""Ketin""",
"""Naindin""",
"""Avikam""",
"""Mbato""",
"""Ahafo""",
"""Akuapem""",
"""Akyem Bosome""",
"""Asante""",
"""Asen""",
"""Dankyira""",
"""Fante""",
"""Kwawu""",
"""Fianse""",
"""Alangua""",
"""Ano""",
"""Aowin""",
"""Barabo""",
"""Bini""",
"""Bona""",
"""Djuablin""",
"""Indenie""",
"""Moronou""",
"""Sanvi""",
"""Anyin Morofo""",
"""Baoulé""",
"""Sehwi""",
"""Pepesa""",
"""Gonja""",
"""Nkonya""",
"""Nterato""",
"""Ginyanga""",
"""Nawuri""",
"""Southern Chumburung""",
"""Yeji""",
"""Kenyen""",
"""Wiase""",
"""Kplang""",
"""Krache""",
"""Nchumbulu""",
"""Tchumbuli""",
"""Awutu""",
"""Senya""",
"""Boso""",
"""Larteh""",
"""Krobu""",
"""Beti""",
"""Bolgo Kubar""",
"""Bon Gula""",
"""Kawaway""",
"""Southern Fania""",
"""Patool""",
"""Pongaal""",
"""Tiaala""",
"""Tiitaal""",
"""Koke""",
"""Niellim""",
"""Tchini""",
"""Noy""",
"""Tunya""",
"""Zan""",
"""Bouna""",
"""Ngalo""",
"""Takawa-Béngoro""",
"""Goundo""",
"""Gerep""",
"""Kolop""",
"""Kosop""",
"""Ngomi""",
"""Karang""",
"""Sakpu""",
"""Tale""",
"""Nzakambay""",
"""Zoli""",
"""Man""",
"""Pana""",
"""Pondo""",
"""Kuo""",
"""Mboum""",
"""Ndai""",
"""Imbana""",
"""Kiziere""",
"""Kiziere""",
"""Torrock-Kaélé""",
"""Pam""",
"""Bang-Were""",
"""Faale-Piyew""",
"""Podokge""",
"""To""",
"""Oblo""",
"""Kumba""",
"""Gnoore""",
"""Gola""",
"""Gongla""",
"""Jalingo""",
"""Jeng""",
"""Kasaa""",
"""Kugong""",
"""Kwaji""",
"""Lankaviri""",
"""Mang""",
"""Meeka""",
"""Nyaaja""",
"""Saawa""",
"""Sagbee""",
"""Shaari""",
"""Yaa""",
"""Yakoko""",
"""Yoro""",
"""Zinna""",
"""Komo""",
"""Pangseng""",
"""Rang""",
"""Kpasam""",
"""Yotti""",
"""Yendang""",
"""Goom""",
"""Home""",
"""Mambe'""",
"""Mamna'a""",
"""Ngbang""",
"""Nyok""",
"""Sagzee""",
"""Vaazin""",
"""Saan""",
"""Duupa""",
"""Duli""",
"""Wom""",
"""Deenu""",
"""Samba Leko""",
"""Samba de Wangai""",
"""Sampara""",
"""Nimbari""",
"""Peer Muure""",
"""Zongbi""",
"""Sewe""",
"""Teere""",
"""Gomme""",
"""Gomnome""",
"""Koma Damti""",
"""Leelu""",
"""Liu""",
"""Ndera""",
"""Koma Ndera""",
"""Yeru""",
"""Zanu""",
"""Mom Jango""",
"""Joto""",
"""Linda""",
"""Ndokpa""",
"""Ngapo""",
"""Buru""",
"""Gbaga-South""",
"""Gbambiya""",
"""Govoro""",
"""Hai""",
"""Ka""",
"""Mbi""",
"""Ndi""",
"""Ngalabo""",
"""Ngola""",
"""Banda-Banda""",
"""Vidiri""",
"""Wundu""",
"""Mbre""",
"""Moruba""",
"""Sabanga""",
"""Wada""",
"""Banda-Ndélé""",
"""Junguru""",
"""Ngao""",
"""Ngbala""",
"""Tangbago""",
"""Kpagua""",
"""Dukpu""",
"""Wasa""",
"""Yakpa""",
"""Bubanda""",
"""Galaba""",
"""Kaga""",
"""Mpaka""",
"""Ngundu""",
"""Vara""",
"""Kala""",
"""Ngbundu""",
"""Ngbugu""",
"""Gbaga-Nord""",
"""Gbi""",
"""Vita""",
"""Wojo""",
"""Mbangi""",
"""Northern Ngbandi""",
"""Sango""",
"""Southern Ngbandi""",
"""Yakoma""",
"""Ndunga""",
"""Tora""",
"""Madipia""",
"""Ngbaka Ma'bo""",
"""Gbanziri""",
"""Yaka""",
"""Gundi""",
"""Limassa""",
"""Yango""",
"""Monzombo""",
"""Mangayat""",
"""Togoyo""",
"""Belanda Viri""",
"""Sere""",
"""Tagbu""",
"""Ngala-Santandrea""",
"""Pambia""",
"""Geme Tulu""",
"""Nzakara""",
"""Makaraka""",
"""Gbaya of Boda""",
"""Bokoto""",
"""Bozom""",
"""Diabe""",
"""Gbabana""",
"""Suma""",
"""North Bangato""",
"""Southwest Gbaya""",
"""Bodoe""",
"""Gaymona""",
"""Gbaya Kara""",
"""Gbeya""",
"""Lai""",
"""Lombu""",
"""Mbai""",
"""Mbere""",
"""Mombe""",
"""Yaáyuwee""",
"""Gbagiri""",
"""Gbanu""",
"""Ngbaka Manza""",
"""Ngbaka""",
"""Gbaya-Mbodomo""",
"""Koniko""",
"""Mandiakuy""",
"""Mao""",
"""Togo""",
"""Wahu""",
"""Cwi Bwamu""",
"""Láá Láá Bwamu""",
"""Konni""",
"""Northern Gourmanchema""",
"""Southern Gourmanchema""",
"""Ligbeln""",
"""Likoonli""",
"""Limonkpel""",
"""Linafiel""",
"""Motiem""",
"""Ceemba""",
"""Linangmanli""",
"""Ncanm""",
"""Ntaapum""",
"""Yom""",
"""Frafra""",
"""Gudeni""",
"""Gurune""",
"""Nabt""",
"""Nankana""",
"""Nankani""",
"""Talni""",
"""Nabit""",
"""Saremdé""",
"""Taolendé""",
"""Yaadré""",
"""Yaande""",
"""Yana""",
"""Zaore""",
"""'Dolimi""",
"""Cherii""",
"""Fufula""",
"""Yeri Waali""",
"""Southern Dagaare""",
"""Wile""",
"""Southern Birifor""",
"""Nura""",
"""Wule""",
"""Safaliba""",
"""Yazori""",
"""Langantere""",
"""Murugu""",
"""Kamara""",
"""Toende""",
"""Western Mampruli""",
"""Miyobe""",
"""Gouande""",
"""Materi""",
"""Pingou""",
"""Porga""",
"""Tangeta""",
"""Tihoun""",
"""Western Ditammari""",
"""Mbelime""",
"""Nateni""",
"""Okoni""",
"""Tayari""",
"""Tangamma""",
"""Fulse""",
"""Koromba""",
"""Western Koromfe""",
"""Khe""",
"""Gbogorose""",
"""Klamaasise""",
"""Lutise""",
"""Mesise""",
"""Sukurase""",
"""Khisa""",
"""Kaansa""",
"""Kewe""",
"""Kijang""",
"""Lama-Tissi""",
"""Kadjala""",
"""Kande""",
"""Lukpa""",
"""Kusuntu""",
"""Delo""",
"""Tem""",
"""Tampulma""",
"""Buge""",
"""Longoro""",
"""Mangum""",
"""Western Sisaala""",
"""Pasaali""",
"""Isala""",
"""Nsihaa""",
"""Potule""",
"""Siti""",
"""Winyé""",
"""Logremma""",
"""Kandéré""",
"""Northern Lyélé""",
"""Southern Lyélé""",
"""Fere""",
"""Lela""",
"""Kasem""",
"""Nunuma""",
"""West Kasem""",
"""Northwestern Nuni""",
"""Bwana""",
"""Gori""",
"""Micari""",
"""Sankura""",
"""Yatini""",
"""Pana South""",
"""Gouindougouba""",
"""Niangoloko-Diarabakoko""",
"""Soubakanedougou""",
"""Douna""",
"""Lala""",
"""Roba""",
"""Voro""",
"""Kaan""",
"""Handa""",
"""Mboi""",
"""Leelau""",
"""Moo""",
"""Loo""",
"""Zo""",
"""Mághdì""",
"""Kaigama""",
"""Laredo""",
"""Mingang Doso""",
"""Tha""",
"""Kwa""",
"""Nya Dele""",
"""Nya Guyuwa""",
"""Nya Gwanda""",
"""Nya Tariya""",
"""Kamo""",
"""Naaban""",
"""Loofaa""",
"""Loofiyo""",
"""Tunga""",
"""Dijim""",
"""Kutule""",
"""Yili""",
"""Gusubou""",
"""Swabou""",
"""Waja""",
"""Sekwa""",
"""Téén""",
"""Kaouara-Timba-Sindou-Koroni""",
"""Palen""",
"""Negueni-Klani""",
"""Ouatourou-Niasogoni""",
"""Soulani""",
"""Noumoudara-Koumoudara""",
"""Ter""",
"""Tru""",
"""Wenteene""",
"""Southern Toussian""",
"""Viemo""",
"""Kafire""",
"""Kandere""",
"""Kasara""",
"""Kufuru""",
"""Kulere""",
"""Nafara""",
"""Papara""",
"""Patara""",
"""Pogara""",
"""Southwest Senari""",
"""Tagara""",
"""Tagbari""",
"""Takpasyeeri""",
"""Tenere""",
"""Tyebara""",
"""Senara Sénoufo""",
"""Tenyer""",
"""Kle Noehmõ""",
"""Koloo""",
"""Kujaa""",
"""Mìjuu""",
"""Nafãã""",
"""Nejuu""",
"""Suõõ""",
"""Sõghoo""",
"""Nanerigé Sénoufo""",
"""Sìcìté Sénoufo""",
"""Djafolo""",
"""Dofana""",
"""Foolo""",
"""Singala""",
"""Pantera""",
"""Nyarafolo Senoufo""",
"""Palaka Senoufo""",
"""Fondebougou""",
"""Fourgoula""",
"""Gbo""",
"""Katiara""",
"""Katiola""",
"""Niakaramadougou""",
"""Niangbo""",
"""Niediekaha""",
"""Tafire""",
"""Bveri""",
"""Dourbeye""",
"""Fali-Tinguelin""",
"""Kangou""",
"""Mbre""",
"""Mpra""",
"""Northern Emberá""",
"""Emberá-Tadó""",
"""Caramanta""",
"""Woun Meu""",
"""Kamma So""",
"""Toro So Dogon""",
"""Ben Tey Dogon""",
"""Nanga""",
"""Nadjamba""",
"""Tebul Ure Dogon""",
"""Yanda Dom Dogon""",
"""Domno""",
"""Gono""",
"""Guru""",
"""Toro Tegu Dogon""",
"""Sagara""",
"""Tengu Tingi""",
"""Togo Kan""",
"""Tomo Kan Dogon""",
"""Bunoge Dogon""",
"""Mombo Dogon""",
"""Penange""",
"""Tiranige Diga Dogon""",
"""Abu""",
"""Sabu""",
"""Gorovu""",
"""Southern Ambakich""",
"""Chambri""",
"""Yimas""",
"""Murik""",
"""Anor""",
"""Ndramini'o""",
"""Tanggu""",
"""Tanguat""",
"""Sepen""",
"""Boroi""",
"""Botbot""",
"""Awar""",
"""Bosngun""",
"""Watam""",
"""Romkun""",
"""Inapang""",
"""Kominimung""",
"""ǂHua""",
"""Sekele""",
"""Nogau""",
"""Mara""",
"""Wandarang""",
"""Ixil""",
"""Tektiteko""",
"""Tz'utujil""",
"""K'iche'""",
"""Sacapulteco""",
"""Sipacapense""",
"""Kekchí""",
"""Poqomchi'""",
"""Uspanteco""",
"""Miramar Chontal""",
"""Tamulté de las Sábanas Chontal""",
"""Chortí""",
"""Epigraphic Mayan""",
"""Tenango""",
"""Tzotzil""",
"""Tojolabal""",
"""Q'anjob'al""",
"""Western Kanjobal""",
"""Tuzanteco""",
"""Mopán Maya""",
"""Najá""",
"""Yucatec Maya""",
"""Huastec""",
"""Coatlín Mixe""",
"""Isthmus Mixe""",
"""Mazatlán Mixe""",
"""Ocotepec Mixe""",
"""Cotzocón Mixe""",
"""Mixe de San Juan Cotzocón""",
"""Mixistlan""",
"""Olotepec""",
"""Puxmetecín""",
"""Zacatepec""",
"""Tlahuitoltepec Mixe""",
"""Totontepec Mixe""",
"""Ulterior-Mixe""",
"""Oluta Popoluca""",
"""Sayula Popoluca""",
"""Tapachultec""",
"""Ostuacín""",
"""San Pedro Yaspac""",
"""Jitotolteco""",
"""Rayón Zoque""",
"""Chimalapa Zoque""",
"""Tabasco Zoque""",
"""Texistepec Popoluca""",
"""Krenak""",
"""Djeoromitxí""",
"""Xakriabá""",
"""Xavánte""",
"""Xerénte""",
"""Kimda""",
"""Paraná Kaingang""",
"""Southeast Kaingang""",
"""Southwest Kaingang""",
"""São Paulo Kaingáng""",
"""Xokleng""",
"""Kayapó-Kradaú""",
"""Xikrin""",
"""Panará""",
"""Yaruma""",
"""Ramkokamekra""",
"""Krahô""",
"""Kreye""",
"""Timbira""",
"""Pará Gavião""",
"""Malali""",
"""Pataxó Hã-Ha-Hãe""",
"""Macuni""",
"""Maxakalí""",
"""Ofayé""",
"""Rikbaktsa""",
"""Ipalapa Amuzgo""",
"""San Pedro Amuzgos Amuzgo""",
"""Teutila Cuicatec""",
"""Ixtayutla Mixtec""",
"""Jamiltepec Mixtec""",
"""San Juan Colorado Mixtec""",
"""Santa María Zacatepec Mixtec""",
"""Mitlatongo Mixtec""",
"""Santa María Peñoles""",
"""Santiago Tlazoyaltepec""",
"""San Miguel Piedras Mixtec""",
"""Sindihui Mixtec""",
"""Tamazola Mixtec""",
"""Yutanduchi Mixtec""",
"""Tlazoyaltepec Mixtec""",
"""Cuatzoquitengo""",
"""Plan de Guadalupe""",
"""Potoichan""",
"""Tototepec""",
"""Xochapa Mixtec""",
"""Metlatónoc Mixtec""",
"""Yoloxochitl Mixtec""",
"""Mixtepec Mixtec""",
"""Southeastern Nochixtlán Mixtec""",
"""Soyaltepec Mixtec""",
"""Cuyamecalco Mixtec""",
"""Tidaá Mixtec""",
"""Chazumba Mixtec""",
"""Chigmecatitlán Mixtec""",
"""Southern Puebla Mixtec""",
"""Juxtlahuaca Mixtec""",
"""San Juan Piñas""",
"""San Martín Peras""",
"""Yucu Ñuti""",
"""Itundujia Mixtec""",
"""San Cristóbal Amoltepec Mixtec""",
"""San Mateo Peñasco Mixtec""",
"""San Miguel Achiutla Mixtec""",
"""Santo Domingo Heundío Mixtec""",
"""Yosoñama""",
"""San Pedro Molinos""",
"""Santa Catarina Ticuá""",
"""Santa María Yosoyúa""",
"""Santa Lucía Monteverde Mixtec""",
"""Sinicahua Mixtec""",
"""Yucuhiti""",
"""Tacahua Mixtec""",
"""Tijaltepec Mixtec""",
"""Yosondúa Mixtec""",
"""Yucuañe Mixtec""",
"""Copala Triqui""",
"""San Martín Itunyoso Triqui""",
"""San Vicente Coyotepec Popoloca""",
"""Mezontla Popoloca""",
"""Santa María Nativitas""",
"""San Juan Atzingo Popoloca""",
"""San Luís Temalacayuca Popoloca""",
"""San Marcos Tlalcoyalco Popoloca""",
"""Todos Santos Almolonga Popoloca""",
"""Ixcatec""",
"""San Francisco Huehuetlán Mazatec""",
"""San Lorenzo Cuanecuiltitla Mazatec""",
"""San Lucas Zoquiapan Mazatec""",
"""San San Jerónimo Mazatec""",
"""Santa Ana Ateixtlahuaca Mazatec""",
"""Santa Cruz Ocopetatillo Mazatec""",
"""Soyaltepec Mazatec""",
"""Ixcatlán Mazatec""",
"""Chiquihuitlán Mazatec""",
"""Jalapa De Díaz Mazatec""",
"""San Miguel""",
"""Zoyaltitla""",
"""Nopala Chatino""",
"""San Juan Quiahije Chatino""",
"""Yaitepec Chatino""",
"""Zacatepec Chatino""",
"""Tataltepec Chatino""",
"""Zenzontepec Chatino""",
"""Teojomulco Chatino""",
"""San Baltazar Loxicha Zapotec""",
"""San Vicente Coatlán Zapotec""",
"""Ayoquesco Zapotec""",
"""Chichicapan Zapotec""",
"""Guevea De Humboldt Zapotec""",
"""Güilá Zapotec""",
"""Isthmus Zapotec""",
"""Lachiguiri Zapotec""",
"""Mazaltepec Zapotec""",
"""Ocotlán Zapotec""",
"""Petapa Zapotec""",
"""Quiavicuzas Zapotec""",
"""San Martín Tilcajete Zapotec""",
"""Teotitlán del Valle Zapotec""",
"""San Pedro Quiatoni Zapotec""",
"""Santa Catarina Albarradas Zapotec""",
"""Santa María Quiegolani Zapotec""",
"""Santo Domingo Albarradas Zapotec""",
"""Tejalapan Zapotec""",
"""Tilquiapan Zapotec""",
"""Zaachila Zapotec""",
"""Yaganiza-Xagacía Zapotec""",
"""Choapan Zapotec""",
"""Rincón Zapotec""",
"""Sierra de Juárez Zapotec""",
"""Southeastern Ixtlán Zapotec""",
"""Southern Rincon Zapotec""",
"""Tabaa Zapotec""",
"""Yalálag Zapotec""",
"""Yareni Zapotec""",
"""Yatee Zapotec""",
"""Yatzachi Zapotec""",
"""Yalina""",
"""Zoogocho""",
"""Coatecas Altas Zapotec""",
"""Lapaguía-Guivini Zapotec""",
"""San Agustín Loxicha Zapotec""",
"""Miahuatlan Zapotec""",
"""San Marcial Ozolotepec Zapotec""",
"""San Agustín Mixtepec Zapotec""",
"""Yautepec Zapotec""",
"""Quioquitani Zapotec""",
"""Santiago Xanica Zapotec""",
"""Tlacolulita Zapotec""",
"""Xadani Zapotec""",
"""Xanaguía Zapotec""",
"""Texmelucan Zapotec""",
"""Zaniza Zapotec""",
"""Lachixío Zapotec""",
"""Sochiapam Chinantec""",
"""Tlacoatzintepec Chinantec""",
"""Usila Chinantec""",
"""Tepetotutla Chinantec""",
"""Valle Nacional Chinantec""",
"""Lealao Chinantec""",
"""Tepinapa Chinantec""",
"""San Francisco Matlatzinca""",
"""San Miguel Tenoxtitlán""",
"""Santa María Citendejé-Banos""",
"""Michoacán Mazahua""",
"""Ixtenco Otomi""",
"""Tenango Otomi""",
"""Texcatepec Otomi""",
"""Tilapa Otomi""",
"""Querétaro Otomi""",
"""Temoaya Otomi""",
"""Northern Pame""",
"""Southern Pame""",
"""Mangue""",
"""Platanillo""",
"""Zapotitlán Tablas""",
"""Azoyú Me'phaa""",
"""Malinaltepec""",
"""Zilacayotitlán""",
"""Tlacoapa Me'phaa""",
"""Subtiaba""",
"""Amal""",
"""Sepik Iwam""",
"""Wogamusin""",
"""Bongos""",
"""Tau""",
"""Wasambu""",
"""Mende""",
"""Nukuma""",
"""Karawa""",
"""Pouye""",
"""Nigilu""",
"""Wagu""",
"""Kapriman""",
"""Watakataui""",
"""Mari""",
"""Sumariup""",
"""Kuvenmas""",
"""Kaningra""",
"""Lower Lagaip""",
"""North Hewa""",
"""Upper Lagaip""",
"""Meiyari""",
"""Setiali""",
"""Piame""",
"""Saniyo""",
"""Yawu""",
"""Kalou""",
"""Pasi""",
"""Pahi""",
"""Awun""",
"""Namia""",
"""Ha""",
"""Meifu""",
"""Qi""",
"""En""",
"""Langnian Buyang""",
"""Yerong""",
"""Qabiao""",
"""Laha""",
"""Red Gelao""",
"""Gelao Mulao""",
"""Qau""",
"""White Gelao""",
"""Liputiõ""",
"""White Lachi""",
"""Nong Zhuang""",
"""Khen Lài""",
"""Nùng An""",
"""Nùng Cháo""",
"""Nùng Inh""",
"""Nùng Lòi""",
"""Nùng Phan Slình""",
"""Nùng Qúy Rin""",
"""Xuòng""",
"""Yang Zhuang""",
"""Thai Song""",
"""Yong""",
"""Tai Mene""",
"""Tày Tac""",
"""North Burma Khamti""",
"""Sinkaling Hkamti""",
"""Khamyang""",
"""Phake""",
"""Turung""",
"""Tai Mao""",
"""Tai Pong""",
"""Yongren""",
"""Nan""",
"""Tai Wang""",
"""Tai Long""",
"""Tai Laing""",
"""Tai Ya""",
"""Tai Thanh""",
"""Lao-Khrang""",
"""Luang Prabang""",
"""Pakse""",
"""Savannakhet""",
"""Vientiane""",
"""Northern Isan""",
"""Southern Isan. Korat""",
"""Yoy""",
"""Thai Malay""",
"""Phuan""",
"""Tày Sa Pa""",
"""Eastern Tày""",
"""Northern Tày""",
"""Southern Tày""",
"""Tày Bao Lac""",
"""Tày Trung Khanh""",
"""Qianxi""",
"""Qianzhong""",
"""Cao Lan""",
"""Central Hongshuihe Zhuang""",
"""E""",
"""Eastern Hongshuihe Zhuang""",
"""Guibei Zhuang""",
"""Guibian Zhuang""",
"""Kuan""",
"""Lianshan Zhuang""",
"""Liujiang Zhuang""",
"""Liuqian Zhuang""",
"""Qiubei Zhuang""",
"""Na Kadok""",
"""Tay Khang""",
"""Ts'ün-Lao""",
"""Youjiang Zhuang""",
"""Yongnan Zhuang""",
"""Zuojiang Zhuang""",
"""Rien""",
"""Qiongshan""",
"""Naxi Yao""",
"""Northern Dong""",
"""Southern Dong""",
"""Mulam""",
"""Di'e""",
"""Ching""",
"""Hwa""",
"""Lyo""",
"""Mak""",
"""Maonan""",
"""Pandong""",
"""Sandong""",
"""Hexi""",
"""Huishi""",
"""Dagang-Baoshan-Liangcun""",
"""Yonggu Biao""",
"""Lakkia""",
"""Kitemoka""",
"""Kuyubi""",
"""Torá""",
"""Yaru""",
"""Wari'""",
"""Rocorona""",
"""Lenca-Salvador""",
"""Rawo""",
"""Womo-Sumararu""",
"""Vanimo""",
"""Wutung""",
"""Warapu""",
"""Urartian""",
"""Ticuna""",
"""Wintu""",
"""Patwin""",
"""Rembarunga""",
"""Ngandi""",
"""Nunggubuyu""",
"""Gundjeipme""",
"""Gunei""",
"""Muralidban""",
"""Naiali""",
"""Ngalkbun""",
"""Kunbarlang""",
"""Waray""",
"""Wulwulam""",
"""Önge""",
"""Maregaon""",
"""Pulgaon""",
"""Wani""",
"""Metla-Kinwat""",
"""Naiki""",
"""Utnur""",
"""Kukanar""",
"""Nethanar""",
"""Tiriya""",
"""Mudhili Gadaba""",
"""Pottangi Ollar Gadaba""",
"""Khirwar""",
"""Kalat""",
"""Sarawan""",
"""Oraon""",
"""Nepali Kurux""",
"""Hiranpur""",
"""Litipara""",
"""Sahibganj""",
"""Betta Kurumba""",
"""Holiya""",
"""Jennu Kurumba""",
"""Bijapur""",
"""Jeinu Kuruba""",
"""Old Kannada""",
"""Pani Yerava""",
"""Panjiri Yerava""",
"""Sholaga""",
"""Mele Nadu Irula""",
"""Northern Irula""",
"""Vette Kada Irula""",
"""Muduga""",
"""Aranadan""",
"""Kadar""",
"""Kaikadi""",
"""Kalanadi""",
"""Kanikkaran""",
"""Kurichiya""",
"""Malaryan""",
"""Vettuvan""",
"""Kayavar""",
"""Malabar""",
"""Moplah""",
"""Nagari-Malayalam""",
"""Namboodiri""",
"""Nasrani""",
"""Nayar""",
"""North Kerala""",
"""Malayalam""",
"""Pulaya""",
"""South Kerala""",
"""Mannan""",
"""Mullu Kurumba""",
"""Pathiya""",
"""Thachanadan""",
"""Ullatan""",
"""Urali""",
"""Vishavan""",
"""Wayanad Chetti""",
"""Eravallan""",
"""Kunduvadi""",
"""Mala Malasar""",
"""Malapandaram""",
"""Western""",
"""Old Tamil""",
"""Paniya""",
"""Aiyangar""",
"""Aiyar""",
"""Arava""",
"""Burgandi""",
"""Burma Tamil""",
"""Harijan""",
"""Hebbar""",
"""Kongar""",
"""Madrasi""",
"""Malaya Tamil""",
"""Mandyam Brahmin""",
"""Tamil""",
"""Pattapu Bhasha""",
"""Sanketi""",
"""Secunderabad Brahmin""",
"""South Africa Tamil""",
"""Sri Lanka Tamil""",
"""Tigalu""",
"""Sankara-Yerukala""",
"""Toda""",
"""Mudu""",
"""Onti""",
"""Tappu""",
"""Mudu Koraga""",
"""Kudiya""",
"""Tulu""",
"""Betul""",
"""Bhandara""",
"""Chhindwara""",
"""Mandla""",
"""Nagpur""",
"""Seoni""",
"""Yavatmal""",
"""Bhamragarh""",
"""Etapally Gondi""",
"""Nirmal""",
"""Rajura""",
"""Sironcha""",
"""Utnoor""",
"""Sukma""",
"""Raigarh""",
"""Far Western Muria""",
"""Dhanora""",
"""Sonapal""",
"""Jaganathapuram Koya""",
"""Malakanagiri Koya""",
"""Podia Koya""",
"""Adewada""",
"""Bhamani Maria""",
"""Etapally Maria""",
"""Konda-Dora""",
"""Khondi""",
"""Kuvi""",
"""Indi""",
"""Kumbaran""",
"""Manna-Dora""",
"""Mukha-Dora""",
"""Old Telugu""",
"""Dasaru""",
"""Dommara""",
"""East Godaweri""",
"""Golari""",
"""Guntur""",
"""Kamathi""",
"""Komtao""",
"""Nellore""",
"""Rayalseema""",
"""Salewari""",
"""Srikakula""",
"""Telangana""",
"""Vadaga""",
"""Vadari""",
"""Vishakhapatnam""",
"""Yanadi""",
"""Waddar""",
"""Campo Marino Albanian""",
"""Central Mountain Albanian""",
"""Sicilian Albanian""",
"""South Central Arvanitika""",
"""Thracean Arvanitika""",
"""Camerija""",
"""Korca""",
"""Srem""",
"""Gheg Albanian""",
"""Hieroglyphic Luwian""",
"""Milyan""",
"""Palaic""",
"""Pisidian""",
"""Sidetic""",
"""Akn""",
"""Arabkir""",
"""Artvin""",
"""Ashkharik""",
"""Astrakhan""",
"""Constantinople Armenian""",
"""Crimea""",
"""Dzhulfa""",
"""Eastern Armenian""",
"""Erevan""",
"""Ewdokia""",
"""Hamshen""",
"""Jolfâ""",
"""Karabagh""",
"""Karabagh Shamakhi""",
"""Karin""",
"""Kharberd""",
"""Khoi-Salmst""",
"""Kilikien""",
"""Malatya""",
"""Mus""",
"""North Komedia""",
"""Rodosto""",
"""Sebaste""",
"""Shabin-Karahissar""",
"""Shamakhi""",
"""Smyrna Armenian""",
"""Syria""",
"""Tbilisi""",
"""Tigranakert""",
"""Trabzon""",
"""Urmia-Maragheh""",
"""Van""",
"""Western Armenian""",
"""Tamian""",
"""East Aukštaitian""",
"""Suvalkietiskai""",
"""South Samogitian""",
"""West Samogitian""",
"""Prussian""",
"""Northeast Belarusan""",
"""Southwest Belarusan""",
"""Old Russian""",
"""South Russian""",
"""Northwest Ukrainian""",
"""Southwest Ukrainian""",
"""Pomak""",
"""Southeastern Macedonian""",
"""Western Macedonian""",
"""Old Church Slavonic""",
"""Slavomolisano""",
"""Lower Carniola""",
"""Prekmurski""",
"""Primorski""",
"""Resia""",
"""Stajerski""",
"""Upper Carniola""",
"""Windisch""",
"""Chakavski""",
"""Kaykavski""",
"""Croatian""",
"""Shtokavski""",
"""Shtokavski""",
"""Czecho-Moravian""",
"""Hanak""",
"""Lach""",
"""Northeast Bohemian""",
"""Southwest Bohemian""",
"""Silesian""",
"""Slovak""",
"""Slovincian""",
"""Polabian""",
"""Kamenz""",
"""Lepontic""",
"""Leonais""",
"""Tregorrois""",
"""Vannetais""",
"""Cornish""",
"""Patagonian Welsh""",
"""Southern Welsh""",
"""Manx""",
"""East Sutherlandshire""",
"""Donegal""",
"""Munster-Leinster""",
"""Old Irish""",
"""Noric""",
"""Transalpine Gaulish""",
"""Venetic""",
"""Dacian""",
"""Ostrogoth""",
"""Visigoth""",
"""Jutish""",
"""Jamtska""",
"""Bornholmsk""",
"""Hallaendska""",
"""Skånska""",
"""Laumal""",
"""Northern Swedish""",
"""Nyland Swedish""",
"""Southwest Finland Swedish""",
"""Standard Swedish""",
"""Svea""",
"""Uusimaa Swedish""",
"""Åland Islands Swedish""",
"""Österbotten""",
"""Icelandic""",
"""Norwegian""",
"""Old Norse""",
"""Older Runic""",
"""Hessian Middle High German""",
"""Old Low Franconian""",
"""Mainfränkisch""",
"""Yiddish""",
"""Western""",
"""South Rhine Franconian""",
"""West Franconian""",
"""Limburgish""",
"""Lower Silesian""",
"""Mainfränkisch""",
"""Non-Amish Pennsylvania German""",
"""Berlin German""",
"""Hannover German""",
"""Mansfeld German""",
"""Unserdeutsch""",
"""Thuringian""",
"""Wymysorys""",
"""East Cape Afrikaans""",
"""Orange River Afrikaans""",
"""Oorlams""",
"""Brabants""",
"""Northern North Hollandish""",
"""Oost-Vlaams""",
"""South Guelderish""",
"""Negerhollands""",
"""Javindo""",
"""Petjo""",
"""Frans Vlaams""",
"""Limburgs""",
"""Oostvlaams""",
"""Westvlaams""",
"""Bevelands""",
"""Duvelands""",
"""Flakkees""",
"""Fluplands""",
"""Goerees""",
"""Kezands""",
"""Schouws""",
"""Walchers""",
"""Old Dutch""",
"""Swabian""",
"""Graubenden-Grisons""",
"""Low Alemannic""",
"""Lucerne""",
"""Obwald""",
"""St. Gallen""",
"""Wallis""",
"""Walser""",
"""Viennese German""",
"""Central Bavarian""",
"""North Bavarian""",
"""Northern Bavarian""",
"""South Bavarian""",
"""Southern Bavarian""",
"""Sette Comuni Cimbrian""",
"""Tredici Communi Cimbrian""",
"""Hutterite German""",
"""Frassilongo""",
"""Palú""",
"""Mideastern Yiddish""",
"""Northeastern Yiddish""",
"""Southeastern Yiddish""",
"""Northwestern Yiddish""",
"""Southwestern Yiddish""",
"""Old High German""",
"""South Drente""",
"""East Pomeranian""",
"""Eastphalian""",
"""High East Prussian""",
"""Low East Prussian""",
"""Mecklenburgish""",
"""Schleswig-Holstein Low German""",
"""West Pomeranian""",
"""Mecklenburg-Anterior Pomerania""",
"""Northern Low Saxon""",
"""Veenkoloniaals""",
"""West Groningen""",
"""Westerwolds""",
"""Plautdietsch""",
"""Sallands""",
"""Stellingwerfs""",
"""Twents""",
"""North Veluws""",
"""Westphalien""",
"""Middle Low German""",
"""Saxon""",
"""Old Saxon""",
"""Creolese""",
"""Trinidadian Creole English""",
"""Virgin Islands Creole English""",
"""Turks And Caicos Creole English""",
"""Gullah""",
"""Tobagonian Creole English""",
"""Vincentian Creole English""",
"""Limonese Creole""",
"""Nicaragua Creole English""",
"""San Andres Creole English""",
"""Saramaccan""",
"""Paramaccan""",
"""Sranan Tongo""",
"""Ghanaian Pidgin English""",
"""Krio""",
"""Nigerian Pidgin""",
"""Pijin""",
"""Tok Pisin""",
"""Torres Strait Creole""",
"""Hawai'i Creole English""",
"""Kriol""",
"""Pitcairn-Norfolk""",
"""Maltese English""",
"""New Zealand English""",
"""Pakistani English""",
"""Sri Lankan English""",
"""Middle English""",
"""Northern Scots""",
"""Southern Scots""",
"""Ulster""",
"""Helgoland""",
"""Mooringer""",
"""Sölreng""",
"""Old Frisian""",
"""Saterfriesisch""",
"""Súdhoeksk""",
"""Westerlauwers Fries""",
"""Wâldfrysk""",
"""Cypriot Greek""",
"""Cargese""",
"""Cypriot Greek""",
"""Dimotiki""",
"""Katharevousa""",
"""Mariupol Greek""",
"""Macedonian Greek""",
"""Rumelian""",
"""Thracian""",
"""Salento""",
"""Saracatsan""",
"""Athens""",
"""Megara""",
"""Cycladian""",
"""Ionian Islands""",
"""Northern Epirus""",
"""Peloponnese""",
"""Smyrna Greek""",
"""Dodecanese""",
"""Sille""",
"""Western Cappadocian""",
"""Pontic""",
"""Yevanic""",
"""Mycenaean Greek""",
"""Propontis Tsakonian""",
"""Southern Tsakonian""",
"""Northern Magahi""",
"""Southern Magahi""",
"""Panchpargania""",
"""Barei""",
"""Barmeli""",
"""Central Colloquial Maithili""",
"""Dehati""",
"""Eastern Maithili""",
"""Jolaha""",
"""Kawar""",
"""Kisan""",
"""Kyabrat""",
"""Makrana""",
"""Musar""",
"""Sadri""",
"""Southern Standard Maithili""",
"""Standard Maithili""",
"""Tati""",
"""Western Maithili""",
"""Pali""",
"""Bardiya""",
"""Dang""",
"""Deokhuri""",
"""Kailali""",
"""Kanchanpur""",
"""Surkhet""",
"""Kathoriya Tharu""",
"""Mahottari""",
"""Morangia""",
"""Morangiya""",
"""Saptari""",
"""Sarlahi""",
"""Siraha""",
"""Sunsari""",
"""Udayapur""",
"""Rana Tharu""",
"""Majhi""",
"""Sonha""",
"""Darai""",
"""Dhanwar""",
"""Bojpury""",
"""Domra""",
"""Madhesi""",
"""Mauritian Bhojpuri""",
"""Musahari""",
"""Gorakhpuri""",
"""Sarawaria""",
"""Southern Standard Bhojpuri""",
"""Teli""",
"""Tharu""",
"""Purbi""",
"""Trinidad Bhojpuri""",
"""Mokkan Tila Sadri""",
"""Nurpur Sadri""",
"""Uchai Sadri""",
"""Lower Sadri""",
"""Sadani""",
"""Beirut""",
"""Beludji""",
"""Churi-Wali""",
"""Domaki""",
"""Helebi""",
"""Karachi""",
"""Koli""",
"""Kurbat""",
"""Kurbati""",
"""Luli""",
"""Marashi""",
"""Maznoug""",
"""Nablos""",
"""Nawar""",
"""Nawari""",
"""Qinati""",
"""Wogri-Boli""",
"""Yürük""",
"""Lomavren""",
"""Dzambazi""",
"""East Bulgarian Romani""",
"""Greek Romani""",
"""Ironworker Romani""",
"""Paspatian""",
"""Tinners Romani""",
"""Tinsmiths""",
"""Ursári""",
"""Zargari""",
"""Latvian Romani""",
"""Lithuanian Romani""",
"""North Russian Romani""",
"""Polish Romani""",
"""White Russia Romani""",
"""White Russian Romani""",
"""Galician""",
"""Moravian Romani""",
"""Transylvanian""",
"""West Slovakian Romani""",
"""Eftawagaria""",
"""Estracharia""",
"""Gadschkene""",
"""Kranaria""",
"""Krantiki""",
"""Lallere""",
"""Manouche""",
"""Manuche""",
"""Piedmont Sintí""",
"""Praistiki""",
"""Serbian Romani""",
"""Slovenian-Croatian""",
"""Slovenian-Croatian Romani""",
"""Welsh Romani""",
"""Churari""",
"""Eastern""",
"""Ghagar""",
"""Grekurja""",
"""Kalderash""",
"""Lovari""",
"""Machvano""",
"""North Albanian""",
"""Sedentary Bulgaria""",
"""Sedentary Romania""",
"""Serbo-Bosnian""",
"""South Albanian""",
"""Southern Vlax""",
"""Southern Vlax Romani""",
"""Ukraine-Moldavia""",
"""Ukrainian Vlax Romani""",
"""Zagundzi""",
"""Sauraseni Prakrit""",
"""Seb Seliyer""",
"""Anarya""",
"""Bhilodi""",
"""Bhim""",
"""Charani""",
"""Habura""",
"""Konkani""",
"""Kotali""",
"""Magra Ki Boli""",
"""Nahari""",
"""Naikdi""",
"""Panchali""",
"""Patelia""",
"""Ranawat""",
"""Rani Bhil""",
"""Siyalgir""",
"""Chodri""",
"""Dhodia""",
"""Gamit""",
"""Dungra Bhil""",
"""Rajput Garasia""",
"""Bhoyari""",
"""Dholewari""",
"""Hoshangabad""",
"""Jamral""",
"""Katiyai""",
"""Malvi Proper""",
"""Patvi""",
"""Rajawadi""",
"""Rangari""",
"""Rangri""",
"""Sondhwadi""",
"""Sondwari""",
"""Ujjaini""",
"""Umadwadi""",
"""Mawchi""",
"""Padvi""",
"""Nahali""",
"""Palya Bareli""",
"""Pittala Bhasha""",
"""Takari""",
"""Pauri Bareli""",
"""Rathawi""",
"""Rathwi Bareli""",
"""Vaagri Booli""",
"""Kherwara""",
"""Sagwara""",
"""Gangapari""",
"""Mirzapuri""",
"""Pardesi""",
"""Tharu""",
"""Uttari""",
"""Gahore""",
"""Godwani""",
"""Ojhi""",
"""Powari""",
"""Sonpari""",
"""Tirhari""",
"""Bhulia""",
"""Binjhwari""",
"""Chhattisgarhi Proper""",
"""Kalanga""",
"""Kavardi""",
"""Khairagarhi""",
"""Sadri Korwa""",
"""Surgujia""",
"""Govari of Seoni""",
"""Khalari""",
"""Koshti""",
"""Kumbhari""",
"""Lodhi""",
"""Marari""",
"""Vyneganga Powari""",
"""Kakari""",
"""Kathiyawadi""",
"""Kharwa""",
"""Standard Gujarati""",
"""Tarimuki""",
"""Southern Saurashtra""",
"""Dehvali""",
"""Dogri""",
"""Khatalia""",
"""Kotni""",
"""Jikrio Goth Aer""",
"""Kachi Bhil""",
"""Katai Meghwar""",
"""Rabari""",
"""Vagri""",
"""Zalavaria Koli""",
"""Vaghri""",
"""Hasoria Koli""",
"""Mewasi""",
"""Nairya Koli""",
"""Wadiyara Koli""",
"""Rardro Bhil""",
"""Tharadari Bhil""",
"""Tharadari Koli""",
"""Jandavra""",
"""Central Dhatki""",
"""Eastern Dhatki""",
"""Malhi""",
"""Southern Dhatki""",
"""Dhundari""",
"""Sipari""",
"""Kabutra""",
"""Karnataka Lamani""",
"""Maharashtra Lamani""",
"""Merwari""",
"""Khairari""",
"""Sarwari""",
"""Khuni""",
"""Madahaddi""",
"""Sirohi""",
"""Eastern Gujari""",
"""Western Gujari""",
"""Mewati""",
"""Od""",
"""Parya""",
"""Sikar""",
"""Goaria""",
"""Marwari Bhil""",
"""Marwari Meghwar""",
"""Northern Marwari""",
"""Southern Marwari""",
"""Parkari Koli""",
"""Kotali Bhil""",
"""Kundi""",
"""Khandesi""",
"""Rangari""",
"""Middle Indo-Aryan""",
"""Bhuksa""",
"""Braj Bhasha""",
"""Dangi""",
"""Jadobafi""",
"""Sikarwari""",
"""Banaphari""",
"""Bhadauri""",
"""Chhatapur""",
"""Chhindwara Bundeli""",
"""Gaoli""",
"""Khatola""",
"""Kirari""",
"""Kundri""",
"""Lodhanti""",
"""Nagpuri Hindi""",
"""Nibhatta""",
"""Pawari""",
"""Raghobansi""",
"""Southern Bharatpur""",
"""Southern Morena""",
"""Standard Braj of Bulandshahr""",
"""Standard Braj of Eastern Agra""",
"""Standard Braj of Mathura""",
"""Standard Bundeli""",
"""Tirhari""",
"""Western Agra""",
"""Bangaru Proper""",
"""Deswali""",
"""Khadar""",
"""Mewati""",
"""Fiji Hindi""",
"""Literary Hindi""",
"""Hindi""",
"""Rekhta""",
"""Urdu""",
"""Pinjari""",
"""Tirhari""",
"""Transitional Kanauji""",
"""Gurgula""",
"""Bhunjia""",
"""Bastari""",
"""Bhunjia""",
"""Chandari""",
"""Gachikolo""",
"""Kawari""",
"""Mehari""",
"""Muri""",
"""Sundi""",
"""Kamar""",
"""Nahari""",
"""Barik""",
"""Bhatiari""",
"""Central Bengali""",
"""Chirmar""",
"""Chittagonian""",
"""Sylhetti""",
"""Ganda""",
"""Haijong""",
"""Kachari-Bengali""",
"""Lohari-Malpaharia""",
"""Musselmani""",
"""Siripuria""",
"""Rajbanshi""",
"""Rajshahi""",
"""Samaria""",
"""Saraki""",
"""Siripuria""",
"""Southeastern Bengali""",
"""Southwestern Bengali""",
"""Vanga""",
"""Mal Paharia""",
"""Saraki""",
"""Rajar Gang""",
"""Sylheti""",
"""Kharia Thar""",
"""Lodhi""",
"""Mal Paharia""",
"""Rohingya""",
"""Chittagonian""",
"""Tangchangya""",
"""Mayang""",
"""Standard Assamese""",
"""Western Assamese""",
"""Naga Pidgin""",
"""Kurmukar""",
"""Rangpuri""",
"""Surjapuri""",
"""Bodo Parja""",
"""Kupia""",
"""Midnapore Oriya""",
"""Mughalbandi""",
"""North Balasore Oriya""",
"""Northwestern Oriya""",
"""Southern Oriya""",
"""Western Oriya""",
"""Oriya""",
"""Reli""",
"""Bangani""",
"""Bhattiani""",
"""Chandpuri""",
"""Dessaulya""",
"""Gangadi""",
"""Jaunpuri""",
"""Lohbya""",
"""Majh-Kumaiya""",
"""Nagpuriya""",
"""Parvati""",
"""Rathi""",
"""Ravai""",
"""Salani""",
"""Srinagaria""",
"""Tehri""",
"""Northeastern Kumauni""",
"""Southeastern Kumauni""",
"""Western Kumauni""",
"""Chaudhabis""",
"""Paachsai""",
"""Sinja""",
"""Baitadi""",
"""Bajhangi""",
"""Bajurali""",
"""Darjula""",
"""Doteli""",
"""Gorkhali""",
"""Nepali""",
"""Palpa""",
"""Soradi""",
"""Palpa""",
"""Padar""",
"""Padari""",
"""Churahi""",
"""Bhattiyali""",
"""Bilaspuri""",
"""Bansyari""",
"""Gadi Chameali""",
"""Macleod Ganj""",
"""Pangwali""",
"""East Dogri""",
"""Kandiali""",
"""North Dogri""",
"""Dogri""",
"""Palampuri""",
"""Mandeali""",
"""Kllui""",
"""Outer Seraji""",
"""Baghliani""",
"""Kiunthali""",
"""Rohruri""",
"""Shimla Siraji""",
"""Sodochi""",
"""Pahari Kinnauri""",
"""Giripari""",
"""Southern Kalasha""",
"""North Khowar""",
"""South Khowar""",
"""Swat Khowar""",
"""Bunjwali""",
"""Kishtwari""",
"""Miraski""",
"""Poguli""",
"""Rambani""",
"""Riasi""",
"""Shah-Mansuri""",
"""Siraji of Doda""",
"""Siraji-Kashmiri""",
"""Standard Kashmiri""",
"""Zayoli""",
"""Zirak-Boli""",
"""Kalam""",
"""Lamuti""",
"""Rajkoti""",
"""Thal""",
"""Ushu""",
"""Chail""",
"""Wotapuri-Katarqalai""",
"""Indus""",
"""Chilisso""",
"""Gowro""",
"""Tirahi""",
"""Grangali""",
"""Zemiaki""",
"""Shumashti""",
"""Paisaci Prakrit""",
"""Chalas""",
"""Kandak""",
"""Kurangal""",
"""Kurdar""",
"""Darrai Nur""",
"""Kunar""",
"""Laghman""",
"""Wegal""",
"""Bolaghain""",
"""Gulbahar""",
"""Kohnadeh""",
"""Laurowan""",
"""Najil""",
"""Nangarach""",
"""Pachagan""",
"""Pandau""",
"""Parazhghan""",
"""Pashagar""",
"""Sanjan""",
"""Shamakot""",
"""Shutul""",
"""Uzbin""",
"""Wadau""",
"""Isken""",
"""Tagau""",
"""Kolai""",
"""Palasi""",
"""Ushojo""",
"""Kundal Shahi""",
"""Dras""",
"""Gurezi""",
"""Kharmangi""",
"""Satpara""",
"""Darel""",
"""Harban""",
"""Sazin""",
"""Tangir""",
"""Drasi""",
"""Bunji""",
"""Gilgit""",
"""Haramosh""",
"""Hunza-Nagar""",
"""Punial""",
"""Rondu""",
"""Gurezi""",
"""Northern Phalura""",
"""Savi""",
"""Bhatyiana""",
"""Doab""",
"""Majhi""",
"""Malwa""",
"""Panjabi Proper""",
"""Powadhi""",
"""Kohat Hindko""",
"""Peshawar Hindko""",
"""Rural Peshawar Hindko""",
"""Mirpuri""",
"""Pahari""",
"""Pothwari""",
"""Punchhi""",
"""Western Panjabi""",
"""Derawali""",
"""Jafri""",
"""Jangli""",
"""Jatki""",
"""Multani""",
"""Siraiki Hindki""",
"""Thali""",
"""Khetrani""",
"""Lasi""",
"""Luwati""",
"""Memoni""",
"""Dukslinu""",
"""Jadeji""",
"""Kachchi""",
"""Kayasthi""",
"""Lari""",
"""Lasi""",
"""Macharia""",
"""Sindhi Musalmani""",
"""Thareli""",
"""Thari""",
"""Viccholi""",
"""Vicholo""",
"""Visholi""",
"""Mohrano""",
"""Sindhi Bhil""",
"""Sindhi Meghwar""",
"""Chitpavani""",
"""Daldi""",
"""Kudali""",
"""Mangalore""",
"""Sarasvat Brahmin""",
"""Standard Konkani""",
"""Northern Katkari""",
"""Southern Katkari""",
"""Bhandari""",
"""Dhanagari""",
"""Ghati""",
"""Karhadi""",
"""Kiristav""",
"""Koli""",
"""Mahari""",
"""Parabhi""",
"""Sangamesvari""",
"""Thakuri""",
"""Kukna""",
"""Phudagi""",
"""Samvedi""",
"""Govari""",
"""Jhadpi""",
"""Katia""",
"""Kosti""",
"""Kunban""",
"""Kunbi""",
"""Mahari""",
"""Marheti""",
"""Natakani""",
"""Raipur""",
"""Eastern Nihiri""",
"""Western Nihiri""",
"""Kalvadi""",
"""Gawdi of Goa""",
"""Kasargod""",
"""Kosti""",
"""Kudali""",
"""Nagpuri Marati""",
"""Old Marathi""",
"""Sanskrit""",
"""Veddah""",
"""Lahul Lohar""",
"""Bactrian""",
"""Khwarezmian""",
"""Digor""",
"""Iron""",
"""Jassic""",
"""Kurtat""",
"""Tagaur""",
"""Tual""",
"""Western Yagnobi""",
"""Logar""",
"""Nijrau""",
"""Shutul""",
"""Waciri""",
"""Ghilzai""",
"""Ningraharian Pashto""",
"""Kohat""",
"""Mohmand""",
"""Shilmani""",
"""Shinwari""",
"""Yusufzai""",
"""Northwestern Pakhto""",
"""Quetta Pashto""",
"""Southeastern Pashto""",
"""Southwestern Pashto""",
"""Waneci""",
"""Tumshuqese""",
"""Sanglechi""",
"""Sanglich""",
"""Zebak""",
"""Sarikoli""",
"""Khufi""",
"""Shughni""",
"""Oroshor""",
"""Roshani""",
"""Rushani""",
"""Upper Yazgulyam""",
"""Eastern Wakhi""",
"""Gojal""",
"""Ishkoman""",
"""Western Wakhi""",
"""Yarkhun""",
"""Yasin""",
"""Mamalgha Munji""",
"""Northern Munji""",
"""Southern Munji""",
"""Yidgha""",
"""Koroshi""",
"""Bashgaadi""",
"""Coastal Balochi""",
"""Huuti""",
"""Kechi""",
"""Makrani""",
"""Sarawani""",
"""Rashti""",
"""Rudbari""",
"""Mazanderani""",
"""Shahmirzadi""",
"""Soi""",
"""Khunsari""",
"""Northwestern Fars""",
"""Sivandi""",
"""Khuri""",
"""Nayini""",
"""Zoroastrian Dari""",
"""Garmiyani""",
"""Hewleri""",
"""Kerkuki""",
"""Mukri""",
"""Pijdari""",
"""Pizhdar""",
"""Rewandiz""",
"""Sanandaji""",
"""Southern Jafi""",
"""Suleimani""",
"""Warmawa""",
"""Xoshnaw""",
"""Laki""",
"""Amadiye""",
"""Ashiti""",
"""Barwari Jor""",
"""Bayezidi""",
"""Boti""",
"""Gulli""",
"""Hekari""",
"""Khorasani Kurmanji""",
"""Marashi""",
"""Mhallami""",
"""Sheikhan""",
"""Shemdinani""",
"""Surchi""",
"""Zakho""",
"""Feyli""",
"""Garrusi""",
"""Kalhori""",
"""Kermanshahi""",
"""Kolyai""",
"""Kordali""",
"""Luri""",
"""Maleksh ahi""",
"""Malekshahi""",
"""Sanjabi""",
"""Parthian""",
"""Sangisari""",
"""Semnani""",
"""Sorkhei""",
"""Koresh-e Rostam""",
"""Shahrudi""",
"""Kho'ini""",
"""Central Talyshi""",
"""Lenkoran""",
"""Lerik""",
"""Massali""",
"""Northern Talyshi""",
"""Southern Talyshi""",
"""Kalas""",
"""Upper Taromi""",
"""Karingani""",
"""Vidar""",
"""Kharaqan""",
"""Ramand""",
"""Tarom""",
"""Zanjan""",
"""Tafresh""",
"""Vafsi""",
"""Razajerdi""",
"""Hawraman-I Luhon""",
"""Hawraman-I Taxt""",
"""Kakai""",
"""Kandula""",
"""Gurani""",
"""Sarli""",
"""Shabak""",
"""Hazzu""",
"""Kori""",
"""Motki""",
"""Sivereki""",
"""Varto""",
"""Southern Bashaka""",
"""Aruskush-Daqqushchu""",
"""Balakhani""",
"""Devechi""",
"""Lahyj""",
"""Malham""",
"""Northern Tats""",
"""Qonaqkend""",
"""Quba""",
"""Qyzyl Qazma""",
"""Surakhani""",
"""Firozkohi""",
"""Jamshidi""",
"""Maliki""",
"""Mizmast""",
"""Taimani""",
"""Taimuri""",
"""Teimuri""",
"""Zainal""",
"""Zohri""",
"""Parsiwan""",
"""Darwazi""",
"""Dehwari""",
"""Hazaragi""",
"""Pahlavani""",
"""Tajik""",
"""Judeo-Persian""",
"""Bandari""",
"""Basseri""",
"""Esfahani""",
"""Kashani""",
"""Kermani""",
"""Ketabi""",
"""Mahalhamadani""",
"""Mashadi""",
"""Old Shirazi""",
"""Qazvini""",
"""Sedehi""",
"""Shahrudi Kazeruni""",
"""Shirazi""",
"""Shirazjahromi""",
"""Tehrani""",
"""Yazdi""",
"""Kumzari""",
"""Bikha""",
"""Evaz""",
"""Gerash""",
"""Khonj""",
"""Lari""",
"""Chelgerd""",
"""Haft-Lang""",
"""Kuhrang""",
"""Bala-Gariva'i""",
"""Borujerdi""",
"""Cagani""",
"""Khorramabadi""",
"""Mahali""",
"""Nahavandi""",
"""Kohgiluyeh""",
"""Mamasani""",
"""Shuli""",
"""Yasuji""",
"""Old Persian""",
"""Pahlavi""",
"""Southwestern Fars""",
"""Gramsukraviri""",
"""Suruviri""",
"""Shekhani""",
"""Mumviri""",
"""Western Kativiri""",
"""Lower Prasun""",
"""Upper Wasi-Weri""",
"""Varjan""",
"""Istro Romanian""",
"""Megleno Romanian""",
"""Bayash""",
"""Bayash Romanian""",
"""Crishana""",
"""Maramuresh""",
"""Moldavan""",
"""Moldavian""",
"""Muntenian""",
"""Oltenia-Lesser Wallachia""",
"""Transylvanian""",
"""Istriot""",
"""Cicolano-Reatino-Aquilano""",
"""Fiorentino""",
"""Laziale""",
"""Napoletano""",
"""Northern Calabrese-Lucano""",
"""Pugliese""",
"""Eastern Nonmetafonetica""",
"""Isole Eolie""",
"""Messinese""",
"""Pantesco""",
"""Southeast Metafonetica""",
"""Southern Calabro""",
"""Western Sicilian""",
"""Central Emiliano""",
"""Eastern Emiliano""",
"""Lunigiano""",
"""Vogherese-Pavese""",
"""Western Emiliano""",
"""Sammarinese""",
"""Southern Romagnolo""",
"""Judeo-Italian""",
"""Monégasque""",
"""Bergamasco""",
"""Eastern Lombard""",
"""Eastern Lombard""",
"""Insubric""",
"""Latin Anaunico""",
"""Latin Fiamazzo""",
"""Mantovano""",
"""Milanese""",
"""Novarese Lombard""",
"""Ticinese""",
"""Trentino Western""",
"""Western Lombard""",
"""Low Piemontese""",
"""Turinese""",
"""Sassarese Sardinian""",
"""Istrian""",
"""Tretine""",
"""Triestino""",
"""Venetian Proper""",
"""East Central Friulian""",
"""Western Friulian""",
"""Atesino""",
"""Badiotto""",
"""Cadorino""",
"""Fassano""",
"""Gardenese""",
"""Livinallese""",
"""Marebbano""",
"""Nones""",
"""Marsh French""",
"""Prairie French""",
"""Karipúna Creole French""",
"""Plateau Haitian Creole""",
"""St. Barth Creole French""",
"""Patwa""",
"""San Miguel Creole French""",
"""Louisiana Creole French""",
"""Angevin""",
"""Berrichon""",
"""Bourbonnais""",
"""Bourguignon""",
"""Dgernesiais""",
"""Franco-Ontarien""",
"""Gallo""",
"""Jerriais""",
"""Lorraine""",
"""Norman""",
"""Poitevin""",
"""Québécois""",
"""Santongeais""",
"""Seselwa Creole French""",
"""Réunion Creole French""",
"""Tayo""",
"""Artois""",
"""Belgian Picard""",
"""Boulonnais""",
"""Calaisis""",
"""Cambresis""",
"""Hainaut""",
"""Lillois""",
"""Ponthieu""",
"""Santerre""",
"""Vermandois""",
"""Vimeu""",
"""Dauphinois""",
"""Faeto""",
"""Franche-Comtois""",
"""Lyonnais""",
"""Neuch-Telois""",
"""Neuchatelais""",
"""Savoyard""",
"""Valaisan""",
"""Valle D'aosta""",
"""Vaudois""",
"""Faeto and Celle San Vito Francoprovencal""",
"""Middle French""",
"""Old French""",
"""Eastern Walloon""",
"""Southern Walloon""",
"""Western Walloon""",
"""Puter""",
"""Rumantsch Grischun""",
"""Surmiran-Albula""",
"""Sursilvan""",
"""Sursilvan-Oberland""",
"""Upper Engadine""",
"""Vallader""",
"""Baish Aranés""",
"""Béarnais""",
"""Landais""",
"""Mijaranés Aranés""",
"""Naut Aranés""",
"""Haut-Auvergnat""",
"""Haut-Limousin""",
"""Vivaro-Alpine Occitan""",
"""Guyennais""",
"""Haut-Languedocien""",
"""Languedocien Moyen""",
"""Gavot""",
"""Maritime Provençal""",
"""Niçard""",
"""Rhodanien""",
"""Transalpin""",
"""Old Provençal""",
"""Nonstandard Central Catalan""",
"""Eastern Asturian""",
"""Leonese""",
"""Western Asturian""",
"""Mirandese""",
"""Northern Extremaduran""",
"""Southern Extremaduran""",
"""Old Spanish""",
"""Judezmo""",
"""Ladino""",
"""Loreto-Ucayali Spanish""",
"""Palenquero""",
"""Cotobato Chavacano""",
"""Davawenyo Zamboanguenyo""",
"""Ermitaño""",
"""Ternateño""",
"""Zamboangueño""",
"""Ternateño""",
"""Andalusian""",
"""Aragonese""",
"""Canary Islands Spanish""",
"""Castilian""",
"""Murcian""",
"""Navarrese""",
"""Mañegu""",
"""Valvideiru""",
"""Galician""",
"""Brazilian Portuguese""",
"""Estremenho""",
"""Galician Portuguese""",
"""Madeira-Azores""",
"""Korlai Creole Portuguese""",
"""Fa D'ambu""",
"""Sãotomense""",
"""Macanese""",
"""Português de Bidau""",
"""Kabuverdianu Sotavento""",
"""Sotavento""",
"""Papiamento""",
"""Bissau-Bolama Creole""",
"""Cacheu-Ziguinchor Creole""",
"""Minderico""",
"""Eastern Aragonese""",
"""Southern Aragonese""",
"""Western Aragonese""",
"""Mozarabic""",
"""Sartenais""",
"""Venaco""",
"""Vico-Ajaccio""",
"""Gallurese Sardinian""",
"""Cagliare""",
"""Central Campidanese""",
"""Meridionale""",
"""Ogliastrino""",
"""Sarrabense""",
"""Sub-Barbaricino""",
"""Sulcitano""",
"""Western Campidenese""",
"""Northern Logudorese""",
"""Nuorese""",
"""Southwestern Logudorese""",
"""South Lucanian""",
"""Old Latin""",
"""Umbrian""",
"""Sabine""",
"""South Picene""",
"""Volscian""",
"""Lusitanian""",
"""Messapic""",
"""Thracian""",
"""Tocharian B""",
"""Elt Ulid""",
"""Guanche""",
"""South Oran""",
"""Senhaja De Srair""",
"""Western Kabyle""",
"""Jerba""",
"""Jerbi""",
"""Tamezret""",
"""Zuara""",
"""Siwi""",
"""Hoggar""",
"""Tadhaq""",
"""Timbuktu""",
"""Tawallammat Tan Ataram""",
"""Tawallammat Tan Dannag""",
"""Tanassfarwat""",
"""Zenaga""",
"""Tariyit""",
"""Temacin""",
"""Temacine Tamazight""",
"""Touat""",
"""Tit""",
"""Tumzabt""",
"""Tmagourt""",
"""Tachawit""",
"""Beni Iznassen""",
"""Igzennaian""",
"""Urrighel""",
"""Tunisian-Zuwara Berber""",
"""Gwendele""",
"""Hurza""",
"""Mayo-Plata""",
"""Mberem""",
"""Jilbe""",
"""Gili""",
"""Kirya-Konzel""",
"""Wula""",
"""Zlenge""",
"""Kajire-'dulo""",
"""Majera""",
"""Logone-Birni""",
"""Logone-Gana""",
"""Houlouf""",
"""Kabe""",
"""Kalo""",
"""Mser""",
"""Hedkala""",
"""Waga""",
"""Ghudavan""",
"""Gwoza""",
"""Leghva""",
"""Zaladeva""",
"""Zaladva""",
"""Visik""",
"""Marghi South""",
"""Gwara""",
"""Lassa""",
"""Mulgwe""",
"""Wurga""",
"""Pabir""",
"""Pela""",
"""Cibak""",
"""Nggwahyi""",
"""Putai""",
"""Dghwede""",
"""Chikide""",
"""Gava""",
"""Gvoko""",
"""Parkwa""",
"""Ngoshie""",
"""Glavda""",
"""Gwanje""",
"""Jampalam""",
"""Kamburwama""",
"""Kirawa""",
"""Masfeima""",
"""Mazagwa""",
"""Mura""",
"""Wandala""",
"""Ziogba""",
"""Mineo""",
"""Zulgo""",
"""Gudur""",
"""Massagal""",
"""Mokong""",
"""Njeleng""",
"""Zidim""",
"""Wazan""",
"""Moloko""",
"""Muyang""",
"""Wuzlam""",
"""Muturami""",
"""Rum""",
"""Luggoy""",
"""Maniling""",
"""Mpus""",
"""Muzuk""",
"""Ngilemong""",
"""Vulum""",
"""Muskum""",
"""Northern Buduma""",
"""Buduma""",
"""Southern Buduma""",
"""Dro""",
"""Goulfey""",
"""Mara""",
"""Malgbe""",
"""Walia""",
"""Sao""",
"""Digam""",
"""Makari""",
"""Mpade""",
"""Shoe""",
"""Woulki""",
"""Ngala of Lake Chad""",
"""Ga'anda""",
"""Hwana""",
"""Nyimatli""",
"""Pidlimndi""",
"""Gavar""",
"""Musgoi""",
"""Mbedam""",
"""Gamdugun""",
"""Jingjing""",
"""Nive""",
"""Pologozom""",
"""Opalo""",
"""Wa-Duku""",
"""Bacama-Yimburu""",
"""Garoua""",
"""Jirai""",
"""Kobotachi""",
"""Malabu""",
"""Ndeewe""",
"""Ribaw""",
"""Wadi""",
"""Zumu""",
"""Fali of Mubi""",
"""Fali of Mucella""",
"""Fali of Vimtim""",
"""Holma""",
"""Jimo""",
"""Malabu""",
"""Wadi""",
"""Zumo""",
"""Ngwaba""",
"""Holma""",
"""Hoode""",
"""Lovi""",
"""Magara""",
"""Maiha""",
"""Mutidi""",
"""Nggwoli""",
"""Paka""",
"""Rogede""",
"""Tsuvan""",
"""Zizilivakan""",
"""Ldamtsai""",
"""Mokola""",
"""Mokolo""",
"""Ouzal""",
"""Soulede""",
"""Mafa""",
"""Mavoumay""",
"""Mefele""",
"""Serak""",
"""Shugule""",
"""Sukur""",
"""Nancere""",
"""Kimruwa""",
"""Tchire""",
"""Moonde""",
"""Tobanga""",
"""Gaya""",
"""Kawalké""",
"""Mindéra""",
"""Mobou""",
"""Ngam""",
"""Kwang""",
"""Tchagin""",
"""Ndam-Ndam""",
"""Somrai""",
"""Tumak""",
"""Gadang""",
"""Miltu""",
"""Sarua""",
"""Jalkia""",
"""Komi""",
"""Sakaya""",
"""Agrab""",
"""Duguri""",
"""Eastern Birgit""",
"""Mogum Diguimi""",
"""Mogum Déle""",
"""Mogum Urmi""",
"""Toram""",
"""Garawgino""",
"""Jekkino""",
"""Nalguno""",
"""Oboyguno""",
"""East Dangaleat""",
"""West Dangaléat""",
"""Musunye""",
"""Doga""",
"""Gamiya""",
"""Migaama""",
"""Mabire""",
"""Masmaje""",
"""Mubi""",
"""Zirenkel""",
"""Sokoro""",
"""Tamki""",
"""Ubi""",
"""Gugiko""",
"""Mezimko""",
"""Mokilko""",
"""Moriko""",
"""Seginki""",
"""Jaraw-Domo""",
"""Lew""",
"""Pe""",
"""Pe-Holom-Gamé""",
"""Bongor""",
"""Budugum""",
"""Bugudum""",
"""Wina""",
"""Gumay""",
"""Ham""",
"""Walia""",
"""Yagwa""",
"""Zumaya""",
"""Zamre""",
"""Ngete""",
"""Doe""",
"""Lamé""",
"""Gwandara Gitata""",
"""Gwandara Karashi""",
"""Gwandara Koro""",
"""Gwandara Southern""",
"""Nimbia""",
"""Damagaram""",
"""Dawra""",
"""Kano""",
"""Katagum""",
"""Gaya""",
"""Kurfey""",
"""Arewa""",
"""Gobirawa""",
"""Katsina""",
"""Kebbawa""",
"""Sokoto""",
"""Zamfarawa""",
"""Tambas""",
"""Richa""",
"""Tof""",
"""Mangar""",
"""Mundat""",
"""Daffo-Butura""",
"""Sha""",
"""Jalalam""",
"""Kwarta Mataci""",
"""Bole""",
"""Ngamo""",
"""Gamsawa""",
"""Sum""",
"""Kubi""",
"""Maaka""",
"""Nyam""",
"""Shani""",
"""Shellen""",
"""Pero""",
"""Piya""",
"""Kwaami""",
"""Kaltungo""",
"""Shongom""",
"""Ture""",
"""Montol""",
"""Tal""",
"""Pyapun""",
"""Jorto""",
"""Dimmuk""",
"""Gworam""",
"""Jipal""",
"""Kwagallak""",
"""Mirriam""",
"""Kofyar""",
"""Mwaghavul""",
"""Plain Angas""",
"""Yiwom""",
"""Shirawa""",
"""Southern Bade""",
"""Western Bade""",
"""Teshenawa""",
"""Ciwogai""",
"""Diri""",
"""Mburku""",
"""Pa'a""",
"""Siri""",
"""Faishang""",
"""Federe""",
"""Fursum""",
"""Gala""",
"""Warji""",
"""Zumbun""",
"""Mangas""",
"""Gar""",
"""Gayar""",
"""Jimi""",
"""Karakara""",
"""Kuuku""",
"""Lungu""",
"""Mbaaru""",
"""Tala""",
"""Zangwal""",
"""Geji""",
"""Zaranda""",
"""Buli""",
"""Dir""",
"""Langas""",
"""Polchi""",
"""Zul""",
"""Durr-Baraza""",
"""Wandi""",
"""Zumbul""",
"""Zari""",
"""Zakshi""",
"""Lushi""",
"""Zeem""",
"""Amara""",
"""Beni-Amir""",
"""Bisharin""",
"""Hadareb""",
"""Hadendoa""",
"""Xamtanga""",
"""Dembiya""",
"""Hwarasa""",
"""Kayla""",
"""Kwolasa""",
"""Qimant""",
"""Semyen""",
"""Dahalo""",
"""Soro""",
"""Libido""",
"""Tambaro""",
"""Timbaro""",
"""Sidamo""",
"""Baadu""",
"""Central Afar""",
"""Northern Afar""",
"""Jiiddu""",
"""Dabarre""",
"""Tunni""",
"""Girirra""",
"""Garre""",
"""Rendille""",
"""Benaadir""",
"""Degodia""",
"""Northern Somali""",
"""Ogaden""",
"""Daasanach""",
"""El Molo""",
"""Konso""",
"""Boran""",
"""Borana""",
"""Gabra""",
"""Guji""",
"""Kereyu""",
"""Sakuye""",
"""Salale""",
"""Orma""",
"""Orma""",
"""Waata""",
"""Mecha""",
"""Raya""",
"""Tulema""",
"""Wello""",
"""Western Oromo""",
"""Gergere""",
"""Gobeze""",
"""Gollango""",
"""Gorose""",
"""Harso""",
"""Tsamai""",
"""Yaaku""",
"""Kw'adza""",
"""Oxyrhynchite""",
"""Old Coptic""",
"""Lycopolitan""",
"""Sahidic""",
"""Egyptian""",
"""Eblan""",
"""Dumaitic""",
"""Hasaitic""",
"""Hismaic""",
"""Safaitic""",
"""Taymanitic""",
"""Dhofari Arabic""",
"""Al-Hasâ""",
"""Bahraini Gulf Arabic""",
"""Khamseh""",
"""Kuwaiti Hadari Arabic""",
"""North Qatari Arabic""",
"""South Qatari Arabic""",
"""Zubair-Faau Arabic""",
"""Hadrami Arabic""",
"""North Hijazi""",
"""South Hijazi""",
"""Valley Tihaamah""",
"""Beda""",
"""Habban""",
"""San'a""",
"""North Najdi""",
"""South Anjdi""",
"""Omani Arabic""",
"""Sanaani Arabic""",
"""Shihhi Arabic""",
"""Ta'izzi""",
"""Uzbeki Arabic""",
"""Khorasan Arabic""",
"""Euphrates Cluster""",
"""Tigris Cluster""",
"""North Mesopotamian Arabic""",
"""Northeast Egyptian Bedawi Arabic""",
"""Eastern Egyptian Bedawi Arabic""",
"""South Levantine Bedawi Arabic""",
"""North Delta Arabic""",
"""South Central Delta Arabic""",
"""Upper Egypt Arabic""",
"""Chari-Baguirmi""",
"""Nubi""",
"""Khartoum""",
"""North Kordofan Arabic""",
"""Shukri""",
"""Western Sudanese""",
"""Sudanese Creole Arabic""",
"""Beqaa Arabic""",
"""Iqlim-Al-Kharrub Sunni Arabic""",
"""Jdaideh Arabic""",
"""North Lebanese Arabic""",
"""North-Central Lebanese Arabic""",
"""Saida Sunni Arabic""",
"""South Lebanese Arabic""",
"""South-Central Lebanese Arabic""",
"""Standard Lebanese Arabic""",
"""Sunni Beiruti Arabic""",
"""Madani""",
"""Constantine""",
"""Oran""",
"""Algerian Saharan Arabic""",
"""Hassaniyya""",
"""Judeo-Moroccan Arabic""",
"""Judeo-Tripolitanian Arabic""",
"""Southern Libyan Arabic""",
"""Tripolitanian Arabic""",
"""Western Egyptian Bedawi Arabic""",
"""Port Maltese""",
"""Rural Central Maltese""",
"""Rural East Maltese""",
"""Rural West Maltese""",
"""Standard Maltese""",
"""Zurrieq""",
"""Jebli""",
"""Marrakech""",
"""Oujda""",
"""Rabat-Casablanca Arabic""",
"""Southern Morocco Arabic""",
"""Tangier""",
"""Sahil""",
"""Sfax""",
"""South-Eastern Tunisian""",
"""South-Western Tunisian""",
"""Tunis""",
"""Standard Arabic""",
"""Jinet""",
"""Umraya""",
"""Mar Bishu""",
"""Nochiya""",
"""Tergawar""",
"""Iranian Koine""",
"""Dez""",
"""Gavar""",
"""Jilu""",
"""Qudshanis""",
"""Salamas""",
"""Upper Barwari""",
"""Van""",
"""Benatha""",
"""Daudiya""",
"""Inishke""",
"""Tina""",
"""Solduz""",
"""Urmi""",
"""Lower Barwari""",
"""Tal""",
"""Tkhuma""",
"""Bartille""",
"""Dihok""",
"""Mangesh""",
"""Shirnak-Chizre""",
"""Tel Kepe""",
"""Tisqopa""",
"""Jewish Babylonian Aramaic""",
"""Bijil""",
"""Sandu""",
"""Shahe""",
"""Atrush""",
"""Barashe""",
"""Bétanure""",
"""Dohuk""",
"""Nerwa""",
"""Shukho""",
"""Zakho""",
"""Salmas""",
"""Urmi""",
"""Naghada""",
"""Ushno""",
"""Sanandaj""",
"""Saqiz""",
"""Suleimaniya""",
"""Senaya""",
"""Rwanduz""",
"""Qaladze""",
"""Ranye""",
"""Shaqlawa""",
"""Dobe""",
"""Iwardo""",
"""Kfarze""",
"""Midin""",
"""Midyat""",
"""Raite""",
"""Western Syriac""",
"""Iraqi Neo-Mandaic""",
"""Shushtar""",
"""Old Aramaic""",
"""Samaritan Aramaic""",
"""Jub-'adin""",
"""Ma'lula""",
"""Standard Hebrew""",
"""Samaritan""",
"""Ugaritic""",
"""Jabal Razih""",
"""Minaean""",
"""Qatabanian""",
"""Sabaean""",
"""Soddo""",
"""Gyeto""",
"""Mesmes""",
"""Mesqan""",
"""Ezha""",
"""Gumer""",
"""Gura""",
"""Gyeto""",
"""Argobba""",
"""Wolane""",
"""Zay""",
"""Tigrinya""",
"""Kuria Muria""",
"""Western Jibbali""",
"""Central Soqotri""",
"""Northwest Central Soqotri""",
"""Southern Soqotri""",
"""Western Soqotri""",
"""Hobyót""",
"""Harsusi""",
"""Nagdi""",
"""Western Mehri""",
"""Quileute""",
"""Lipan Apache""",
"""Navajo""",
"""Western Apache""",
"""Babine""",
"""Beaver""",
"""Southern Carrier""",
"""Chilcotin""",
"""Chipewyan""",
"""Degexit'an""",
"""Gwich'in""",
"""Han""",
"""South Slavey""",
"""Holikachuk""",
"""Koyukon""",
"""Lower Tanana""",
"""Sarsi""",
"""Sekani""",
"""Tagish""",
"""Tahltan""",
"""Tanacross""",
"""Tanaina""",
"""Tsetsaut""",
"""Southern Tutchone""",
"""Upper Kuskokwim""",
"""Upper Tanana""",
"""Kato""",
"""Mattole""",
"""Wailaki""",
"""Galice""",
"""Tututni""",
"""Tolowa""",
"""Upper Umpqua""",
"""Eyak""",
"""Tlingit""",
"""Wurrugu""",
"""Turumsa""",
"""Puri""",
"""Nguburindi""",
"""Nyangga""",
"""Atimelang""",
"""Kobola""",
"""Lembur""",
"""Kamang""",
"""Sibo""",
"""Tiayai""",
"""Watang""",
"""Iramang""",
"""Kula Watena""",
"""Kulatela""",
"""Larena""",
"""Kula""",
"""Sumang""",
"""Watena""",
"""Lona""",
"""Sawila""",
"""Salimana""",
"""Sileba""",
"""Langkuru""",
"""Maneta""",
"""Kiramang""",
"""Kui""",
"""Halerman""",
"""Panggar""",
"""Probur""",
"""Hamap""",
"""Meibuil""",
"""Otvai""",
"""Pintumbang""",
"""Tang'ala""",
"""Bakalang""",
"""Limarahing""",
"""Pura""",
"""Retta""",
"""Tereweng""",
"""Kaera""",
"""Kalondama""",
"""Tubal""",
"""Nedebang""",
"""Lebang""",
"""Madar""",
"""Oirata""",
"""Maklere""",
"""Sqoleq""",
"""Tekedaya""",
"""Teruku""",
"""North Bunun""",
"""Randai""",
"""Shibukun""",
"""South Bunun""",
"""Takopulan""",
"""Tondai""",
"""Chengkung-Kwangshan""",
"""Northern Amis""",
"""Southern Amis""",
"""Tavalong-Vataan""",
"""Kaliyawan""",
"""Nataoran""",
"""Natawran""",
"""Pokpok""",
"""Ridaw""",
"""Sakizaya""",
"""Trobiawan""",
"""Ketangalan""",
"""Makatao""",
"""Siraya""",
"""Pangsoia-Dolatok""",
"""Taivoan""",
"""Saaroa""",
"""Malay""",
"""Itbayaten""",
"""Southern Ivatan""",
"""Yami""",
"""Sarangani Blaan""",
"""Southern Tboli""",
"""Western Tboli""",
"""Tiruray""",
"""West Banggai""",
"""Saluan""",
"""Bobongko""",
"""Bungku""",
"""Routa""",
"""Torete""",
"""Tulambatu""",
"""Waia""",
"""Koroni""",
"""Kulisusu""",
"""Nahina""",
"""Petasia""",
"""Soroako""",
"""Tambe'e""",
"""Taloki""",
"""Wawonii""",
"""Rumbia""",
"""Padoe""",
"""Tomadino""",
"""Rahambuu""",
"""Konawe""",
"""Konio""",
"""Laiwui""",
"""Mekongga""",
"""Norio""",
"""Tamboki""",
"""Wiwirano""",
"""Waru""",
"""Masiri""",
"""Sampolawa""",
"""Holimombo""",
"""Kondowa""",
"""Wabula""",
"""Takimpo""",
"""Wali""",
"""Lasalimu""",
"""Lantoi""",
"""Kioko""",
"""Liabuku""",
"""Gu""",
"""Kadatua""",
"""Kalia-Lia""",
"""Katobengke""",
"""Lakudo""",
"""Laompo""",
"""Lawama""",
"""Lawela""",
"""Lowu-Lowu""",
"""Mawasangka""",
"""Salaa""",
"""Topa""",
"""Wale-Ale""",
"""Siompu""",
"""Katobu""",
"""Lawa""",
"""Tobea Besar""",
"""Tungkuno""",
"""Tiworo""",
"""Kapontori""",
"""Labuandiri""",
"""Bonerate""",
"""Wanci""",
"""Tomea""",
"""Inde""",
"""Tado""",
"""Moma""",
"""Doi""",
"""Edo""",
"""Ija""",
"""Ledo""",
"""Rai""",
"""Raio""",
"""Taa""",
"""Tado""",
"""Tara""",
"""Sedoa""",
"""Topoiyo""",
"""Unde Kaili""",
"""Tombelala""",
"""Bada""",
"""Besoa""",
"""Napu""",
"""Rato""",
"""Nunu'""",
"""Benggaulu""",
"""Kantewu""",
"""Southern Uma""",
"""Tobaku""",
"""Tolee'""",
"""Winatu""",
"""Laiyolo""",
"""Wolio""",
"""Wotu""",
"""Totoli""",
"""Tomini""",
"""Dampelas""",
"""Pendau""",
"""Taje""",
"""Tajio""",
"""Remontado Agta""",
"""Sambali Botolan""",
"""Ambala Ayta""",
"""Bataan Ayta""",
"""Mag-Indi Ayta""",
"""Masinloc""",
"""Santa Cruz""",
"""Mariri""",
"""Southeast Dobel""",
"""Straits Dobel""",
"""Warabal""",
"""Lorang""",
"""Manombai""",
"""East Tarangan""",
"""Barakai""",
"""Karey""",
"""Kompane""",
"""Ujir""",
"""Southwestern Tarangan""",
"""Dawera-Daweloor""",
"""North Babar""",
"""East Masela""",
"""Serili""",
"""Southeast Babar""",
"""West Masela""",
"""Imroing""",
"""Tela-Masbuar""",
"""West Damar""",
"""Mbojo""",
"""Bima""",
"""Sangar""",
"""Toloweri""",
"""Eli""",
"""Kelimuri""",
"""Mina Mina Gorong""",
"""Tamher Timur""",
"""Masiwang""",
"""Lesa""",
"""Benggoi""",
"""Hoti""",
"""Seti""",
"""Wahakaim""",
"""Salas""",
"""Lumaete""",
"""Kayeli""",
"""Kanikeh""",
"""Maneo""",
"""South Manusela""",
"""South Nuaulu""",
"""West Teluti""",
"""Seit""",
"""Mamala""",
"""Morela""",
"""Hitu""",
"""Wakal""",
"""Tulehu""",
"""Tengah-Tengah""",
"""Tial""",
"""Kaibobo""",
"""Kailolo""",
"""Pelauw""",
"""Rohomoni""",
"""Rutah""",
"""Soahuku""",
"""Nusa Laut""",
"""Iha-Seram""",
"""Kulur""",
"""Siri-Sori""",
"""Kamarian""",
"""Asilulu""",
"""Ureng""",
"""Larike""",
"""Wakasihu""",
"""Kelang""",
"""Luhu""",
"""Manipa""",
"""Lisabata-Timur""",
"""Nuniali""",
"""Sukaraja""",
"""Loun""",
"""Saleman""",
"""Central West Alune""",
"""Kairatu""",
"""North Coastal Alune""",
"""South Alune""",
"""Naka'ela""",
"""Yalahatan""",
"""Kasieh""",
"""Uwenpantai""",
"""Ut""",
"""Fogi""",
"""Masarete""",
"""Wae Sama""",
"""Hukumina""",
"""Tagalisa""",
"""Fagudu""",
"""Falahu""",
"""Mangei""",
"""Padang""",
"""Lamalera""",
"""West Lamaholot""",
"""West Solor""",
"""Lewotobi""",
"""East Solor""",
"""West Adonara""",
"""South Ile Ape""",
"""West Lembata""",
"""Levuka""",
"""South Lembata""",
"""Lewo Eleng""",
"""Lamatuka""",
"""Sikka Natar""",
"""Tana Ai""",
"""Eastern Manggarai""",
"""West-Central Manggarai""",
"""Western Manggarai""",
"""Rajong""",
"""Rembong""",
"""Wangka""",
"""Riung""",
"""Wae Rana""",
"""Ende""",
"""Li'o""",
"""Nage""",
"""Central Ngada""",
"""South Ngada""",
"""Rongga""",
"""So'a""",
"""Palu'e""",
"""Mesara""",
"""Raijua""",
"""Seba""",
"""Timu""",
"""Rua""",
"""Lewa""",
"""Mangili-Waijelo""",
"""Melolo""",
"""Kambera""",
"""Southern Sumba""",
"""Uma Ratu Nggai""",
"""Mamboru""",
"""Kodi Bokol""",
"""Nggaro""",
"""Lamboya""",
"""Tana Righu""",
"""Weyewa""",
"""Fordata-Larat II""",
"""Molo""",
"""Sera""",
"""Kei Kecil""",
"""Ta'am""",
"""Tanimbar Kei""",
"""Tayando""",
"""Ogar""",
"""Patipi""",
"""Sepa""",
"""Sekar""",
"""Uruangnirin""",
"""South Yamdena""",
"""Keroi""",
"""Namatota""",
"""Waikala""",
"""Seluwasan""",
"""Northern Tetun""",
"""Southern Tetun""",
"""Tetun Dili""",
"""Midiki""",
"""Oso Moko""",
"""Waima'a""",
"""Roma""",
"""Moa""",
"""Luang""",
"""Wetan""",
"""Maku'a""",
"""Dadua""",
"""Edi""",
"""Hahak""",
"""Na Nahek""",
"""Galoli""",
"""Serua""",
"""Te'un""",
"""Esulit""",
"""Ilmaumau""",
"""Karbubu""",
"""Klishatu""",
"""Nabar""",
"""Telemar""",
"""Ustutun""",
"""Lurang""",
"""Welemur""",
"""Uhak""",
"""Ilpokil""",
"""Kahailin Ilway""",
"""Mahuan""",
"""Masapua""",
"""Tomliapat""",
"""Helong Darat""",
"""Helong Pulau""",
"""Tai Boko""",
"""Uis Tasae""",
"""Amfoan-Fatule'u-Amabi""",
"""Biboki-Insana""",
"""Kusa-Manlea""",
"""Mollo-Miomafo""",
"""Oenale""",
"""Lelain""",
"""Western Dengka""",
"""Ro'is""",
"""Ro'is Hero""",
"""Ro'is Tais Nonof""",
"""Lelenuk""",
"""Bilba""",
"""North Lole""",
"""South Lole""",
"""Ringgou""",
"""Oe Pao""",
"""Korbafo""",
"""Pa'da""",
"""Pa'da Kona""",
"""Tii""",
"""Lakalei""",
"""Lolei""",
"""Mambai""",
"""Manua""",
"""Kemak""",
"""Tukudede""",
"""Papitalai""",
"""Titan""",
"""Kele""",
"""Kurti""",
"""Leipon""",
"""Ponam""",
"""Mokerang""",
"""Tong""",
"""Hermit""",
"""Sori""",
"""Drehet""",
"""Levei""",
"""Likum""",
"""Mondropolon""",
"""Keli""",
"""Tulu""",
"""Pam""",
"""Nauna""",
"""Penchal""",
"""Southern Kaniet""",
"""Seimat""",
"""Wuvulu""",
"""Central Vanua Levu""",
"""Kadavu""",
"""Northeast Vanua Levu""",
"""Northeast Viti Levu""",
"""Southeast Vanua Levu""",
"""Southeast Viti Levu""",
"""West Vanua Levu""",
"""Gone Dau""",
"""Vanua Balavu""",
"""Lomaiviti""",
"""East Futuna""",
"""Niuatoputapu""",
"""Wallisian""",
"""Tokelau""",
"""South Tuvaluan""",
"""Nukuoro""",
"""Pelau""",
"""Nukuria""",
"""Takuu""",
"""Atiu""",
"""Mangaia""",
"""Mauke""",
"""Mitiaro""",
"""Rarotonga""",
"""Mangareva""",
"""Moriori""",
"""North Auckland""",
"""Rotorua-Taupo""",
"""South Island""",
"""Taranaki""",
"""Wanganui""",
"""Nuku Hiva""",
"""Ua Huka""",
"""Ua Pou""",
"""Hiva Oa""",
"""Tahuta""",
"""Penrhyn""",
"""Rakahanga-Manihiki""",
"""Rimatara""",
"""Rurutu""",
"""Tubuai""",
"""Tahitian""",
"""Marangai""",
"""Napuka""",
"""Parata""",
"""Reao""",
"""Tapuhoe""",
"""Vahitu""",
"""Rapanui""",
"""Sikaiana""",
"""Matema""",
"""Pileni""",
"""Nukapu""",
"""Nupani""",
"""Taumako""",
"""Pukapuka""",
"""Mungiki""",
"""Tikopia""",
"""West Futuna""",
"""Mele""",
"""West Uvean""",
"""Tonga""",
"""Rotuman""",
"""Nalea""",
"""Tubai""",
"""Waya""",
"""Wete""",
"""Iaai""",
"""Nengone""",
"""Nui""",
"""Rälik""",
"""Pingelapese""",
"""Ponapean""",
"""Sapwuahfik""",
"""Fayichuck""",
"""Mid Mortlock""",
"""Upper Mortlock""",
"""Pulapese""",
"""Pulusukese""",
"""Tanapag""",
"""Namonuito""",
"""Satawalese""",
"""Mapia""",
"""Woleaian""",
"""Sonsorolese""",
"""Tobian""",
"""Ulithian""",
"""Malen-Utwe""",
"""Nauru""",
"""Olal""",
"""Port Vato""",
"""Penapo""",
"""Taveak""",
"""Toak""",
"""Emau""",
"""Livara""",
"""Nguna""",
"""Paunangis""",
"""Sesake""",
"""Pang Pang""",
"""South Efate""",
"""Bierebo""",
"""Vovo""",
"""Maii""",
"""Tasiko""",
"""Onesso""",
"""Axamb""",
"""Burmbar""",
"""Katbol""",
"""Lingarak""",
"""Maskelynes""",
"""Vivti""",
"""Nese""",
"""Vao""",
"""Port Sandwich""",
"""Navwien""",
"""Nisvai""",
"""Uripiv""",
"""Wala-Rano""",
"""Nati""",
"""Larevat""",
"""Maragus""",
"""South West Bay""",
"""Letemboi""",
"""Nasarian""",
"""Repanbitip""",
"""Makura""",
"""Mataso""",
"""Tongariki Island""",
"""Tongoa Island""",
"""South Paama""",
"""Loltong""",
"""Melsisi""",
"""Suru-Bo""",
"""Suru-Marani""",
"""Ninebulo""",
"""Ponorwal""",
"""Sowa""",
"""Lombaha""",
"""Longana""",
"""Walaha""",
"""Morouas""",
"""Roria""",
"""Navut""",
"""Tiale""",
"""Lorediakarkar""",
"""Tutuba""",
"""Avunatari""",
"""Shark Bay""",
"""Polonombauk""",
"""Tambotalo""",
"""Piamatsina""",
"""Tasmate""",
"""Tolomako""",
"""Valpei""",
"""Vunapu""",
"""Araki""",
"""Narango""",
"""Tangoa""",
"""Wailapa""",
"""Wusi""",
"""Hano""",
"""Nasawa""",
"""Talise""",
"""Peterara""",
"""Tanoriki""",
"""Marino""",
"""Lo-Toga""",
"""Lakon""",
"""Lehali""",
"""Lehalurup""",
"""Vera'a""",
"""Mwerig""",
"""West Mwerelawa""",
"""Mota""",
"""Nume""",
"""Vetumboso""",
"""Wetamut""",
"""Vulava""",
"""Gela""",
"""Geri""",
"""Ndi""",
"""Nginia""",
"""Ghari""",
"""Tandai-Nggaria""",
"""Ghaimuta""",
"""Lengo""",
"""Paripao""",
"""Malango""",
"""Malagheti""",
"""Moli""",
"""Talise""",
"""Poleo""",
"""Tolo""",
"""Baelelea""",
"""Fataleka""",
"""Gula'alaa""",
"""Kwaio""",
"""Kwara'ae""",
"""Lau""",
"""Suafa""",
"""To'abaita""",
"""Wala""",
"""'Are'are""",
"""Dori'o""",
"""Oroha""",
"""Ulawa""",
"""Wango""",
"""Bauro""",
"""Rawo""",
"""Fagani""",
"""Rihu'a""",
"""Kahua""",
"""Santa Catalina""",
"""Tawarafa""",
"""Pouébo""",
"""Kumak""",
"""Yalayu""",
"""Thuanga""",
"""Numee""",
"""Ouen""",
"""Nemi""",
"""Jawe""",
"""Pije""",
"""Pwaamei""",
"""Pwapwa""",
"""Haeke""",
"""Haveke""",
"""Hmwaveke""",
"""Vamale""",
"""Waamwang""",
"""Paicî""",
"""Arhâ""",
"""Arhö""",
"""Neku""",
"""Orowe""",
"""Tiri""",
"""Xaragure""",
"""Xârâcùù""",
"""Zire""",
"""Potnariven""",
"""Yoku""",
"""Ura""",
"""Itonga""",
"""Loanatit""",
"""Nerauya""",
"""Imafin""",
"""West Tanna""",
"""Weasisi""",
"""Nvhal""",
"""Emira""",
"""Southern Mussau""",
"""Western Mussau""",
"""Tenis""",
"""Nanggu""",
"""Natügu""",
"""Teanu""",
"""Asumboa""",
"""Tanimbili""",
"""Vano""",
"""Uneapa""",
"""Usen""",
"""Lamusong""",
"""Lavatbura""",
"""Ugana""",
"""Katingan""",
"""Lelet""",
"""Malom""",
"""Mesi""",
"""Konomala""",
"""Makada""",
"""Molot""",
"""Label""",
"""Kininanggunan""",
"""Kokopo""",
"""Livuan""",
"""Masawa""",
"""Matupit""",
"""Nodup""",
"""Rakunei""",
"""Raluana""",
"""Rapitok""",
"""Rebar""",
"""Vanumami""",
"""Vunadidir""",
"""Watom""",
"""Minigir""",
"""Pala""",
"""Sokirik""",
"""Katazi""",
"""Kuboro""",
"""Lömaumbi""",
"""Babatana""",
"""Sengan""",
"""Sisiqa""",
"""Varisi""",
"""Fauro""",
"""Mono""",
"""Torau""",
"""Uruava""",
"""Hangan""",
"""Selau""",
"""Touloun""",
"""Matsungan""",
"""Sumoun""",
"""Taiof""",
"""Kurur""",
"""Ratsua""",
"""Melilup""",
"""Petspets""",
"""Taunita""",
"""Wainanana""",
"""Vado-Vaene'""",
"""Vaene'""",
"""Vapopeo'""",
"""Vapopeo'-Rausaura""",
"""Vasui""",
"""Vavoehpoa'""",
"""Pinipel""",
"""Papapana""",
"""Solos""",
"""Kusaghe""",
"""Marovo""",
"""Roviana""",
"""Ughele""",
"""Vangunu""",
"""Kazukuru""",
"""Ghanongga""",
"""Lungga""",
"""Simbo""",
"""Zazao""",
"""Maringe""",
"""Gao""",
"""Zabana""",
"""Siar-Lak""",
"""Sursurunga""",
"""Maket""",
"""Tanga""",
"""Tabar""",
"""Tatau""",
"""Notsi""",
"""Tomoip""",
"""Lauan-Nonopai""",
"""Luburua""",
"""Ngavalus-Lossuk""",
"""West Kara""",
"""Nalik""",
"""Tiang""",
"""Island Tigak""",
"""South Tigak""",
"""West Tigak""",
"""Tungag""",
"""Bola""",
"""Bulu""",
"""Losa""",
"""Maututu""",
"""Ubae""",
"""Vere""",
"""Aribwaung""",
"""Duwet""",
"""Musom""",
"""Nafi""",
"""Labu""",
"""Wampar""",
"""Sarasira""",
"""Sukurum""",
"""Wampur""",
"""North Watut""",
"""Maralango""",
"""Kela""",
"""Yabem""",
"""Numbami""",
"""Kapin""",
"""Lagis""",
"""Chimbuluk""",
"""Mambump""",
"""Mapos""",
"""Papakene""",
"""Wagau""",
"""Wins""",
"""Kumalu""",
"""Piu""",
"""Vehes""",
"""Hote""",
"""Yamap""",
"""Iwal""",
"""Mutu""",
"""Tuam""",
"""Galeg""",
"""Suit""",
"""Yamai""",
"""Yori""",
"""Mindiri""",
"""Wab""",
"""Gedaged""",
"""Southern Marik""",
"""Western Marik""",
"""Matukar""",
"""Serang""",
"""Nanaya""",
"""Ronji""",
"""Lokep""",
"""Karnai""",
"""Singorokai""",
"""Mur Pano""",
"""Maleu""",
"""Northern Mbula""",
"""Mbula""",
"""Sakar""",
"""Mamusi""",
"""North Coast Mengen""",
"""South Coast Mengen""",
"""Sio""",
"""Lesing""",
"""Apalik""",
"""Gimi""",
"""Umua""",
"""Apsokok""",
"""Bao""",
"""Karore""",
"""Kaulong""",
"""Miu""",
"""Sengseng""",
"""Lomogai""",
"""Musen""",
"""Paret""",
"""Pulie-Rauto""",
"""Tourai""",
"""Wanam""",
"""Ormu""",
"""Tobati""",
"""Podena""",
"""Bonggo""",
"""Kaptiau""",
"""Masimasi""",
"""Sobei""",
"""Wakde""",
"""Tarpia""",
"""Yamna""",
"""Terebu""",
"""Kairiru""",
"""Sepa""",
"""Wogeo""",
"""Medebur""",
"""Yakamul""",
"""Tumleo""",
"""Malol""",
"""Sissano""",
"""Ulau-Suain""",
"""Maisin""",
"""Miniafia""",
"""Doga""",
"""Gapapaiwa""",
"""Ghayavi""",
"""Kaninuwa""",
"""Ubir""",
"""Naura""",
"""Taupota""",
"""Wa'ema""",
"""Maiwala""",
"""Minaveha""",
"""Bohilai""",
"""Diwinai""",
"""Huhuna""",
"""Kehelala""",
"""Labe""",
"""Lelehudi""",
"""Sideya""",
"""Yaleba""",
"""Lavora""",
"""Topura""",
"""Yapoa""",
"""Yakaikeke""",
"""Belebele I""",
"""Bwaidoga""",
"""Faiyava""",
"""Kalauna""",
"""Kilia""",
"""Kiliva""",
"""Lauwela""",
"""Mataitai""",
"""Wagifa""",
"""Central Vivigani""",
"""Goiala""",
"""Idakamenai""",
"""Kalauna""",
"""Ufaufa""",
"""Ufufu""",
"""Waibula""",
"""Central Diodio""",
"""Iauiaula""",
"""Utalo""",
"""Didigavu""",
"""Gwabegwabe""",
"""Masimasi""",
"""Southern Yamalele""",
"""Maiadomu""",
"""Koluwawa""",
"""Tala'ai""",
"""Tosila'ai""",
"""Gameta""",
"""Garea""",
"""Sebutuia""",
"""Urua""",
"""Wadalei""",
"""Kasikasi""",
"""Kerorogea""",
"""Kumalahu""",
"""Lomitawa""",
"""Meudana""",
"""Bunama""",
"""Sawabwala""",
"""Sawatupwa""",
"""Sipupu""",
"""Weyoko""",
"""Mwatebu""",
"""Galubwa""",
"""Loboda""",
"""Sanaroa""",
"""Ubuia""",
"""Guleguleu""",
"""Mwalukwasia""",
"""Siausi""",
"""Somwadina""",
"""Central Sewa Bay""",
"""Darubia""",
"""Maiabare""",
"""Miadeba""",
"""Sewataitai""",
"""Sibonai""",
"""Gumawana""",
"""South Kakabai""",
"""Buhutu""",
"""Wale""",
"""Oya'oya""",
"""Saliba""",
"""Bonarua""",
"""Dahuni""",
"""Daui""",
"""Leileiafa""",
"""Suau""",
"""Sinaki""",
"""Unubahe""",
"""Wagawaga""",
"""Magori""",
"""Yoba""",
"""Ouma""",
"""Babaga""",
"""Kalo""",
"""Kapari""",
"""Lalaura""",
"""Maopa""",
"""Keapara""",
"""Wanigela""",
"""Babagarupu""",
"""Balawaia""",
"""Boku""",
"""Buaga""",
"""Ikega""",
"""Ikolu""",
"""Kubuli""",
"""Kwaibida""",
"""Kwaibo""",
"""Omene""",
"""Oruone""",
"""Saroa""",
"""Taboro""",
"""Tubulamo""",
"""Vora""",
"""Wiga""",
"""Western Motu""",
"""Lala""",
"""North Mekeo""",
"""Northwest Mekeo""",
"""West Mekeo""",
"""Toura""",
"""Paitana""",
"""Roro""",
"""Sinaketa""",
"""Vakuta""",
"""Lougaw""",
"""Nawyem""",
"""Wamwan""",
"""Yanaba""",
"""Tewatewa""",
"""Panawina""",
"""Sabari""",
"""Western Point""",
"""Griffin Point""",
"""Jelewaga""",
"""Pamela""",
"""Rambuso""",
"""Yapese""",
"""Kuri""",
"""Bedoanas""",
"""Erokwanas""",
"""Bo'o""",
"""Bosnik""",
"""Dwar""",
"""Fairi""",
"""Jenures""",
"""Kamer""",
"""Korido""",
"""Korim""",
"""Mandusir""",
"""Mapia""",
"""Mios Num""",
"""Mofu""",
"""Monoarfu""",
"""Opif""",
"""Padoa""",
"""Penasifu""",
"""Rumberpon""",
"""Samberi""",
"""Sampori""",
"""Sor""",
"""Sorendidori""",
"""Sorido""",
"""Sundei""",
"""Vogelkop""",
"""Wadibu""",
"""Wardo""",
"""Wari""",
"""Warsa""",
"""Roon""",
"""Dusner""",
"""Meoswar""",
"""Yaur""",
"""Yeretuar""",
"""Ambai""",
"""Randawaya""",
"""Ansus""",
"""Ambumi""",
"""Bintuni""",
"""Dasener""",
"""Wamesa""",
"""Wasior""",
"""Windesi""",
"""Woi""",
"""Papuma""",
"""Serui-Laut""",
"""Wabo""",
"""Yoke""",
"""Mor""",
"""Metsam""",
"""As""",
"""Kawe""",
"""Legenyem""",
"""Batanta Island""",
"""Ma'ya""",
"""Wauyai""",
"""Wayamli""",
"""Maba""",
"""Patani""",
"""Kobe""",
"""Messa-Dote""",
"""Sawai""",
"""Weda""",
"""East Makian""",
"""Tandia""",
"""Napan""",
"""Waropen Kai""",
"""Rotanese Chamorro""",
"""Enggano""",
"""Pahu""",
"""Tunjung Linggang""",
"""Tunjung Londong""",
"""Bezanozano""",
"""Merina""",
"""Sihanaka""",
"""Tanala""",
"""Southern Betsimisaraka""",
"""Tesaka Malagasy""",
"""Kibushi-Kimaore""",
"""Vezo""",
"""Tsimihety Malagasy""",
"""Tanosy Malagasy""",
"""Tandroy-Mahafaly Malagasy""",
"""Bakoi""",
"""Bantian""",
"""Banuwang""",
"""Bawu""",
"""Benua""",
"""Kali""",
"""Karau""",
"""Lawa""",
"""Lolang""",
"""Mantararen""",
"""Njumit""",
"""Pasir""",
"""Purai""",
"""Purung""",
"""Tuwang""",
"""Tawoyan""",
"""Dusun Malang""",
"""Dusun Witu""",
"""Samihim""",
"""Sihong""",
"""Paku""",
"""Jaya Bakti""",
"""Kajoa""",
"""Matalaang""",
"""Poso""",
"""Roti""",
"""Same'""",
"""Sulamu""",
"""Tongian 1""",
"""Tongian 2""",
"""Wallace""",
"""Mapun""",
"""Kawang""",
"""Kota Belud""",
"""Papar""",
"""Pitas Bajau""",
"""Putatan""",
"""Sandakan Bajau""",
"""Kabinga'an""",
"""Lutangan""",
"""Balangingi""",
"""Sibuco-Vitali""",
"""Sibuguey""",
"""Bajau Darat""",
"""Bajau Laut""",
"""Bajau Semporna""",
"""Balimbing""",
"""Bongao""",
"""Laminusa""",
"""Languyan""",
"""Obian""",
"""Sama""",
"""Sapa-Sapa""",
"""Sibutu'""",
"""Sikubung""",
"""Simunul""",
"""Sitangkai""",
"""Tandubas""",
"""Ubian""",
"""Pangutaran Sama""",
"""Yakan""",
"""Kadorih""",
"""Ot Balawan""",
"""Ot Banu'u""",
"""Ot Murung 1""",
"""Ot Olang""",
"""Ot Tuhup""",
"""Sarawai""",
"""Sebaung""",
"""Ulu Ai'""",
"""Siang""",
"""Bakumpai""",
"""Mantangai""",
"""Pulopetak""",
"""Camarines Norte Agta""",
"""Naga""",
"""Southern Catanduanes Bicolano""",
"""Mt. Iraya Agta""",
"""Mt. Iriga Agta""",
"""Daraga""",
"""Libon""",
"""Ligao""",
"""Oas""",
"""Iriga Bicolano""",
"""Northern Catanduanes Bicolano""",
"""Calatravanhon""",
"""Odionganon""",
"""Sibalenhon""",
"""Simaranhon""",
"""Cebu""",
"""Leyte""",
"""Mindanao Visayan""",
"""Kari""",
"""Kawayan""",
"""Hiligaynon""",
"""Masbatenyo""",
"""Porohanon""",
"""Romblon""",
"""Sibuyan""",
"""Kinabalian""",
"""Samar-Leyte""",
"""Waray""",
"""Waray Sorsogon""",
"""Magahat""",
"""Tausug""",
"""Tandaganon""",
"""Malaynon""",
"""Bulalakaw""",
"""Dispoholnon""",
"""Looknon""",
"""Guimaras Island""",
"""Hamtik""",
"""Lambunao""",
"""Miag-Ao""",
"""Pandan""",
"""Pototan""",
"""Sulod""",
"""Santa Teresa""",
"""Mamanwa""",
"""Mansaka""",
"""South Kamayo""",
"""Lactan""",
"""Piso""",
"""Tumuaong""",
"""Tagakaulu Kalagan""",
"""Batangas""",
"""Bulacan""",
"""Lubang""",
"""Manila""",
"""Marinduque""",
"""Tanay-Paete""",
"""Tayabas""",
"""Ilud""",
"""Iranun""",
"""Laya""",
"""Sibugay""",
"""Tagakawanan""",
"""Maranao""",
"""Bolango""",
"""Buol""",
"""Gorontalo Kota""",
"""Limboto""",
"""Tilamuta""",
"""West Gorontalo""",
"""Kaidipan""",
"""Lolak""",
"""Lolayan""",
"""Pasia""",
"""Ponosakan""",
"""Matig-Salud""",
"""Tala Ingod""",
"""Tigwa""",
"""Surigao""",
"""Umayam""",
"""Dibabawon Manobo""",
"""Rajah Kabunsuwan Manobo""",
"""Kidapawan Manobo""",
"""Magpet Manobo""",
"""Livunganen""",
"""Puleniyan""",
"""Kiriyenteken""",
"""Pulangiyen""",
"""Tasaday""",
"""Tagabawa""",
"""Higaonon""",
"""Cinamiguin Manobo""",
"""Central Tagbanwa""",
"""Tagbanwa""",
"""Southwest Palawano""",
"""Central Palawano""",
"""Taut Batu""",
"""Western Tawbuid""",
"""Buhid""",
"""Bulalakawnon""",
"""Gubatnon""",
"""Kagankan""",
"""Waigan""",
"""Wawan""",
"""Eastern Subanen""",
"""Dikayu""",
"""Salog""",
"""Lapuyan Subanun""",
"""Palaui Island Agta""",
"""Ibatan""",
"""Surabaya""",
"""Indramayu""",
"""Jawa Halus""",
"""Manuk""",
"""Pasisir""",
"""Tembung""",
"""Cirebon""",
"""Solo""",
"""Tegal""",
"""New Caledonian Javanese""",
"""Osing""",
"""Tengger""",
"""Lampung Api""",
"""Kota Bumi""",
"""Menggala""",
"""Rara Bakati'""",
"""Sara""",
"""Benyadu'""",
"""Dongay""",
"""Empawa""",
"""Grogo""",
"""Gumbang""",
"""Krokong""",
"""Serambau""",
"""Singge""",
"""Stenggang Jagoi""",
"""Suti""",
"""Taup""",
"""Tengoh""",
"""Stang""",
"""Tibia""",
"""Bukar Sadong""",
"""Mentuh Tapuh""",
"""Lebong""",
"""Musi""",
"""Pasisir""",
"""Rawas""",
"""Tringgus""",
"""Sanggau""",
"""Kembayan""",
"""Ribun""",
"""Bihak""",
"""Gerai""",
"""Semandang""",
"""Bawean""",
"""Pamekesan""",
"""Sampang""",
"""Sapudi""",
"""Sumenep""",
"""Baruh""",
"""Bueng""",
"""Daja""",
"""Pase""",
"""Pidie""",
"""Tunong""",
"""Western Cham""",
"""Haroi""",
"""Rai""",
"""Tsat""",
"""Chuty""",
"""Golar""",
"""Habau""",
"""Hodrung""",
"""Jhue""",
"""Pleikly""",
"""Puan""",
"""Sesan""",
"""To-Buan""",
"""Bih""",
"""Blo""",
"""Kodrao""",
"""Krung 1""",
"""Ndhur""",
"""Rde Kpa""",
"""Lowland Bali""",
"""Nusa Penida""",
"""Meno-Mene""",
"""Mriak-Mriku""",
"""Ngeno-Ngene""",
"""Ngeto-Ngete""",
"""Sumbawa""",
"""Cocos Islands Malay""",
"""Peranakan Indonesian""",
"""Sabah Malay""",
"""Kuala""",
"""Bukit Malay""",
"""Kampong Ayer""",
"""Kedayan""",
"""Kota Bangun Kutai Malay""",
"""Northern Kutai""",
"""Tenggarong Kutai""",
"""Gorap""",
"""Bugau""",
"""Dau""",
"""Lemanak""",
"""Skrang""",
"""Ulu Ai""",
"""Undup""",
"""Mualang""",
"""Remun""",
"""Seberuang""",
"""Sebuyau""",
"""Loncong""",
"""Duano""",
"""Indonesian""",
"""Suku Batin""",
"""Ulu""",
"""Dawas""",
"""Djambi""",
"""Lalang""",
"""Nomadic Kubu""",
"""Ridan""",
"""Supat""",
"""Tungkal""",
"""Tungkal Ilir""",
"""Ulu Lako""",
"""Standard Malay""",
"""Mamaq""",
"""Sakei""",
"""Talang""",
"""Ulu""",
"""Lembak Sindang""",
"""Haji""",
"""Kaur""",
"""Aneuk Jamee""",
"""Batu Sangkar-Pariangan""",
"""Kerinci-Minangkabau""",
"""Orang Mamak""",
"""Pajokumbuh""",
"""Penghulu""",
"""Si Junjung""",
"""Singkarak""",
"""Tanah""",
"""Ulu""",
"""Negeri Sembilan Malay""",
"""Pekal""",
"""Kedah Malay""",
"""Malay""",
"""Old Malay""",
"""Orang Kanaq""",
"""Orang Seletar""",
"""Pattani Malay""",
"""Belanda""",
"""Berembun""",
"""Mantra""",
"""Temuan""",
"""Udai""",
"""Urak Lawoi'""",
"""Banda Malay""",
"""Larantuka Malay""",
"""North Moluccan Malay""",
"""Papuan Malay""",
"""Makassar Malay""",
"""Malaccan Creole Malay""",
"""Sri Lanka Malay""",
"""Kendayan""",
"""Keninjal""",
"""Banana'""",
"""Belantikan""",
"""Delang""",
"""Kayung""",
"""Lamandau""",
"""Mentebah-Suruk""",
"""Riam""",
"""Semitau""",
"""Suhaid""",
"""Sukamara""",
"""Tapitn""",
"""Bogor""",
"""Cirebon""",
"""Pringan""",
"""Tomohon""",
"""Tondano""",
"""Remboken""",
"""Kalabat Atas""",
"""Kauditan""",
"""Likupang""",
"""Maumbi""",
"""Sonder""",
"""Tompaso""",
"""Tonsawang""",
"""Ja-It""",
"""L'be""",
"""Moklen""",
"""Nasal""",
"""East Berawan""",
"""West Berawan""",
"""Long Kiput""",
"""Long Tutoh""",
"""Tutong""",
"""Lelak""",
"""Narom""",
"""Bintulu""",
"""Brung""",
"""Lepu Potong""",
"""Libbung""",
"""Lon Bangag""",
"""Lengilu""",
"""Sa'ban""",
"""Tring""",
"""Balait""",
"""Kolur""",
"""Lepu Potong""",
"""Lun Bawang""",
"""Lun Dayah""",
"""Lun Daye""",
"""Padas""",
"""Trusan""",
"""Long Atip""",
"""Long Bleh""",
"""Mahakam Busang""",
"""Kayan Mahakam""",
"""Mendalam Kayan""",
"""Wahau Kayan""",
"""Uma Lakan""",
"""Lugat""",
"""Long Wat""",
"""Lisum""",
"""Long Badan""",
"""Long Geng""",
"""Long Kehobo""",
"""Long Murun""",
"""Ma'aging""",
"""Uma Daro""",
"""Uma Juman""",
"""Kelingan""",
"""Liah Bing""",
"""Long Bento'""",
"""Long Glat""",
"""Nahes""",
"""Segah""",
"""Semukung Uheng""",
"""Long Semiang""",
"""Uma Bem""",
"""Uma Jalam""",
"""Uma Tau""",
"""Kemena Penan""",
"""Long Bangan""",
"""Lunan""",
"""Uma Bakah""",
"""Uma' Lung""",
"""Punan Tubu""",
"""Lirong""",
"""Long Atun""",
"""Long Ekang""",
"""Long Luyang""",
"""Long Pokun""",
"""Tinjar Sibop""",
"""Jelalong Penan""",
"""Nibong""",
"""Penan Apo""",
"""Penan Gang""",
"""Penan Lanying""",
"""Penan Lusong""",
"""Penan Silat""",
"""Sipeng""",
"""Ida'an""",
"""Subpan""",
"""Lahanan""",
"""Sekapan""",
"""Bruit""",
"""Dalat""",
"""Igan""",
"""Mukah-Oya""",
"""Prehan""",
"""Sarikei""",
"""Segahan""",
"""Segalang""",
"""Siteng""",
"""Matu""",
"""Seduan""",
"""Punan Batu 1""",
"""Punan Merah""",
"""Sian""",
"""Punan Ukit""",
"""Ukit""",
"""Binatang""",
"""Bulungan""",
"""Dumaring""",
"""Jembayan""",
"""Karangan""",
"""Punan Biau""",
"""Punan Batu 2""",
"""Punan Sajau""",
"""Lotud""",
"""Sabah Bisaya""",
"""Bundu""",
"""Dusun Sinulihan""",
"""Kadazan-Tagaro""",
"""Kiundu""",
"""Kuala Monsok Dusun""",
"""Luba""",
"""Menggatal""",
"""Pahu'""",
"""Ranau""",
"""Sokid""",
"""Tindal""",
"""Coastal Kadazan""",
"""Minokok""",
"""Tinagas""",
"""Tambunan Dusun""",
"""Tempasuk Dusun""",
"""Sandayo""",
"""Sonsogon""",
"""Tandek""",
"""Klias River Kadazan""",
"""Kota Marudu Talantang""",
"""Kuijau""",
"""Lamag Sungai""",
"""Mangkaak""",
"""Sukang""",
"""Rungus""",
"""Nulu""",
"""Tobilung""",
"""Serudung Murut""",
"""Rumanau""",
"""Tampias Lobu""",
"""Kalabuan""",
"""Makiang""",
"""Sinabu'""",
"""Okolod""",
"""Sembakung Murut""",
"""Kokoroton Murut""",
"""Tengara""",
"""Gana""",
"""Dusun Murut""",
"""Nabay""",
"""Makaheeliga""",
"""Paluan""",
"""Pandewan""",
"""Sook Murut""",
"""Takapan""",
"""Maligan""",
"""Pensiangan Murut""",
"""Rundum""",
"""Salalir""",
"""Sapulot Murut""",
"""Sumambu""",
"""Tagal""",
"""Tawan""",
"""Tolokoson""",
"""Tomani""",
"""Penchangan""",
"""Sedalir""",
"""Sesayap""",
"""Sibuku""",
"""Tarakan""",
"""Tidung""",
"""Bukau""",
"""Dabugus""",
"""Kapagalan""",
"""Lower Murut""",
"""Murut Padas""",
"""Poros""",
"""Sandiwar""",
"""Timugon""",
"""Papar""",
"""Tatana""",
"""Alag-Bako""",
"""Pagbahan""",
"""Palauan-Calavite""",
"""Pambuhan""",
"""Santa Cruz""",
"""Tadyawan""",
"""Western Addasen""",
"""Pamplona Atta""",
"""Pudtol Atta""",
"""Gaddang""",
"""Central Cagayan Agta""",
"""Malaweg""",
"""Yogad""",
"""South Ibanag""",
"""Malaweg""",
"""Calanasan""",
"""Dibagat-Kabugao""",
"""Karagawan""",
"""Talifugu-Ripang""",
"""Dicamay Agta""",
"""Iloko""",
"""Inlaod Itneg""",
"""Balatok-Kalinga""",
"""Balbalasang""",
"""Guinaang""",
"""Lubuagan""",
"""Pinangol""",
"""Tinaloctoc""",
"""Mallango""",
"""Sumadel""",
"""Tinglayan""",
"""Masadiit Sallapadan""",
"""Moyadan Itneg""",
"""Gubang Itneg""",
"""Malibcong Banao""",
"""Mabaka Valley Kalinga""",
"""Guinaang Bontoc""",
"""Sadanga""",
"""Kadaklan""",
"""Lias""",
"""Guinzadan""",
"""Kapangan""",
"""Mankayan-Buguias""",
"""Northern Kankanay""",
"""Burnay Ifugao""",
"""Ducligan Ifugao""",
"""Batad Ifugao""",
"""Mayoyao Ifugao""",
"""Hungduan Ifugao""",
"""Lagawe Ifugao""",
"""Egongot""",
"""Ibalao""",
"""Italon""",
"""Iyongut""",
"""Daklan""",
"""Kabayan""",
"""Tinoc Kallahan""",
"""Ya-Tuka""",
"""Karao""",
"""Pangasinan""",
"""Southern Alta""",
"""Bolos Point""",
"""Camonayan""",
"""Palaui Island""",
"""Peñablanca""",
"""Roso""",
"""Santa Ana-Gonzaga""",
"""Santa Margarita""",
"""Tanglagan""",
"""Valley Cove""",
"""Yaga""",
"""Dorot""",
"""Serbodjadi""",
"""Tampur""",
"""Pagai""",
"""Sakalagan""",
"""Saumanganja""",
"""Silabu""",
"""Simalegi""",
"""Sipura""",
"""South Siberut""",
"""Taikaku""",
"""Nias""",
"""Tapah""",
"""Simeulue""",
"""Batak Dairi""",
"""Batak Mandailing""",
"""Batak Toba""",
"""Palauan""",
"""Sarangani""",
"""North Tabukang""",
"""Siau""",
"""South Tabukang""",
"""Tamako""",
"""Awit""",
"""Beo""",
"""Dapalan""",
"""Essang""",
"""Kaburuang""",
"""Lirang""",
"""Nenusa-Maingas""",
"""South Karakelong""",
"""Ratahan""",
"""Konjo Pesisir""",
"""Tana Toa""",
"""Highland Konjo""",
"""Maros-Pangkep""",
"""Turatea""",
"""Selayar""",
"""Padang""",
"""Sinyonyoi""",
"""Sumare-Rangas""",
"""Majene""",
"""Malunda""",
"""Pamboang""",
"""Sendana""",
"""Kalosi""",
"""Pattinjo""",
"""Ranga""",
"""Maiwa""",
"""Malimpung""",
"""Mambi""",
"""Tabulahan""",
"""Bumal""",
"""Issilita'""",
"""Matangnga""",
"""Mehalaan""",
"""Pakkau""",
"""Pattae'""",
"""Salu Mokanam""",
"""Sondoang""",
"""Tappalang""",
"""Tapango""",
"""Karataun""",
"""Mablei""",
"""Mangki""",
"""Northern Mamasa""",
"""Pattae'""",
"""Northeast Luwu""",
"""Rongkong""",
"""South Luwu""",
"""Talondo'""",
"""Rantepao""",
"""Toraja Barat""",
"""Panasuan""",
"""Lodang""",
"""Seko Tengah""",
"""Bone""",
"""Camba""",
"""Luwu""",
"""Pangkep""",
"""Pasangkayu""",
"""Sawitto""",
"""Sidrap""",
"""Sinjai""",
"""Soppeng""",
"""Wajo""",
"""Campalagian""",
"""Taman""",
"""Tungho""",
"""Paiwan""",
"""Taokas""",
"""Papora""",
"""Shtafari""",
"""Pinan""",
"""Labuan""",
"""Maga""",
"""Mantauran""",
"""Tanan""",
"""Tona""",
"""Iimutsu""",
"""Luhtu""",
"""Tapangu""",
"""Tfuea""",
"""Eastern Aleut""",
"""Western Aleut""",
"""Labrador Eskimo""",
"""Quebec Eskimo""",
"""North Slope Inupiatun""",
"""Point Hope Inupiatun""",
"""West Arctic Inupiatun""",
"""King Island Inupiatun""",
"""Kobuk River Inupiatun""",
"""Kotzebue Sound Inupiatun""",
"""Northern Malimiut Inupiatun""",
"""Seward Peninsula Inupiatun""",
"""Southern Malimiut Inupiatun""",
"""Polar Eskimo""",
"""West Greenlandic""",
"""Tunumiisiut""",
"""Copper Inuktitut""",
"""Netsilik""",
"""Siglit""",
"""Koniag""",
"""Chaplino""",
"""Noohalit""",
"""Wooteelit""",
"""Naukan Yupik""",
"""Sirenik Yupik""",
"""Ligo""",
"""Nyangbara""",
"""Nyepu""",
"""Pöjulu""",
"""Kakwa""",
"""Mandari""",
"""Lango""",
"""Lokoya""",
"""Lopit""",
"""Logiri""",
"""Logotok""",
"""Lomya""",
"""Lorwama""",
"""Lowudo""",
"""Damat""",
"""Iloodokilani""",
"""Kaputiei""",
"""Keekonyokie""",
"""Kisonko""",
"""Kore""",
"""Laitokitok""",
"""Loitai""",
"""Matapo""",
"""Moitanik""",
"""Parakuyo""",
"""Purko""",
"""Siria""",
"""Orom""",
"""Jie""",
"""Karamojong""",
"""Nyangatom""",
"""Jiye""",
"""Western Toposa""",
"""Southern Turkana""",
"""Nandi""",
"""Terik""",
"""Tugen""",
"""Sabiny""",
"""Sor""",
"""Book""",
"""Koony""",
"""Sambirir""",
"""West Pokot""",
"""Sogoo""",
"""Suiei""",
"""Barabayiiga""",
"""Bianjiida""",
"""Buraadiiga""",
"""Gisamjanga""",
"""Rootigaanga""",
"""Tsimajeega""",
"""Ageer""",
"""Dongjol""",
"""Luac""",
"""Ngok-Sobat""",
"""Rut""",
"""Thoi""",
"""Ngok-Kordofan""",
"""Pan Aru""",
"""Pawany""",
"""Aliap""",
"""Ciec""",
"""Gok""",
"""Bor""",
"""Ghol""",
"""Nyarweng""",
"""Tuic""",
"""Aguok""",
"""Apuk""",
"""Awan""",
"""Lau""",
"""Luac""",
"""Malual""",
"""Paliet""",
"""Palioupiny""",
"""Rek""",
"""Tuic""",
"""Cien""",
"""Dor""",
"""Eastern Jikany""",
"""Eastern Nuer""",
"""Lou""",
"""Nyuong""",
"""Thiang""",
"""Thognaath""",
"""Western Jikany""",
"""Reel""",
"""Maiak""",
"""Mufwa""",
"""Mughaja""",
"""Ragreig""",
"""Mabaan""",
"""Coro""",
"""Lul""",
"""Opëno""",
"""Belanda Bor""",
"""Luwo""",
"""Päri""",
"""Shilluk""",
"""Colo""",
"""Manangeer""",
"""Labwor""",
"""Nyakwai""",
"""Luo""",
"""Jonam""",
"""Mambisa""",
"""Wanyoro""",
"""Lango""",
"""Lower Bamu""",
"""Nuhiro""",
"""Sisiame""",
"""Upper Bamu""",
"""Gibaio""",
"""Kope""",
"""Urama""",
"""Daru Kiwai""",
"""Doumori""",
"""Eastern Kiwai""",
"""Island Kiwai""",
"""Southern Coast Kiwai""",
"""Morigi""",
"""Waboda""",
"""Djadha""",
"""Njawlo""",
"""Pidha""",
"""Tadha""",
"""Ngiti""",
"""Malele""",
"""Meje""",
"""Mangbetu""",
"""Popoi""",
"""Efe""",
"""Fare""",
"""Lese Karo""",
"""Ndese""",
"""Vukutu""",
"""Mvuba""",
"""Mamvu""",
"""Angwe""",
"""Makutana""",
"""Membi""",
"""Oke'bu""",
"""Avokaya Pur""",
"""Northern Ogambi""",
"""Ojila""",
"""Dogo""",
"""Eastern Keliko""",
"""Western Keliko""",
"""Omi""",
"""Bhagira""",
"""Doka""",
"""Lolya""",
"""Obilebha""",
"""Ogambi""",
"""Aluru""",
"""Arua""",
"""Lu""",
"""Maracha""",
"""Nio""",
"""Otsho""",
"""Terego""",
"""Zaki""",
"""Agi""",
"""Andri""",
"""Kadiro""",
"""Lakama'di""",
"""Miza""",
"""Moruwa'di""",
"""Burulo""",
"""Lokai""",
"""Moyo""",
"""Pandikeri""",
"""Olu'bo""",
"""Okollo""",
"""Rigbo""",
"""Sopi""",
"""Wulu""",
"""Mo'da""",
"""Ma'du""",
"""Morokodo""",
"""Modo""",
"""Wetu""",
"""Wira""",
"""Nyamusa""",
"""Busere Bongo""",
"""Tonj Bongo""",
"""Mele""",
"""Mere""",
"""Molo""",
"""Mot-Mar""",
"""Nguru""",
"""Sar""",
"""Zura""",
"""Kara""",
"""Nduga""",
"""Nduka""",
"""Lutos""",
"""Wada""",
"""Tana""",
"""Dam""",
"""Gol""",
"""Kibar""",
"""Disa""",
"""Banama""",
"""Bidjir""",
"""Bolong""",
"""Cenge""",
"""Morbo""",
"""Morom""",
"""Jaya""",
"""Manawadji""",
"""Mondogossou""",
"""Yiryo""",
"""Kuka""",
"""Medogo""",
"""Pen""",
"""Horo""",
"""Nar""",
"""No""",
"""Goula""",
"""Mang""",
"""Maïngao""",
"""Paï""",
"""Benoye""",
"""Kere""",
"""Lara""",
"""Murum""",
"""Bedjond""",
"""Yom""",
"""Yamod""",
"""Mango""",
"""Bédjou""",
"""Bédégué""",
"""Kan""",
"""Mougo""",
"""Ngoka""",
"""Kon Ngam""",
"""Ngam Gir Bor""",
"""Ngam Tel""",
"""Ngam Tira""",
"""Mara""",
"""Siime""",
"""Dunje""",
"""Na""",
"""Tie""",
"""So""",
"""Yulu""",
"""Sinyar""",
"""Millcayac""",
"""Nanubae""",
"""Tapei""",
"""Luofu""",
"""Jiongnai Bunu""",
"""Northern Qiandong Miao""",
"""Southern Qiandong Miao""",
"""Western Xiangxi Miao""",
"""Dongnu""",
"""Naogelao""",
"""Numao""",
"""Nunu""",
"""Hmong Xi""",
"""Mong Leng""",
"""Petchabun Miao""",
"""Hmong Shua""",
"""Horned Miao""",
"""Northern Hmong""",
"""Hmong Dô""",
"""Small Flowery Miao""",
"""Southern Guiyang Hmong""",
"""Southwestern Guiyang Hmong""",
"""Eastern Huishui Hmong""",
"""Northern Huishui Hmong""",
"""Southwestern Huishui Hmong""",
"""Large Flowery Miao""",
"""Luopohe Hmong""",
"""Northern Mashan Hmong""",
"""Southern Mashan Hmong""",
"""Western Mashan Hmong""",
"""Wunai Bunu""",
"""Younuo Bunu""",
"""Jiaogong Mian""",
"""Dzao Min""",
"""Shi Mun""",
"""Chiangrai""",
"""Dao Do""",
"""Dao Lan Tien""",
"""Dao Lo Gang""",
"""Deo Tien""",
"""Quan Chet""",
"""Quan Trang""",
"""Dao Quan Trang""",
"""Soo""",
"""Western Highland Purepecha""",
"""Layana""",
"""Southern Lengua""",
"""Sanapana""",
"""Toba-Maskoy""",
"""Western Jicaque""",
"""Gogodala""",
"""Waruna""",
"""Suki""",
"""Hibito""",
"""Kimiai""",
"""Tipai""",
"""Paipai""",
"""Walapai""",
"""Yavapai""",
"""Maricopa""",
"""Mohave""",
"""Quechan""",
"""Kiliwa""",
"""Southern Aymara""",
"""Xatia""",
"""Kham""",
"""Vaal-Orange""",
"""Bu'u""",
"""Miyatnu""",
"""Sawuve""",
"""Wiyagwa""",
"""Wunavai""",
"""Tainae""",
"""Baruya""",
"""Usirampia""",
"""Wantakia""",
"""Simbari""",
"""Kaintiba""",
"""Hamtai""",
"""Pmasa'a""",
"""Wenta""",
"""Menya""",
"""Susuami""",
"""Kawacha""",
"""Wajakes""",
"""Yagwoia""",
"""Chayahuita""",
"""Jesuit-Maynas""",
"""Makolkol""",
"""Mali""",
"""Qaqet""",
"""Simbali""",
"""Ura""",
"""Wulna""",
"""Gun-narta""",
"""Gun-nartpa""",
"""Guragone""",
"""Nakara""",
"""Djeebbana""",
"""Otuke""",
"""Umotína""",
"""Riantana""",
"""Ndom""",
"""Weriagar""",
"""Negri Besar""",
"""Tarof""",
"""Kaburi""",
"""Kais""",
"""Puragi""",
"""Toaripi""",
"""Sepoe""",
"""Opao""",
"""Orokolo""",
"""Semimi""",
"""Teushen""",
"""Selk'nam""",
"""Wardaman""",
"""Yangman""",
"""Seget""",
"""Moraid""",
"""Imyan""",
"""Mbol Fle""",
"""Saifi""",
"""Sawiat Salmeit""",
"""Sfa Riere""",
"""Tehit Jit""",
"""East Sentani""",
"""West Sentani""",
"""Yewena-Yongsu""",
"""Yokari""",
"""Karaginskij""",
"""Palanskij""",
"""Enmylinskij""",
"""Enurmin""",
"""Nunligranskij""",
"""Pevekskij""",
"""Uellanskij""",
"""Xatyrskij""",
"""Yanrakinot""",
"""Mainypilgino""",
"""Cavcuvenskij""",
"""Gin""",
"""Itkan""",
"""Kamenskij""",
"""Palan""",
"""Paren""",
"""Xatyrskij""",
"""Napanskij""",
"""Itelmen""",
"""Sedanka""",
"""Sopocnovskij""",
"""Xajrjuzovskij""",
"""Rapoisi""",
"""Atsilima""",
"""Pipipaia""",
"""Point Arena""",
"""Ukiah""",
"""Sherwood Valley""",
"""Southern Pomo""",
"""Southeastern Pomo""",
"""Ineseño""",
"""Purisimeño""",
"""Ventureño""",
"""Cruzeño""",
"""South Band""",
"""Waco""",
"""Murrinhkura""",
"""Murrinhpatha""",
"""Ngangi-Wumeri""",
"""Ngenkiwumerri""",
"""Tyemeri""",
"""Dima""",
"""Ginuman""",
"""Kanasi""",
"""Gwareta""",
"""Maiwa""",
"""Manigara""",
"""Oren""",
"""Mapena""",
"""Onjob""",
"""Turaka""",
"""Upper Ugu River""",
"""Irupi-Drageli""",
"""Kunini""",
"""Masingle""",
"""Sebe""",
"""Sogal""",
"""Tate""",
"""Western Gizra""",
"""Buglial""",
"""Bulgai""",
"""Tagota""",
"""Dorogori""",
"""Gamaewe""",
"""Guiam""",
"""Iamega""",
"""Kapal""",
"""Kuru""",
"""Peawa""",
"""Podari""",
"""Rual""",
"""Ume""",
"""Wipim""",
"""Woigo""",
"""Wonie""",
"""Yuta""",
"""North Awin""",
"""South Awin""",
"""Pare""",
"""Mongol""",
"""Yaul""",
"""Yidinich""",
"""Tishena""",
"""Tirma""",
"""Narim""",
"""Lotilla""",
"""Olam""",
"""Tennet""",
"""Kacipo""",
"""Kichepo""",
"""Suri""",
"""Western Suri""",
"""Zilmamu""",
"""Samanai""",
"""Lihen""",
"""Mengau""",
"""North Kamberataro""",
"""South Kamberataro""",
"""Mararit""",
"""Girga""",
"""Murasi""",
"""Sebunkik""",
"""Sungor""",
"""Walad Dulla""",
"""Haura""",
"""Orra""",
"""Tama""",
"""Iha""",
"""Gayil""",
"""Karo""",
"""Dime""",
"""Ebitoso""",
"""Zamuco""",
"""Yongolei""",
"""North-South Udab""",
"""Northeast Fuyug""",
"""West Fuyug""",
"""Karuama""",
"""Kأƒآ¢te""",
"""Tauade""",
"""Ono""",
"""Sim""",
"""San Felipe""",
"""Santa Ana""",
"""Santo Domingo""",
"""Zia""",
"""Bayono""",
"""Urningangg""",
"""Tuba""",
"""Dor""",
"""Kobe""",
"""Berti""",
"""Mando""",
"""Nguri""",
"""Tarjumo""",
"""Sugurti""",
"""Tumari""",
"""Guvja""",
"""Kabari""",
"""Kaga""",
"""Kwayam""",
"""Lare""",
"""Maiduguri""",
"""Mao""",
"""Movar""",
"""Mowor""",
"""Ngazar""",
"""Njesko""",
"""Sugurti""",
"""Temageri""",
"""Yerwa""",
"""Fachi""",
"""Manga""",
"""Dazaga""",
"""Ooku""",
"""Neme""",
"""Binahari-Ma""",
"""Domu""",
"""Laua""",
"""Baibara""",
"""Borebo""",
"""Darava""",
"""Derebai""",
"""Domara""",
"""Geagea""",
"""Ilai""",
"""Island""",
"""Morawa""",
"""Small Nyikina""",
"""Warrwa""",
"""Northern Yawuru""",
"""Southern Coastal Yawuru""",
"""Bardi""",
"""Djawi""",
"""Nimanbur""",
"""Nyulnyul""",
"""Nyaro""",
"""Warnang""",
"""Tunduli""",
"""Logol""",
"""Dorobe""",
"""Dugujur""",
"""Dukwara""",
"""Nginyukwur""",
"""Ngirere""",
"""Ngunduna""",
"""Nguqwurang""",
"""Ndano""",
"""Shabun""",
"""Nderre""",
"""Nubwa""",
"""Ulba""",
"""Umm Dorein""",
"""Umm Gabralla""",
"""Werria""",
"""Tira El Akhdar""",
"""Tira Lumum""",
"""Tira Mandi""",
"""Vaupés Cacua""",
"""Nukak Makú""",
"""River Nivaclé""",
"""Iyojwa'ja Chorote""",
"""Wichí Lhamtés Nocten""",
"""Pisaflores Tepehua""",
"""Tlachichilco Tepehua""",
"""Highland Totonac""",
"""Papantla Totonac""",
"""Upper Necaxa Totonac""",
"""Western Totonac""",
"""Yecuatla Totonac""",
"""Terei""",
"""Uisai""",
"""Koromira""",
"""Naasioi""",
"""Orami""",
"""Pakia-Sideronsi""",
"""Ounge""",
"""Sibe""",
"""Mainoki""",
"""Kitja""",
"""Miriwung""",
"""Madngele""",
"""Kalabari""",
"""Kirike""",
"""Nkoroo""",
"""Nembe""",
"""Okodia""",
"""Oruma""",
"""Arogbo""",
"""Basan""",
"""Bumo""",
"""East Olodiama""",
"""East Tarakiri""",
"""Egbema""",
"""Ekpetiama""",
"""Furupagha""",
"""Gbarain""",
"""Iduwini""",
"""Ikibiri""",
"""Kabo""",
"""Kolokuma-Opokuma""",
"""Koluama""",
"""Kumbo""",
"""Mein""",
"""Ogbe Ijo""",
"""Ogboin""",
"""Ogulagha""",
"""Operemo""",
"""Oporomo""",
"""Oporoza""",
"""Oyiakiri""",
"""Tuomo""",
"""West Olodiama""",
"""West Tarakiri""",
"""Taworta""",
"""Saponi""",
"""Iau""",
"""Turu""",
"""Western Duvle""",
"""Kaiy""",
"""Kwerisa""",
"""Papasena""",
"""Waritai""",
"""Eritai""",
"""Obokuitai""",
"""Sikaritai""",
"""Kirikiri""",
"""Tause""",
"""Weirate""",
"""Chiquián Ancash Quechua""",
"""Huallaga Huánuco Quechua""",
"""Panao Huánuco Quechua""",
"""Southern Conchucos Ancash Quechua""",
"""Corongo Ancash Quechua""",
"""Monzón""",
"""Northern Dos de Mayo""",
"""Huaraz""",
"""Yungay""",
"""Margos-Yarowilca-Lauricocha Quechua""",
"""Sihuas Ancash Quechua""",
"""Waycha""",
"""West Waylla""",
"""Jauja Wanca Quechua""",
"""North Junín Quechua""",
"""Santa Ana de Tusi Pasco Quechua""",
"""Yanahuanca Pasco Quechua""",
"""Azángaro-Huangáscar-Chocos""",
"""Cacra-Hongos""",
"""Huancaya-Vitis""",
"""Laraos""",
"""Madean-Viñac""",
"""San Pedro de Huacarpana""",
"""Tana-Lincha""",
"""Tomñs-Alis""",
"""Pacaraos Quechua""",
"""Western Cajamarca""",
"""Chincha Quechua""",
"""Incahuasi""",
"""La Jalca""",
"""Lamud""",
"""Llakwash Chachapoyas""",
"""Cañar Highland Quichua""",
"""Chimborazo Highland Quichua""",
"""Imbabura Highland Quichua""",
"""San Andrés Inga""",
"""Santiago Inga""",
"""Yunguillo-Condagua""",
"""Loja Highland Quichua""",
"""Salasaca Highland Quichua""",
"""Southern Pastaza Quechua""",
"""Tena Lowland Quichua""",
"""San Martín Quechua""",
"""Cotahuasi""",
"""Highland Arequipa""",
"""Northern Arequipa""",
"""Huancavelica""",
"""Charazani""",
"""Chuma""",
"""Cochabamba""",
"""Northwest Jujuy""",
"""Oruro""",
"""Potosí""",
"""Sucre""",
"""Classical Quechua""",
"""Eastern Apurímac Quechua""",
"""Puno Quechua""",
"""Antabamba""",
"""Cotabambas""",
"""North Bolivian Quechua""",
"""Santiago del Estero Quichua""",
"""Pamoa Bara""",
"""Yohoraa""",
"""Pisamira""",
"""Yurutí""",
"""Wa'ikhana""",
"""Tanimuca""",
"""Opaina""",
"""Siriano""",
"""Janera""",
"""Taiwano""",
"""Macuna""",
"""Miriti""",
"""Ecuadorian Siona""",
"""Siona""",
"""Tama""",
"""Julud""",
"""Karoka""",
"""Kateik""",
"""Kiddu""",
"""Kirkpong""",
"""Koldrong""",
"""Tima""",
"""Kelo""",
"""Molo""",
"""Kukur""",
"""Kulang""",
"""Soda""",
"""Kedi""",
"""Damara""",
"""Gimsbok Nama""",
"""Nama""",
"""Namidama""",
"""Sesfontein Damara""",
"""Xiri""",
"""Danisi""",
"""Deti""",
"""Ganádi""",
"""Shua-Khwe""",
"""Tshidi-Khwe""",
"""Tsoa""",
"""Ts'ixa""",
"""Buma-Kxoe""",
"""Kxoedam""",
"""G!inkwe""",
"""G!okwe""",
"""Qabekhoe""",
"""Ts'aokhoe""",
"""Tserekwe""",
"""Tsorokwe""",
"""North Waibuk""",
"""South Waibuk""",
"""Pinai""",
"""Lowland Oaxaca Chontal""",
"""Western Acheron""",
"""Tocho""",
"""Talodi""",
"""Daloka""",
"""Masakin Gusar""",
"""Masakin Tuwal""",
"""Torona""",
"""Gitxsan""",
"""Nisga'a""",
"""Southern Tsimshian""",
"""Northern Masalit""",
"""Nyala""",
"""Southern Masalit""",
"""Western Masalit""",
"""Surbakhal""",
"""Kashmere""",
"""Koniéré""",
"""Karanga""",
"""Yaali""",
"""Bakha""",
"""Dondongo""",
"""Kajanga""",
"""Kelingan""",
"""Kodoo""",
"""Kujinga""",
"""Malanga""",
"""Mandaba""",
"""Mandala""",
"""Nyabadan""",
"""Ouled Djemma""",
"""Marfa""",
"""Murru""",
"""Kibet""",
"""Runga""",
"""Mimi-Nachtigal""",
"""Bambassi""",
"""Seze""",
"""Northeast Maidu""",
"""Northwest Maidu""",
"""Valley Maidu""",
"""Western Kilmeri""",
"""Western Pagi""",
"""Umeda""",
"""Taikat""",
"""Auwe""",
"""Daonda""",
"""Imonda""",
"""Manem""",
"""Senggi""",
"""Waina""",
"""Waris""",
"""East Yawa""",
"""North Yawa""",
"""South Yawa""",
"""West Yawa""",
"""Saweru""",
"""Ngkâlmpw Kanum""",
"""Sota Kanum""",
"""Smärky Kanum""",
"""Namat""",
"""Nambo""",
"""Namo""",
"""Neme""",
"""Nen""",
"""Ránmo""",
"""Rema""",
"""Kamã""",
"""Kánchá""",
"""Semariji""",
"""Kómnjo""",
"""Wára""",
"""Wèré""",
"""Upper Yei""",
"""Konai""",
"""Gobasi""",
"""Oiba""",
"""Kubo""",
"""Samo""",
"""Odoodee""",
"""Namunka""",
"""Orichen""",
"""Tez""",
"""Bikin""",
"""Iman""",
"""Khor""",
"""Khungari""",
"""Samargin""",
"""Sikhota Alin""",
"""Birar""",
"""Kila""",
"""Kuro-Urmi""",
"""Samagir""",
"""Sunggari""",
"""Torgon""",
"""Ussuri""",
"""Val-Nogliki""",
"""Ulch""",
"""Bala""",
"""Jing""",
"""Lalin""",
"""Xibe""",
"""Indigirka""",
"""Kamchatka""",
"""Kolyma-Omolon""",
"""Lamunkhin""",
"""Okhotsk""",
"""Ola""",
"""Sakkyryr""",
"""Tompon""",
"""Upper Kolyma""",
"""Chenba'erhu""",
"""Haila'er""",
"""Huihe""",
"""Morigele""",
"""Verkhovsk""",
"""Heilongjiang Oroqen""",
"""Chiricoa""",
"""Chiripo""",
"""Masiguare""",
"""Masiware""",
"""Mayayero""",
"""Mochuelo-Casanare-Cuiba""",
"""Tampiwi""",
"""Yarahuuraxi-Capanapara""",
"""Guahibo""",
"""Tigrero""",
"""Playero""",
"""Guayabero""",
"""Macaguán""",
"""Pei""",
"""Tuwari""",
"""Yawiyo""",
"""Toba-Pilagá""",
"""Southeast Toba""",
"""Kadiwéu""",
"""Atsugewi""",
"""Tyaraity""",
"""Uru""",
"""Tumtum""",
"""Talassa""",
"""Chiroro-Kursi""",
"""Krongo Abdalla""",
"""Kufa-Lima""",
"""Kanga""",
"""Kadugli""",
"""Katcha""",
"""Miri""",
"""Tumma""",
"""Kamda""",
"""Tulishi""",
"""Keiga""",
"""San Mateo del Mar Huave""",
"""Santa María del Mar Huave""",
"""Siawi""",
"""Siawi""",
"""Kafa""",
"""Kutubu""",
"""Mubi""",
"""Humene""",
"""Uare""",
"""Mulaha""",
"""Ooweekeeno""",
"""Kwakiutl""",
"""Nuu-chah-nulth""",
"""Tamagario""",
"""Southern Haida""",
"""Yelmek""",
"""Kamakan""",
"""Menien""",
"""North Central Yuri""",
"""Usari""",
"""Yafi""",
"""Towei""",
"""Taulil""",
"""Nikiyama""",
"""Umuruta""",
"""Iteri""",
"""Nakwi""",
"""Nimo""",
"""Owiniga""",
"""Suabo""",
"""Kadina""",
"""Morotai""",
"""Sopi""",
"""South Modole""",
"""Pagu""",
"""Toliwiku""",
"""Nyeku""",
"""Dodinga""",
"""Tobelo""",
"""Teluk Lili""",
"""Tala'i""",
"""Waioli""",
"""Tidore""",
"""West Makian""",
"""Bara""",
"""Boro""",
"""Keba-Wopasali""",
"""Kewah""",
"""Pupitau""",
"""Ro""",
"""Sesa""",
"""Siligi""",
"""Sopese""",
"""Suri""",
"""Tebera""",
"""Waraga""",
"""Fur""",
"""Bench""",
"""She""",
"""Gamila""",
"""Guba""",
"""Wembera""",
"""Kafa""",
"""Shekkacho""",
"""Ganta""",
"""Kachama""",
"""Koorete""",
"""Zergulla""",
"""Gamo""",
"""Gofa""",
"""Dorze""",
"""Melo""",
"""Oyda""",
"""Male""",
"""Toba""",
"""Kokila""",
"""Koriko""",
"""Didigaru""",
"""Gebi""",
"""Imila""",
"""Maria""",
"""Oibu""",
"""Uderi""",
"""Momuna""",
"""Monumbo""",
"""Yuki""",
"""Huachipaire""",
"""Sapiteri""",
"""Toyeri""",
"""Gbaya-Dara""",
"""Gbaya-Gboko""",
"""Gbaya-Ndogo""",
"""Gbaya-Ngbongbo""",
"""Naka""",
"""Orlo""",
"""Ama""",
"""East Boikin""",
"""Haripmor""",
"""Island Boikin""",
"""Kunai""",
"""Kwusaun""",
"""Munji""",
"""West Boikin""",
"""Ngala""",
"""Wingei""",
"""Wosera-Kamu""",
"""Wosera-Mamu""",
"""Hanga Hundi""",
"""Yelogu""",
"""Gaikundi""",
"""Koiwat""",
"""Palimbei""",
"""Keak""",
"""Sos Kundi""",
"""Sengo""",
"""Yahadian""",
"""Tese""",
"""Bora""",
"""Muinane""",
"""Mombum""",
"""West Central Kwomtari""",
"""Ende""",
"""Kawam""",
"""Tame""",
"""Western Fas""",
"""Nayi""",
"""Dorsha""",
"""Ilgar""",
"""Maung""",
"""Raetic""",
"""Cha ndani""",
"""Caspian and eastern Persia Gypsy""",
"""Central-Southern Persian Gypsy""",
"""Magati""",
"""Jordanian Bengali Pidgin Arabic""",
"""Pidgin Gulf Arabic""",
"""Pidgin Madam""",
"""Romanian Pidgin Arabic""",
"""Turku""",
"""Bonin English Pidgin""",
"""Butler English""",
"""Chinese Pidgin English""",
"""New South Wales Pidgin""",
"""Papuan Pidgin English""",
"""Queensland Kanaka English""",
"""Samoan Plantation Pidgin""",
"""Solombala English""",
"""South Australian Pidgin English""",
"""West Greenlandic Eskimo Pidgin""",
"""Belle-Isle Pidgin""",
"""Broken Slavey""",
"""Burundi Pidgin French""",
"""Francais Tirailleur""",
"""Jargon Loucheux""",
"""New Caledonian Pidgin French""",
"""Tay Boi""",
"""Pidgin Carib""",
"""WW2 Pidgin German""",
"""Gibanawa""",
"""Ioi Trade Jargon""",
"""Papuan Hiri Motu""",
"""Hiri-Motu-Trading-Eleman""",
"""Hiri-Motu-Trading-Koriki""",
"""Russenorsk""",
"""Taimyr Pidgin Russian""",
"""Roquetas Pidgin Spanish""",
"""Settla""",
"""Yimas-Arafundi-Pidgin""",
"""Yimas-Iatmul Pidgin""",
"""Yimas-Karawari Pidgin""",
"""Cikabanga""",
"""Augustinian Sign Language""",
"""Benedictine Sign Language""",
"""Cistercian Sign Language""",
"""Trappist Sign Language""",
"""Plains Indian Sign Language""",
"""Jamaican Sign Language""",
"""Chilean Sign Language""",
"""Colombian Sign Language""",
"""Costa Rican Sign Language""",
"""Dominican Sign Language""",
"""Ethiopian Sign Language""",
"""Gambian Sign Language""",
"""Ghanaian Sign Language""",
"""Guinean Sign Language""",
"""Malaysian Sign Language""",
"""Nigerian Sign Language""",
"""Panamanian Sign Language""",
"""Peruvian Sign Language""",
"""Puerto Rican Sign Language""",
"""Quebec Sign Language""",
"""Sierra Leone Sign Language""",
"""Trinidad and Tobago Sign Language""",
"""Ugandan Sign Language""",
"""Afghan Sign Language""",
"""Albanian Sign Language""",
"""Kuwaiti Sign Language""",
"""Jordanian Sign Language""",
"""Libyan Sign Language""",
"""Yemeni Sign Language""",
"""Argentine Sign Language""",
"""Armenian Sign Language""",
"""Papua New Guinean Sign Language""",
"""British Sign Language""",
"""New Zealand Sign Language""",
"""Maritime Sign Language""",
"""South African Sign Language""",
"""Bamako Sign Language""",
"""Brazilian Sign Language""",
"""Burkina Faso Sign Language""",
"""Ho Chi Minh City Sign Language""",
"""Hong Kong Sign Language""",
"""Thai Sign Language""",
"""Israeli Sign Language""",
"""Polish Sign Language""",
"""Swiss-German Sign Language""",
"""Ecuadorian Sign Language""",
"""Estonian Sign Language""",
"""Guatemalan Sign Language""",
"""Hausa Sign Language""",
"""Pakistan Sign Language""",
"""Nepalese Sign Language""",
"""Korean Sign Language""",
"""Tainan""",
"""Taipei""",
"""Kenyan Sign Language""",
"""Austrian Sign Language""",
"""Bolivian Sign Language""",
"""Valencian Sign Language""",
"""Czech Sign Language""",
"""Debrecen""",
"""Eger""",
"""Miskolc""",
"""Sopron""",
"""Szeged""",
"""Romanian Sign Language""",
"""Slovakian Sign Language""",
"""Icelandic Sign Language""",
"""Vlaamse Gebarentaal""",
"""Dutch Sign Language""",
"""Greek Sign Language""",
"""Hawai'i Pidgin Sign Language""",
"""Irish Sign Language""",
"""Swiss-Italian Sign Language""",
"""Latvian Sign Language""",
"""Moroccan Sign Language""",
"""Oslo""",
"""Trondheim""",
"""Philippine Sign Language""",
"""Selangor Sign Language""",
"""Swiss-French Sign Language""",
"""Tunisian Sign Language""",
"""Yugoslavian Sign Language""",
"""Lyons Sign Language""",
"""Maltese Sign Language""",
"""Mauritian Sign Language""",
"""Mofu-Gudur Sign Language""",
"""Mozambican Sign Language""",
"""Old Bangkok Sign Language""",
"""Uruguayan Sign Language""",
"""Penang Sign Language""",
"""Persian Sign Language""",
"""Lithuanian Sign Language""",
"""Moldova Sign Language""",
"""Mongolian Sign Language""",
"""Russian Sign Language""",
"""Ukrainian Sign Language""",
"""Salvadoran Sign Language""",
"""Saudi Arabian Sign Language""",
"""Mexican Sign Language""",
"""Spanish Sign Language""",
"""Sri Lankan Sign Language""",
"""Finnish Sign Language""",
"""Oporto""",
"""Swedish Sign Language""",
"""Tanzanian Sign Language""",
"""Tijuana Sign Language""",
"""Turkish Sign Language""",
"""Guyana Sign Language""",
"""Venezuelan Sign Language""",
"""Yoruba Sign Language""",
"""Zambian Sign Language""",
"""Zimbabwe Community Sign""",
"""Zimbabwe School Sign""",
"""Al-Sayyid Bedouin Sign Language""",
"""Alipur Sign Language""",
"""Amami O Shima Sign Language""",
"""Angami Naga Sign Language""",
"""Ban Khor Sign Language""",
"""Bengkala Sign Language""",
"""Bribri Sign Language""",
"""Brunca Sign Language""",
"""Bura Sign Language""",
"""Chatino Sign Language""",
"""Enga Sign Language""",
"""Ghandruk Sign Language""",
"""Ghardaia Sign Language""",
"""Guinea-Bissau Sign Language""",
"""Inuit Sign Language""",
"""Jamaican Country Sign Language""",
"""Jhankot Sign Language""",
"""Jumla Sign Language""",
"""Kafr Qasem Sign Language""",
"""Kajana Sign Language""",
"""Keresan Pueblo Indian Sign Language""",
"""Mardin Sign Language""",
"""Martha's Vineyard Sign Language""",
"""Mbour Sign Language""",
"""Nanabin Sign Language""",
"""Nicaraguan Sign Language""",
"""Old Kentish Sign Language""",
"""Original Costa Rican Sign Language""",
"""Providencia Sign Language""",
"""Tebul Sign Language""",
"""Urubú-Kaapor Sign Language""",
"""Yolngu Sign Language""",
"""Yucatec Maya Sign Language""",
"""La'bi""",
"""Medefidrin""",
"""Ngatik Men's Creole""",
"""Tsotsitaal""",
"""Fika""",
"""Apoto""",
"""Aguano""",
"""Arusha""",
"""Esuma""",
"""Nshi""",
"""Ware""",
"""Sorsogon Ayta""",
"""Tayabas Ayta""",
"""Villa Viciosa Agta""",
"""Runa""",
"""Nagarchal""",
"""Pardhan""",
"""Flecheiros""",
"""Giyug""",
"""Guale""",
"""Harappan""",
"""Jumano""",
"""Kwisi""",
"""Lumbee""",
"""Mawa""",
"""Miarrã""",
"""Moksela""",
"""Tawendê""",
"""Yalakalore""",
"""Yelelihre""",
"""Palumata""",
"""Pankararé""",
"""Mayo""",
"""Papavô""",
"""Pisabo""",
"""Shinabo""",
"""Xipináwa""",
"""Rer Bare""",
"""Sentinel""",
"""Tremembé""",
"""Truká""",
"""Tukumanféd""",
"""Wakoná""",
"""Wasu""",
"""Weyto""",
"""Yamasee""",
"""Áncá""",
"""Ambermo""",
"""Ancient Ligurian""",
"""Aracaju""",
"""Aranama""",
"""Aruba""",
"""Baenan""",
"""Bagua""",
"""Bazigar""",
"""Bhatola""",
"""Bidai""",
"""Calchaqui""",
"""Calusa""",
"""Camunic""",
"""Carabayo""",
"""Catuquinaru-Bach""",
"""Chacha""",
"""Chholo""",
"""Colima""",
"""Copallen""",
"""Cueva""",
"""Cusabo""",
"""Cushitic Taita""",
"""Dama""",
"""Degere""",
"""Dima-Bottego""",
"""Dume""",
"""Elymian""",
"""Envuelto""",
"""Eteocretan""",
"""Eteocypriot""",
"""Fayjatases""",
"""Gail""",
"""Gamella""",
"""Guachipas""",
"""Guaicaro""",
"""Gutian""",
"""Haitian Vodoun Culture Language""",
"""Hamba""",
"""Hoxa""",
"""Idabaez""",
"""Imbabura""",
"""Meherrin""",
"""Neutral-Atiouandaronk""",
"""Wenro""",
"""Jenipapo-Kanindé""",
"""Kaimbé""",
"""Kambiwá""",
"""Kantaruré""",
"""Kapinawá""",
"""Kara""",
"""Kamurú""",
"""Kipeá""",
"""Sabujá""",
"""Kassite""",
"""Koguryo""",
"""Komta""",
"""Lemnian""",
"""Malibu""",
"""Mangio""",
"""Mangree""",
"""Minoan""",
"""Monqui""",
"""Muellamues""",
"""Muzo""",
"""Naolan""",
"""Natú""",
"""North Picene""",
"""Ná-Meo""",
"""Okwa""",
"""Pacahuaras-Castillo""",
"""Paekche""",
"""Pamunkey""",
"""Panche""",
"""Panzaleo""",
"""Pasto""",
"""Patagon""",
"""Payaya""",
"""Pericú""",
"""Pictish""",
"""Pijao""",
"""Pitaguary""",
"""Polari""",
"""Poya""",
"""Puruguay""",
"""Quepos""",
"""Querandi""",
"""Quignam""",
"""Quillacinga""",
"""Quinigua""",
"""Quinqui""",
"""Sacata""",
"""San Francisco Solano""",
"""Sansimoniano""",
"""Serengeti-Dorobo""",
"""Silla""",
"""Concho""",
"""Tanpachoa""",
"""South-Arabian-Unknown-k""",
"""Tabancal""",
"""Tapajó""",
"""Tarairiu""",
"""Tartessian""",
"""Tembey""",
"""Traveller Scottish""",
"""Uamué""",
"""Uru-Pa-In""",
"""Urucucús""",
"""Vazimba""",
"""Wavu-II""",
"""Xoco""",
"""Yanacona""",
"""Mekmek""",
"""Bun""",
"""Kyenele""",
"""Kemtuik""",
"""Mlap""",
"""Northern Yana""",
"""Southern Yana""",
"""Yahi""",
"""Jebel Tekeim""",
"""Lafofa""",
"""Piaroa""",
"""Saliba""",
"""Yuwana""",
"""Nagar""",
"""Yasin""",
"""Cacataibo de Sinchi Roca""",
"""Cashibo""",
"""Kaxararí""",
"""Chácobo""",
"""Karipuna""",
"""Pacahuara""",
"""Cashinawa-Tarauaca-River""",
"""Sensi""",
"""Pisquibo""",
"""Shetebo""",
"""Shipibo""",
"""Shipibo del Madre de Dios""",
"""Viwivakeu""",
"""Cashinahua""",
"""Remo""",
"""Marinahua""",
"""Mastanahua""",
"""Yaminahua""",
"""Yawanawa""",
"""Yora""",
"""Atsahuaca""",
"""Ararapina""",
"""Ararawa""",
"""Sanainawa""",
"""Nawa""",
"""Poyanáwa""",
"""Remo-Jaquirana""",
"""Remo-Blanco-River""",
"""Tuxináwa""",
"""Mayoruna-Amazon""",
"""Mayoruna-Jandiatuba""",
"""Korubo""",
"""Kulina Pano""",
"""Matsés""",
"""Mayoruna-Tabatinga""",
"""Mabenaro""",
"""Toromono""",
"""Ese Ejja""",
"""Tacana""",
"""Munga""",
"""Laal""",
"""Latundê""",
"""Tawandê""",
"""Galera""",
"""Hahaintesu""",
"""Halotesu""",
"""Khithaulhu""",
"""Manduka""",
"""Sarare""",
"""Saxwentesu""",
"""Serra Azul""",
"""Waikisu""",
"""Wakalitesu""",
"""Wasusu""",
"""Sabanê""",
"""Tagoi""",
"""Tumale""",
"""Rashad""",
"""Cabo""",
"""Honduran Mískito""",
"""Tawira""",
"""Wanki""",
"""Matagalpa""",
"""Ulwa""",
"""Yakima""",
"""Umatilla""",
"""Ibo'tsa""",
"""Nüpode Huitoto""",
"""Coeruna""",
"""Esperanto""",
"""Interlingua""",
"""Kotava""",
"""Ladakhi Sign""",
"""Lingua Franca Nova""",
"""Neo""",
"""Rennellese Sign Language""",
"""Talossan""",
"""Kuril""",
"""Sakhalin""",
"""Taraika""",
"""Kuril Ainu""",
"""Sakhalin Ainu""",
"""Hoyahoya""",
"""Mahigi""",
"""Minanibai""",
"""Mubami""",
"""Ingias""",
"""Khoamak""",
"""Kuni""",
"""Sengeze""",
"""Wamak""",
"""Dea""",
"""Zimakani""",
"""Halifoersch""",
"""Southeast Marind""",
"""Tugeri""",
"""Nambiomon-Mabur""",
"""Oba-Miwamon""",
"""Bitur""",
"""Were""",
"""Algonquian""",
"""Allegheny""",
"""America""",
"""American""",
"""Americas""",
"""Amerindian""",
"""Antonio""",
"""Apache""",
"""Asia""",
"""Assiniboine""",
"""Atakapa""",
"""August""",
"""Bidanwe""",
"""Biloxi""",
"""Blackwell""",
"""British""",
"""Caddoan""",
"""Catawba""",
"""Catawban""",
"""Chiwere""",
"""Choctaw""",
"""Ciudad""",
"""Coahuiltecan""",
"""Colegio""",
"""Columbus""",
"""Coyote""",
"""Creek""",
"""Crow""",
"""Cruz""",
"""Dakota""",
"""Dakotan""",
"""Dutch""",
"""English""",
"""Euchee""",
"""European""",
"""Finnish""",
"""Fox""",
"""German""",
"""Grande""",
"""Hawaiian""",
"""Hebrew""",
"""Hidatsa""",
"""Hocank""",
"""Hopi""",
"""Huallaga""",
"""Huanuco""",
"""Imbabura""",
"""Indian""",
"""Indonesian""",
"""Iowa""",
"""Ioway""",
"""Iroquois""",
"""Jan""",
"""Japanese""",
"""Jewish""",
"""Ka""",
"""Kansa""",
"""Kanza""",
"""Kaw""",
"""Korean""",
"""Lakhota""",
"""Lakota""",
"""Louisiana""",
"""Maliseet""",
"""Mam""",
"""Man""",
"""Mandan""",
"""Mayan""",
"""Melanesia""",
"""Mexico""",
"""Miami""",
"""Michigamea""",
"""Missiones""",
"""Missouria""",
"""Mobilian""",
"""Na""",
"""Nakoda""", 
"""Natchez""", 
"""Navajo""",
"""Nemaha""",
"""Northeast""",
"""Ofo""",
"""Oklahoma""",
"""Omaha""",
"""Ontario""",
"""Osage""",
"""Oto""",
"""Otoe""",
"""Pennsylvania""", 
"""Ponca""",
"""Ponka""",
"""Quapaw""",
"""Quechua""",
"""Russian""",
"""Sac""",
"""San""",
"""Sauk""",
"""Saul""",
"""Siberian""",
"""Siouan""",
"""Sioux""",
"""Slave""",
"""Southeast""",
"""Spanish""",
"""Sprachtheorie""",
"""Stoney""",
"""Teton """,
"""Timucua""",
"""Tomahitans""",
"""Toronto""",
"""Torricelli""",
"""Tunica""",
"""Turkic""",
"""Tutelo""", 
"""Walman""",
"""Western""",
"""Wh""",
"""WH""",
"""Whitman""",
"""Wichita""",
"""Winnebago""",
"""Wisconsin""",
"""Wiyot""",
"""Woccon""",
"""Yehuda""",
"""Yuchi""",
"""Yurok"""
  ]

OCCURREDREPLACEMENTS=[ 
"""Abfolge""",
"""Abui""",
"""Adang""",
"""Afrasian""",
"""Africa""",
"""Afroasiatic""",
"""Aires""",
"""Aix""",
"""Akhtar""",
"""Akten""",
"""Akzentimitation""",
"""Albert""",
"""Albrecht""",
"""Albrechts""",
"""Aleksander""",
"""Aleut""",
"""Alltag""",
"""Alltagsdeutsch""",
"""Al-Sayyid""",
"""Altaistik""",
"""Althochdeutsch""",
"""Althochdeutschen""",
"""Alto""",
"""Amazonian""",
"""Ambonese""",
"""Ambong""",
"""Amele""",
"""Amelia""",
"""Amharic""",
"""Andrea""",
"""Andres""",
"""Anfängen""",
"""Angas""",
"""Angkor""",
"""Anna""",
"""Ansichten""",
"""Antisemitismus""",
"""Aotearoa""",
"""Aptroot""",
"""Arbeitsbuch""",
"""Arbeitstagung""",
"""ArcGIS""",
"""Arizona""",
"""Armenian""",
"""Arnim""",
"""Artusritter""",
"""Aryan""",
"""Aspekte""",
"""Assamese""",
"""Assimilationskontroverse""",
"""Assiniboine""",
"""Athpare""",
"""Aufgaben""",
"""Aufklärung""",
"""Aufklärungszeit""",
"""Aufzügen""",
"""Ausdrücke""",
"""Auseinanderentwicklung""",
"""Ausformung""",
"""Ausgabe""",
"""Ausgrenzung""",
"""Aushandlung""",
"""Ausländerunterricht""",
"""Ausspracheunterschiede""",
"""Australasian""",
"""Auswertung""",
"""Autotyp""",
"""Ayalon""",
"""Baarmundarten""",
"""Babele""",
"""Babli""",
"""Bagh-o-Bahaar""",
"""Bagrifn""",
"""Bairischen""",
"""BalkaNet""",
"""Bally""",
"""Baltaxe""",
"""Baltic""",
"""Bantawa""",
"""Basari""",
"""Baskin""",
"""Basque""",
"""Basse""",
"""Baumbanken""",
"""Bayerisch""",
"""Bayerischen""",
"""Bayern""",
"""Bayes’""",
"""BEAUti""",
"""Bedeutung""",
"""Bedouin""",
"""Befunde""",
"""Begriff""",
"""Beispiel""",
"""Beispiele""",
"""Beitrag""",
"""Beiträge""",
"""Beiträgen""",
"""Belgisch""",
"""Belhara""",
"""Belhare""",
"""Bella""",
"""Bellugi""",
"""Bemerkungen""",
"""Beobachtungen""",
"""Bereich""",
"""Berger""",
"""Berichte""",
"""Berndeutsche""",
"""Bert""",
"""Bertinoro""",
"""Berty""",
"""Berücksichtigung""",
"""Besch""",
"""Beschreibung""",
"""Bestrebungen""",
"""Betrachtungen""",
"""Bewahrung""",
"""Bewertung""",
"""Bezeichnung""",
"""Bibelübersetzungssprache""",
"""Bibliographie""",
"""Bikol""",
"""Bild""",
"""Bildung"""
"""Biografie""",
"""Bismarck""",
"""Blagar""",
"""Blick""",
"""Blok""",
"""BootCaT""",
"""Borneo""",
"""Boston""",
"""Brako""",
"""Brauchtum""",
"""BrE""",
"""Bresnan""",
"""Bretagne""",
"""Briefe""",
"""Briefwechsel""",
"""Britannica""",
"""Buch""",
"""Bühne""",
"""Bühnentexte""",
"""Bühnentexten""",
"""Bürgerlichen""",
"""Bürgerlichkeit""",
"""Bürgertum""",
"""Bushman""",
"""Cairns""",
"""Calabrese""", 
"""Camling""",
"""Carib""",
"""Cariban""",
"""Caribbean""",
"""Carlos""",
"""Carpenter""", 
"""Casamance""",
"""Catawban""",
"""Cenderawasih""",
"""Chamorro""",
"""ChaSen""",
"""Chepang""",
"""Chichewa""",
"""ChiS""",
"""Cholan""",
"""Christmas""",
"""ciCewa""",
"""Circum-Baltic""",
"""Columbia""",
"""Coola""", 
"""CoreNLP""",
"""Côte""",
"""Creole""",
"""CroCo""",
"""CrossTowns""",
"""Crusca""",
"""Cruz""", 
"""Danish""",
"""Darmstadt""",
"""Darstellung""",
"""Darstellungsformen""",
"""Darwinsche""", 
"""Daten""",
"""Datenverarbeitung""",
"""Dative""",
"""Dativmarkierung""",
"""David""", 
"""Deflexion""",
"""Degema""",
"""Degrammatikalisierung""",
"""Degrammatikalisierungen""",
"""Deklination""",
"""Delphine""",
"""Demagogen""",
"""Deminutivum""",
"""Deutsche""",
"""Deutschen""",
"""Deutschland""",
"""Deutsch-Neuguinea""",
"""Dezember""",
"""Dhankuta""",
"""Dialekt""",
"""Dialektalität""",
"""Dialektalitätsbegriffe""",
"""Dialektattribuierungen""",
"""Dialektbezeichnungen""",
"""Dialektbuch""",
"""Dialekte""",
"""Dialekten""",
"""Dialekterhebung""",
"""Dialektforschung""",
"""Dialektgeographie""",
"""Dialektgrenzen""",
"""DIalektgrenzen""",
"""Dialektkartographie""",
"""Dialektliteratur""",
"""Dialektologentagung""",
"""Dialektologie""",
"""Dialektometrie""",
"""Dialektometrische""",
"""Dialektraum""",
"""Dialekts""",
"""Dialekttiefe""",
"""Dialektverlust""",
"""Dichtung""",
"""Diehl""",
"""Direktor""",
"""Distanz""",
"""d’Ivoire""",
"""Doberai""",
"""Dolittle's""",
"""Donaulandes""",
"""Doppelperspektive""",
"""Druck""",
"""dtv-Atlas""",
"""Dumi""",
"""Dungmali""",
"""Durham""",
"""Ȼegiha""",
"""Eifel""",
"""Eigennamen""",
"""Einar""",
"""Einfluss""",
"""Einführung""",
"""Einsatzes""",
"""Einschluss""",
"""Einsichten""",
"""Einteilung""",
"""Ekari""",
"""Ellis""",
"""Emet""",
"""Emigrants""",
"""Endstadium""",
"""Englisch""",
"""Englishness""",
"""Entstehung""",
"""Entstehungsursache""",
"""Entwicklung""",
"""Entwicklungen""",
"""Entwicklungspsychologie""",
"""Erfahrungen""",
"""Erforschung""",
"""Ergänzungsheft""",
"""Ergebnisse""",
"""Erhebung""",
"""Erhebungen""",
"""Ernst""",
"""ERPs""",
"""Ersatzinfinitivkonstruktion""",
"""Ersatzinfinitivkonstruktionen""",
"""Erscheinungen""",
"""Erwartung""",
"""Erzählliteratur""",
"""Erzählprosa""",
"""Erzählungen""",
"""Erzieher""", 
"""Esther""",
"""Ethnodialektologie""",
"""Ethnologue""",
"""Eurasia""",
"""Europeans""",
"""Evidenzen""",
"""Evolang""",
"""EXMARaLDA""",
"""Extraktion""",
"""Fachtagung""",
"""Faktor""",
"""Fallbeispiel""",
"""Fallstudie""",
"""Familien""",
"""Fantasy""",
"""Farnworth""",
"""Fassung""",
"""Feindbegriff""",
"""Feindbilder""",
"""Feinde""",
"""Felder""",
"""Feldern""",
"""Fernsehen""",
"""Fernsehproduktionen""",
"""Fernsehserie""",
"""Festgabe""",
"""Festlandnordfriesischen""",
"""Festschrift""",
"""Figur""",
"""Figuren""",
"""Fijian""",
"""Files""",
"""Finistère""",
"""Finisterre""",
"""Finisterre-Huon""",
"""Fokus""",
"""Folgen""",
"""Folklore""",
"""Forêt""",
"""Formenlehre""",
"""Formlehre""",
"""Forschung""",
"""Forschungen""",
"""Forschungsbedarf""",
"""Forschungsprojekt""", 
"""Fouesnant""",
"""Fragen""",
"""Frauen""",
"""Fremdsprache""",
"""Fremdwörter""",
"""Fremdzuschreibungen""",
"""Frequenz""",
"""Freytag""",
"""Freytags""",
"""Frömmelei""",
"""Frühjahrstagung""",
"""Frühneuhochdeutschen""",
"""Frühneuhochdeutschkorpus""",
"""Fuchsfabeln""",
"""Fügung""",
"""Fügungen""",
"""Fula""",
"""Funktion""",
"""Fürstentums""", 
"""Garwi""",
"""Gebälk""",
"""Gebetsbuch""",
"""Geburtstag""",
"""Gedichte""",
"""Gedichten""",
"""Gegenüber""",
"""Gegenwart""",
"""Gegenwartsliteratur""",
"""Gegenwartssprache""",
"""Gegenwartssprachliche""",
"""Geheimsprache""",
"""Geld""",
"""Gelehrtes""",
"""Gemeindeverzeichnis""",
"""Gengo""",
"""Gengochizu""",
"""Genitiv""", 
"""Geolinguistik""",
"""Germain""",
"""Germanen""",
"""Germanisten""",
"""Germanistenkongresses""",
"""Germanistik""",
"""Germanistische""",
"""Germanistisches""",
"""Germany""",
"""Gesamtausgabe""",
"""Geschichte""",
"""Gesellschaft""",
"""Geshikhte""",
"""Gespräche""",
"""Gestalten""",
"""Gestaltung""",
"""Gewand""",
"""Gewerbe""",
"""Gieß""",
"""GIVENness""",
"""Givón""",
"""GLDV-Conference""",
"""Gleichstellung""",
"""Gliederung""", 
"""GOing""",
"""Gorkha""",
"""Grammatik""",
"""Grammatikalisierung""",
"""Grammatische""",
"""Graph""",
"""Greenbergian""",
"""Grenze""",
"""Grenzen""",
"""Grenzgänger""",
"""Grenzgebiet""",
"""Gricean""",
"""Grund""",
"""Grundlage""",
"""Grundlagen""",
"""Grundlegung""",
"""Grundriss""",
"""Grundsätzliches""",
"""Grundzüge""",
"""Guinea""",
"""Gujarai""",
"""Gur""",
"""Haben""",
"""Halbband""",
"""Handbuch""",
"""Handelssprache""",
"""Handlungsfelder""",
"""Handwörterbuch""",
"""Hausa""",
"""Hayu""",
"""Hebraismen""", 
"""Henry""",
"""Herkunft""",
"""Herr""",
"""Herrn""",
"""Herz""",
"""Hessen-Nassauisches""",
"""Hessischen""",
"""Heterogenität""",
"""Hida""",
"""Himalayan""",
"""Hindí""",
"""Hindukusch""",
"""Hinoki""",
"""Hintergrund""",
"""Hintergründe""",
"""Histoire""",
"""Historisch""",
"""Historische""",
"""Hittite""",
"""Hiw""",
"""Hochalemannische""",
"""Hochsprache""",
"""Hochzeit""",
"""Hochzeitscarmina""",
"""Hofstra""",
"""Holmberg's""",
"""Hörerurteil""",
"""Huanuco""", 
"""Humanities""",
"""Humor""",
"""Hundred""",
"""Hundt""",
"""Hybridisierung""",
"""Hyperkorrektion""",
"""Hypotaxe""",
"""Icetod""",
"""ICLaVE""",
"""Ihre""",
"""Ikwere""",
"""Illustrations""",
"""Ilse""",
"""Indic""", 
"""Indo-Nepal""",
"""Indonesia""",
"""Induk""",
"""Inor""",
"""Inszenierung""",
"""Interaktion""",
"""Interferenzen""",
"""Interspeech""",
"""Iran""",
"""Irazazábal""",
"""Irian""",
"""Irianese""",
"""Irregularisierung""",
"""Islamic""",
"""Isle""",
"""Isles""",
"""Isoglossen""",
"""Israeli""",
"""Italia""",
"""Ivrit""",
"""IVth""",
"""Jahrbuch""",
"""Jahre""",
"""Jahrhundert""",
"""Jahrhunderts""",
"""Jährliches""",
"""Jahrtausendwende""",
"""Jakartan""",
"""Java""",
"""Jaya""",
"""Jiddisch""",
"""Jiddische""",
"""Jiddischen""",
"""Jiddistik""",
"""Johan""",
"""Joodsch""",
"""Joodse""",
"""Jörn""",
"""JRC-Acquis""",
"""Judden""",
"""Jude""",
"""Juden""",
"""Judendarstellung""",
"""Judendeutsch""",
"""Judendiskurse""",
"""Judeneide""",
"""Judenfiguren""",
"""Judenmord""",
"""Judenpredigt""",
"""Judensprache""",
"""Judentum""",
"""Judentums""",
"""Judeo""",
"""Jüdisch""",
"""Jüdischdeutsch""",
"""Jüdischdeutschen""",
"""Jüdische""",
"""Jüdischen""",
"""Jugendlichen""",
"""Julio""",
"""Jürgen""",
"""Kabar""",
"""Kaera""",
"""Kafoa""",
"""Kähler""",
"""Kamang""",
"""Kanuri""",
"""Kaplan""",
"""Kappa""",
"""Karte""",
"""Karten""",
"""Kartographie""",
"""Kasus""",
"""Kasusmarkierung""",
"""Kausalsätzen""",
"""Kazakh""",
"""Key""",
"""Kham""",
"""Kharia""",
"""Kinyarwanda""",
"""Kiranti""",
"""Kirat""",
"""Kjell""",
"""Klassifikation""",
"""Kleinraumatlanten""",
"""Klima""",
"""Klischees""",
"""Knick""",
"""Kobon""",
"""Kognition""",
"""Kognitive""",
"""Kohumono""",
"""Kolloquium""",
"""Kolportagereihe""",
"""Komi""",
"""Kommentar""",
"""Komödie""",
"""Kompendium""",
"""Komponente""",
"""Komponenten""",
"""Konferenz""",
"""Konflikt""",
"""Kongresses""",
"""Kongruenz""",
"""Kongruenzformen""",
"""Konsonanten""",
"""Kontext""",
"""Kontinuum""",
"""Kontinuums""",
"""Kontraste""",
"""Kontrastsprache""",
"""Konvergenzen""",
"""Konversations""",
"""Konzepte""",
"""Konzeptualisierungen""",
"""Korpora""",
"""Ku""",
"""Kula""",
"""Kuliak""",
"""Kultur""",
"""Kulturen""",
"""Kulturkontraste""",
"""Kulung""",
"""Kuman""",
"""Kunst""",
"""Künste""",
"""Kurtö""",
"""Kurtöp""",
"""Kwa""",
"""Lachoudische""",
"""Lahu""",
"""Laienlinguistik""",
"""Ländern""",
"""Landmann""",
"""Landsjuden""",
"""Langvokale""",
"""Lankan""",
"""Lao""",
"""Larantuka""",
"""Latina""",
"""Laut""",
"""Laute""",
"""Lautlehre""",
"""LCAAJ""",
"""Lebensaltern""",
"""Lehnwortschatz""",
"""Leiden""",
"""Lektüre""",
"""Leshonenu""",
"""Lexer""",
"""Lexika""",
"""Lexikalische""",
"""Lexikon""",
"""Limbum""",
"""LinES""",
"""LinGO""",
"""Linguistik""",
"""Linke""",
"""Literatur""",
"""Livelli""",
"""Lizenzen""",
"""Lohorung""", 
"""Lopit""",
"""Lothringen""", 
"""Lustspiel""",
"""Luthers""",
"""Maasai""",
"""Machine""",
"""Macht""",
"""Madagascar""",
"""Madang-Adelbert""",
"""Mai""",
"""Majoratsherren""",
"""Malayalam""",
"""Malayic""",
"""Malay-Indonesian""",
"""Malayo""",
"""Malayo-Sumbawan""",
"""Maleis-Nederlands""",
"""Malila""",
"""Maliseet""",
"""Maluku""",
"""Manado""",
"""Managua""",
"""Manam""",
"""Mandarin""",
"""Manguean""",
"""Manische""",
"""Mann""",
"""Männern""",
"""Manokwari""",
"""Maori""",
"""Maragoli""",
"""March""",
"""Marion""",
"""Markiertheit""",
"""Märkisch""",
"""Marrakesh""",
"""Materialien""",
"""Mausmooth""",
"""Maxent""", 
"""May""",
"""McDavid""",
"""McMahon""",
"""Medialität""",
"""Melanesian""",
"""Melayu-Papua""",
"""Memura""",
"""Mentalitätsgeschichte""",
"""Merkel""",
"""Merkmale""",
"""Merkmalen""",
"""Meso""",
"""Meso-America""",
"""Methode""",
"""Methoden""",
"""MetricsM""",
"""MetricsMATR""",
"""Mewahang""", 
"""Midlands""",
"""Migrantensprachen""",
"""Migrations""",
"""MiGro""",
"""Mikro""",
"""Milch""",
"""Minangkebau""",
"""Missiones""",
"""Mitteilungen""",
"""Mittelalter""",
"""Mittelalters""",
"""Mittelbairischen""",
"""Mitteleuropa""",
"""Mittelfranken""",
"""Mittelhochdeutsch""",
"""Mittelhochdeutsche""",
"""Mittelrheinischen""",
"""Miya""",
"""Morphosyntax""",
"""Morris""",
"""Morrocco""",
"""Motion""",
"""mtDNA""",
"""Muette""",
"""MULTEXT-East""",
"""Mundart""",
"""Mundartdichtung""",
"""Mundarten""",
"""Mundartgrenzen""",
"""Mundartkunde""",
"""Mündlichkeit""",
"""Museums""",
"""Mussau""",
"""Muster""",
"""Nachdruck""",
"""Nachfeldes""",
"""Nachleben""",
"""Nachschlagewerk""",
"""Nachweis""",
"""Nähe""",
"""Nähekommunikation""",
"""Namatota""",
"""Namen""",
"""Namenforschung""",
"""Nano""",
"""Nassau""",
"""Nassauischen""",
"""Natürlichkeit""",
"""Nay""",
"""Nchumuru""",
"""Ndebele""", 
"""Nebensatzprädikate""",
"""Nebilyer""",
"""Nederlands""",
"""Nederlandse""",
"""Nepalese""",
"""Nepali""",
"""Neuberg""",
"""Neubewertung""",
"""Neue""",
"""Neu-Guinea""",
"""Neuhessischen""",
"""Neuhochdeutschen""",
"""Neutral""",
"""Neutralization""",
"""Newar""",
"""Newari""",
"""Ngambay-Moundou""",
"""Nichtjuden""",
"""Nieuw-Guinea""", 
"""Nimboran""",
"""Nodalida""",
"""Nominalmorphologie""",
"""Nordic""",
"""Nordisk""",
"""Noroeste""", 
"""NPs""",
"""Numerusmarker""",
"""Nusantara""",
"""Nuu""",
"""Nzadi""",
"""Oberdeutschen""",
"""Oberfläche""",
"""Oberflächenmuster""",
"""Oberrheingebiet""",
"""Objekte""", 
"""Oceania""",
"""Oceanic""",
"""Oktober""",
"""Oldenborgh""",
"""Olten""",
"""Omruwa""",
"""Onomastik""",
"""Orthographie""",
"""Osnovy""",
"""Ostafghanistan""",
"""Ostgrenze""",
"""Ostjiddische""",
"""Ostjiddischen""",
"""Ostjuden""",
"""Pacific""",
"""Pädagogen""",
"""Pāli""",
"""Pama""",
"""Panama""",
"""Panare""",
"""Papua""",
"""Papuan""",
"""Parallelkorpora""",
"""Parisian""",
"""Parodien""", 
"""Partikelverben""",
"""Partizip""",
"""Partizips""",
"""Passionsspiel""",
"""Passionsspielen""",
"""Pastaza""",
"""Península""",
"""Perlmutter""",
"""Pferdehändlersprache""",
"""Phänomen""",
"""Phänomene""",
"""Phänomenen""",
"""Phil""",
"""Philippine""",
"""Philologen""",  
"""Phoca""",
"""Phonetik""",
"""Pidgin""",
"""Pidgins""",
"""Pilotstudie""",
"""Pitcairn""",
"""Pitkern""",
"""Planung""",
"""Pluralbildung""",
"""Pluralformen""", 
"""Pneumotachograph""",
"""Polarisierungseffekten""",
"""Polnisch""",
"""Polnisch-Deutscher""",
"""Polynesians""",
"""Popul""",
"""Português""",
"""Posse""",
"""POS-tagged""",
"""Poster""",
"""Potawatomis""",
"""Pragmatik""",
"""Präposition""",
"""Predigten""",
"""Preston""",
"""Prinzipien""",
"""Probleme""",
"""Produktion""",
"""Pronominaladverb""",
"""Pronominaladverbien""",
"""Proto-Ellicean""",
"""Proto-Malay""",
"""Proto-New""",
"""Proto-Polynesian""",
"""Proto-Tibeto-Burman""",
"""Proto-Timor-Alor-Pantar""",
"""Publikation""",
"""Querschnitt""",
"""Radowsky""",
"""Rai""",
"""Rajas""",
"""Rajdeu""",
"""Ramu-Madang""",
"""Randgruppe""",
"""Rapanui""",
"""Rätoromania""",
"""Rätsel""",
"""Raum""",
"""Raumes""",
"""Rawang""",
"""Reanalyse""",
"""Rechtfertigungen""",
"""Rechtschreibung""",
"""Reden""",
"""Redensarten""",
"""Referenzkorpus""",
"""Regionalgeschichte""",
"""Regionalismen""",
"""Regionalkultur""",
"""Regionalsprachenforschung""",
"""Reichs""",
"""Reidlinger""",
"""Reihe""",
"""Reihenfolge""",
"""Rekonstruktion""",
"""Relativpronomina""",
"""Relativsätze""",
"""Ressourcen""",
"""Resten""",
"""Rgyalrongic""",
"""Riau""",
"""Riflessioni""",
"""Rigveda""",
"""Roe""",
"""Rolle""",
"""Rollengeschichte""",
"""Roman""",
"""Romane""",
"""Romanen""",
"""Romantic""",
"""Roshe""",
"""Rotwelschdialekte""",
"""Rules""",
"""Russlands""",
"""Sachgeographie""",
"""Sager""",
"""Saharan""",
"""Saija""",
"""Sakha""",
"""Salienz""",
"""Salienzbegriff""",
"""Salienzeffekte""",
"""Salishan""",
"""Salomo""",
"""Sammlung""",
"""Sämtliche""",
"""San""",
"""Sardische""",
"""Satz""",
"""Sätze""",
"""Satzes""",
"""Satzgliedern""",
"""Satzphonetik""",
"""Sau""",
"""Savosavo""",
"""Scandinavia""",
"""Schaupiel""",
"""Scherz""",
"""Scherze""",
"""Schirm""",
"""Schmus""",
"""Schneersohns""",
"""Schnittstelle""",
"""Schopflochs""",
"""Schreibart""",
"""Schreibdialekte""",
"""Schrift""",
"""Schriften""",
"""Schriftlichkeit""",
"""Schriftsprache""",
"""Schriftsteller""",
"""Schriftstellern""",
"""Schulmänner""",
"""Schwa""",
"""Schwabens""",
"""Schwäbisch""",
"""SciTex""",
"""Sechehaye""",
"""Seele""",
"""Selayarese""",
"""Selbst""",
"""Selbstverständnis""",
"""Semantik""",
"""Semitic""",
"""Semitisch""",
"""Sendschreiben""",
"""Sentani""",
"""Seram""",
"""Serbian""",
"""Serialisierung""",
"""Sexualität""",
"""Shina-Rätsel""",
"""Shina-Texte""",
"""Shiro""",
"""Sicht""",
"""Siedelungsmundarten""",
"""Sierra""",
"""Siewierska""",
"""Siin""",
"""Silben""",
"""Silbenonset""",
"""Singapore""",
"""SiSwati""",
"""Slave""",
"""Slavisch""",
"""Slawisch""",
"""Slovene""",
"""Slowakei""",
"""Smirnov""",
"""Somali""",
"""Sondersprache""",
"""Sonorants""",
"""Sotho""",
"""South-East""",
"""Southeastern""",
"""Soziolinguistik""",
"""Spannungsfeld""",
"""Spektren""",
"""Spiegel""",
"""Spiel""",
"""Spiele""",
"""Spielen""",
"""SplitsTree""",
"""Sprach""",
"""Sprachatlanten""",
"""Sprachatlas""",
"""Sprachatlasses""",
"""Sprachatlasunternehmen""",
"""Sprachausgleich""",
"""Sprachbeziehungen""",
"""Sprache""",
"""Sprachen""",
"""Sprachenvergleich""",
"""Spracherwerb""",
"""Sprachforschung""",
"""Sprachgebiet""",
"""Sprachgebrauch""",
"""Sprachgeschichte""",
"""Sprachgrenzen""",
"""Sprachgut""",
"""Sprachkarte""",
"""Sprachklassifikatorische""",
"""Sprachkontakt""",
"""Sprachkonzepte""",
"""Sprachkultur""",
"""Sprachlaute""",
"""Sprachmaterialien""",
"""Sprachperzeption""",
"""Sprachraum""",
"""Sprachraums""",
"""Sprachreste""",
"""Sprachschatzes""",
"""Sprachsituation""",
"""Sprachspezifik""",
"""Sprachtheorie""",
"""Sprachtypologie""",
"""Sprachvariation""",
"""Sprachveränderung""",
"""Sprachvergleich""",
"""Sprachwandel""",
"""Sprachwechsel""",
"""Sprachwissenschaft""",
"""Sprachwissenschaften""",
"""Sprecher""",
"""Sprichwörter""",
"""Squamish""",
"""Staatsgrenze""",
"""Stadt""",
"""Stammbaum""",
"""Standardsprache""",
"""Standardwestfriesische""",
"""Standpunkt""",
"""Stanford""",
"""Stiefschwester""",
"""Stilmittel""",
"""Stimm""",
"""Stockholm""",
"""Straits""",
"""Strömungen""",
"""Struktur""",
"""Strukturen""",
"""Strukturparameters""",
"""Studien""",
"""Studierende""",
"""Suba""",
"""Suchwerkzeug""",
"""Sudanic""",
"""Suharto""",
"""Sunwar""",
"""Surface""",
"""Swahili""",
"""Swat""",
"""Synchronie""",
"""Syntaktischen""",
"""Systematik""",
"""Szulc""",
"""Taeldeman""",
"""Tagalog""",
"""Tagebücher""",
"""Tales""",
"""Tanah""",
"""Tangut""",
"""Tanzania""",
"""Taparahi""",
"""Taubstummenlehrer""",
"""Technik""",
"""Teop""",
"""Tepehua""",
"""Ternate""",
"""Tette""",
"""Tetun""",
"""Textgrammatik""",
"""Textkorpora""",
"""Textuelles""",
"""Thai""",
"""Theater""",
"""Theaterstücken""",
"""Thema""",
"""Themen""",
"""Theoriebildung""",
"""Theorien""",
"""Theroy""",
"""Thomas""",
"""Thulung""",
"""Tibetan""",
"""Tibeto-Kinnauri""",
"""Tidore""",
"""Tiefenstrukturen""",
"""TIGERSearch""",
"""Timor""",
"""Tisch""",
"""Tischgesellschaft""",
"""Tiv""",
"""Tlachichilco""",
"""Tobelo""",
"""Tomasello""",
"""Tonaufnahmen""",
"""Tong""",
"""Totonacan""", 
"""TransLIT""",
"""Trobe""",
"""Trobriand""",
"""Troyes""",
"""Trubetzkoy""",
"""Tschechien""",
"""Tschechischen""",
"""Tsez""",
"""Tugend""",
"""Tunica""",
"""Turkologie""",
"""Türksprachen""",
"""Tussentaal""",
"""Tuvaluan""",
"""Tzeltal""",
"""Übersetzungswissenschaft""",
"""Uganda""",
"""Umfang""",
"""Umgangssprachen""",
"""Umwelt""",
"""Universalgrammatik""",
"""Universalien""",
"""Universität""", 
"""Untersuchung""",
"""Untersuchungen""",
"""Untersuchungsgebiet""",
"""Uralic""",
"""Urhobo""",
"""Ursprung""",
"""Ursula""",
"""Urteile""",
"""Valentin""",
"""Valenzwörterbüchern""",
"""Variationslinguistik""",
"""Varietätendynamik""",
"""Vaterland""",
"""Vaz""",
"""Vedic""",
"""Vedischen""",
"""Venezuela""",
"""Veränderungen""",
"""Verarbeitung""",
"""Verbalfelder""",
"""Verbalkomplex""",
"""Verben""", 
"""Verbreitung""",
"""Verbstellung""",
"""Verbstellungsphänomenen""",
"""Verbverdoppelung""",
"""Verbverdopplung""",
"""Verbzweitstellung""",
"""Verdoppelung""",
"""Verfahren""",
"""Verfassers""",
"""Vergangenheit""",
"""Vergleich""",
"""Vergleichende""",
"""Verhältnis""",
"""Verkenning""",
"""Verlauf""",
"""Verner""",
"""Versammlung""",
"""Version""",
"""Versuch""",
"""Vertikale""",
"""Verwandtes""",
"""Verwandtschaftsverhältnisse""",
"""Viereck""",
"""Vietnamese""",
"""VIIèmes""",
"""VIIth""",
"""Visualisierungen""",
"""Visualization""",
"""Vlaamse""",
"""Volksglauben""",
"""Volkskunde""",
"""Volkssitte""",
"""Volksstammes""",
"""Voorhoeve""",
"""Vorstellungen""",
"""Vorwort""",
"""Vorzeit""",
"""Waffe""",
"""Wahrnehmungsdialektologie""",
"""Walbiri""",
"""Wald""",
"""Wambule""",
"""Wandel""",
"""Wàogdgò""",
"""Warlpiri""",
"""Waru""",
"""Wasow""",
"""Wave""",
"""Wege""",
"""Weil""",
"""Weil-Sätze""",
"""Welle""",
"""Weltsprache""",
"""Werk""",
"""Werke""",
"""Werner""",
"""Wersing""",
"""Wert""",
"""Westjid""",
"""Westjiddischen""",
"""Westmitteldeutschen""",
"""Westtirols""",
"""Weyland""",
"""Wh""",
"""Wikipedia""",
"""Wittlich""",
"""Wobé""",
"""Woccon""",
"""Wolfssohn""",
"""Wordenboeckje""",
"""WordNet""",
"""Wort""",
"""Wortarten""",
"""Wortbildung""",
"""Wörter""",
"""Wörterbuch""",
"""Wörterverzeichnis""",
"""Wortgeschichten""",
"""Wortschatz""",
"""Wortschatzes""",
"""Wortsemantik""",
"""Wortsprache""",
"""Wortstellung""",
"""XIIème""",
"""XIth""",
"""XIVth""",
"""XVIth""",
"""XVth""",
"""XXIVèmes""",
"""XXVèmes""",
"""Yagua""",
"""Yakha""",
"""Yakkha""",
"""Yakkhas""",
"""Yale""",
"""Years""",
"""Yidiny""",
"""Yidish""",
"""Yimas""",
"""Yine""",
"""Yvi""",
"""Zeichen""",
"""Zeit""",
"""Zeitgeschichte""",
"""Zeitschrift""",
"""Zia""",
"""Zoeloe-grammatika""",
"""Zoff""",
"""Zoologie""",
"""Zoquean""",
"""Zucker""",
"""Zufall""",
"""Züge""",
"""Zuid""",
"""Zulu""",
"""Zuni""",
"""Zwischenkriegszeit""",
"""Aachen""",
"""Aargau""",
"""Aaron""",
"""Aboriginal""",
"""Abschnitten""",
"""Achim""",
"""Actas""",
"""Adige""",
"""African""",
"""Afrikaans""",
"""Akateko""",
"""Alabama""",
"""Alemannischen""",
"""Algonquian""",
"""Allegheny""",
"""Allgäus""",
"""Almeida""",
"""Almone""",
"""Alsfeld""",
"""America""",
"""American""",
"""Americas""",
"""Amerindian""",
"""Amin""",
"""Amsterdam""",
"""Amtlichen""",
"""Anatolian""",
"""Andalucía""",
"""Andler""",
"""Antonio""",
"""Apache""",
"""Appalachian""",
"""Applecross""",
"""April""",
"""Arabic""",
"""Aron""",
"""Ashkenaz""",
"""Ashkenazic""",
"""Ashret""",
"""Asia""",
"""Asian""",
"""Askhenazit""",
"""Atakapa""",
"""Atlantic""",
"""Atti""",
"""August""",
"""Auricher""",
"""Australasia""",
"""Australia""",
"""Australian""",
"""Austria""",
"""Austronesian""",
"""Autorin""",
"""Awadhi""",
"""Azad""",
"""Babel""",
"""Balti""",
"""Bamberg""",
"""Bantu""",
"""Barasano""",
"""Barbara""",
"""Bashkarik""",
"""Bavaria""",
"""Bavarian""",
"""Baxoje-Jiwere""",
"""Bayreuth""",
"""Bechtel""",
"""Beḥinatan""",
"""Belgium""",
"""Beranek""",
"""Berkeley""",
"""Berlin""",
"""Berliner""",
"""Betina""",
"""Bidanwe""",
"""Biloxi""",
"""Birmingham""",
"""Blackwell""",
"""Boe""",
"""Bohemia""",
"""Bonferroni""",
"""Bottom""",
"""Brazilian""",
"""Brésil""",
"""Breslau""",
"""Breton""",
"""Britain""",
"""British""",
"""Broca""",
"""Budapest""",
"""Buenos""",
"""Bulgarian""",
"""Bunim""",
"""Bura""",
"""Burgenland""",
"""Burushaski""",
"""Caddoan""",
"""Cahans""",
"""California""",
"""Cambridge""",
"""Cameroon""",
"""Canada""",
"""Canadian""",
"""Canadiens""",
"""Cantonese""",
"""Capetians""",
"""Carry-the-Kettle""",
"""Castilian""",
"""Catalan""",
"""Caucasus""",
"""Celtic""",
"""Changana""",
"""Charles""",
"""Chicago""",
"""Chinese""",
"""Chintang""",
"""Chitral""",
"""Chiwere""",
"""Choctaw""",
"""Chom""",
"""Christian""",
"""Christians""",
"""Cincinnati""",
"""Clovis""",
"""Coahuiltecan""",
"""Coatzospan""",
"""Colombian""",
"""Columbus""",
"""Corrientes""",
"""Cronbach""",
"""Croom""",
"""Crow""",
"""Czech""",
"""Daan""",
"""Daems""",
"""Dakota""",
"""Dakotan""",
"""Dameli""",
"""Damerau""",
"""Danelaw""",
"""Dangari""",
"""Dani""",
"""Dardic""",
"""Dardistan""",
"""Dene-Yeniseian""",
"""Deutsch""",
"""Devon""",
"""Dialektsyntax""",
"""Diegueño""",
"""Dutch""",
"""East""",
"""Eastern""",
"""Elsass""",
"""Elsässer""",
"""England""",
"""English""",
"""Englishes""",
"""Euchee""",
"""Euchel""",
"""Euchels""",
"""Europe""",
"""European""",
"""Faetar""",
"""Feitel""",
"""Fens""",
"""Fès""",
"""Finnish""",
"""Fischl""",
"""Fishman""",
"""Flanders""",
"""Flemish""",
"""Fouladou""",
"""Fowler""",
"""France""",
"""Franken""",
"""Frankfurt""",
"""Frankreich""",
"""Frans""",
"""Freiburg""",
"""French""",
"""Friedberg""",
"""Friese""",
"""Frisian""",
"""Gabon""",
"""Gaelic""",
"""Gailinger""",
"""Galac""",
"""Garner""",
"""Gärtner""",
"""Gascogne""",
"""Gaulish""",
"""Gawar-Bati""",
"""Georgia""",
"""Georgian""",
"""German""",
"""Germanic""",
"""Gilgit""",
"""Gilgiti""",
"""Gilles""",
"""Glasgow""",
"""Glückel""",
"""Godoberi""",
"""Goeman""",
"""Gojri""",
"""Görlach""",
"""Göttingen""",
"""Gottlieb""",
"""Gottsched""",
"""Gravenberc""",
"""Greek""",
"""Grewendorf""",
"""Grobsdorf""",
"""Groningen""",
"""Gruschka""",
"""Guatemala""",
"""Gujarati""",
"""Gujars""",
"""Gultari""",
"""Günther""",
"""Gustav""",
"""Gutenberg""",
"""Haeckel""",
"""Haider""",
"""Halle""",
"""Hameln""",
"""Hans""",
"""Harold""",
"""Hartwig""",
"""Hattori""",
"""Haugen""",
"""Hawaiian""",
"""Hawick""",
"""Hebräisch""",
"""Hebreeuws""",
"""Hebrew""",
"""Hegauer""",
"""Heine""",
"""Heiyô""",
"""Helmut""",
"""Henoch""",
"""Hermann""",
"""Herzberg""",
"""Herzogthum""",
"""Hessian""",
"""Heymanns""",
"""Hidatsa""",
"""Hilsenrath""",
"""Himalaya""",
"""Himalayas""",
"""Hindi""",
"""Hindu""",
"""Hindukush""",
"""Hirsch""",
"""Hispanic""",
"""Hocąk""",
"""Hocank""",
"""Hôhô""",
"""Holland""",
"""Hopi""",
"""Horst""",
"""Hougen""",
"""Huallaga""",
"""Huambisa""",
"""Hungarian""",
"""Iberian""",
"""Ibérica""",
"""Icelandic""",
"""Ieper""",
"""Ieperlingen""",
"""Igbo""",
"""Ìgbò""",
"""Ihalainen""",
"""Imbabura""",
"""India""",
"""Indian""",
"""Indians""",
"""Indiens""",
"""Indo""",
"""Indochine""",
"""Indo-European""",
"""Indo-Iranian""",
"""Indonesian""",
"""Indosphere""",
"""Indus""",
"""Iowa""",
"""Iowa-Oto""",
"""Iowa/Otoe""",
"""Ioway""",
"""Iranian""",
"""Ireland""",
"""Irish""",
"""Iroquoian""",
"""Iroquois""",
"""Isaac""",
"""Isaak""",
"""Italian""",
"""Italiana""",
"""Italy""",
"""Itsekeri""",
"""Itzig""",
"""Ixil""",
"""Jacques""",
"""James""",
"""Jan""",
"""Jandls""",
"""January""",
"""Japan""",
"""Japanese""",
"""Jean""",
"""Jena""",
"""Jespersen""",
"""Jew""",
"""Jewish""",
"""Jewishness""",
"""Jewry""",
"""Jews""",
"""Jiwere-Nut'achi""",
"""Johannes""",
"""John""",
"""Jokan""",
"""Jonaz""",
"""Joseph""",
"""Joshua""",
"""Josy""",
"""Juan""",
"""Judaica""",
"""July""",
"""Kafka""",
"""Kagoshima""",
"""Kaiser""",
"""Kalam""",
"""Kalasha""",
"""Kalkatak""",
"""Kalkoti""",
"""Kami""",
"""Kansa""",
"""Kansai""",
"""Kanza""",
"""Karakorum""",
"""Karanga""",
"""Karel""",
"""Kasai""",
"""Kashmir""",
"""Kashmiri""",
"""Katarqala""",
"""Kaw""",
"""Kayne""",
"""Khowar""",
"""Kiel""",
"""Kleiber""",
"""Kluender""",
"""Kohistan""",
"""Kohistani""",
"""Kohistanis""",
"""Koinaí""",
"""Kolmogorov""",
"""Koppelmans""",
"""Korean""",
"""Kotoba""",
"""Kristol""",
"""Kritik""",
"""Krogh""",
"""Kundal""",
"""Kurdish""",
"""Kurmanji""",
"""Kurt""",
"""Kush""",
"""Kyoju""",
"""Kyôju""",
"""Kyûshû""",
"""Lakhota""",
"""Lakota""",
"""Lancashire""",
"""Languedoc""",
"""Latin""",
"""Laurence""",
"""Layul""",
"""Lehiste""",
"""Lendu""",
"""Levenshtein""",
"""Levis""",
"""Levys""",
"""Lewisohns""",
"""Lezgian""",
"""Liechtenstein""",
"""Liechtensteiner""",
"""Limbu""",
"""Lisbon""",
"""London""",
"""Lotegorisch""",
"""Louis""",
"""Louisiana""",
"""Machoke""",
"""Macquarie""",
"""Macro-Siouan""",
"""Macushi""",
"""Mago""",
"""Mainz""",
"""Malay""",
"""Mam""",
"""Manchester""",
"""Mandan""",
"""Manfred""",
"""Marburger""",
"""März""",
"""Matisoff""",
"""Matthias""",
"""Matti""",
"""Max""",
"""Maya""",
"""Mayan""",
"""Melanesia""",
"""Mesoamerican""",
"""Mesquakie-Sauk""",
"""Messias""",
"""Mexico""",
"""Meyer""",
"""Mia""",
"""Miami""",
"""Michigamea""",
"""Mid-America""",
"""Minnesota""",
"""Misantla""",
"""Missouria""",
"""Mixe""",
"""Mixtec""",
"""Mobilian""",
"""Mohammad""",
"""Mokum""",
"""Mong""",
"""Montevideo""",
"""Moravia""",
"""Mulamuds""",
"""Munske""",
"""Münster""",
"""Murter""",
"""Murtera""",
"""Murteru""",
"""Nakoda""",
"""Natchez""",
"""Navajo""",
"""Neanderthal""",
"""Neckar""",
"""Nederland""",
"""Nemaha""",
"""Nepal""",
"""Nespital""",
"""Netherlandic""",
"""Netherlands""",
"""Netzen""",
"""Nevada""",
"""Niedersachsen""",
"""Niger-Congo""",
"""Nigerian""",
"""Nihon""",
"""Niigata""",
"""Nobel""",
"""Norddeutschland""",
"""Norfolk""",
"""North""",
"""Northeast""",
"""Northwest""",
"""Norwegian""",
"""Nottingham""",
"""Nuristani""",
"""Ofo""",
"""Ojibwe""",
"""Oklahoma""",
"""Omaha""",
"""Ontario""",
"""Orkney""",
"""Orton""",
"""Osage""",
"""Ossi""",
"""Ostfriesland""",
"""Oto""",
"""Otoe-Missouria""",
"""Owerri""",
"""Oxford""",
"""Pakistan""",
"""Pakistani""",
"""Palula""",
"""Pamir""",
"""Panjabi""",
"""Paris""",
"""Pashai""",
"""Pashto""",
"""Passau""",
"""Pedee""",
"""Pennsylvania""",
"""Peristan""",
"""Peristân""",
"""Persian""",
"""Peterle""",
"""Phalûra""",
"""Philadelphia""",
"""Poguli""",
"""Poláčeks""",
"""Poland""",
"""Ponca""",
"""Ponka""",
"""Portugal""",
"""Portuguese""",
"""Prakrit""",
"""Proto-Gulf""",
"""Pyrenbitz""",
"""Pyrenean""",
"""Quapaw""",
"""Québec""",
"""Quechua""",
"""Querétaro""",
"""Radlof""",
"""Reenen""",
"""Rhin""",
"""Rhodesia""",
"""Río""",
"""Rissanen""",
"""Robert""",
"""Roberts""",
"""Roland""",
"""Romance""",
"""Romania""",
"""Románica""",
"""Rosenthal""",
"""Roths""",
"""Rotwelsch""",
"""Routledge""",
"""Rozier""",
"""Russian""",
"""Salish""",
"""Salzbourg""",
"""Salzburg""",
"""Samaná""",
"""Samuel""",
"""Sanderson""",
"""Sanskrit""",
"""Santa""",
"""Santíssima""",
"""Sardegna""",
"""Saul""",
"""Schlesischen""",
"""Schwaben""",
"""Schweiz""",
"""Schweizerdeutschen""",
"""SchweizerDeutschen""",
"""Scots""",
"""Scottish""",
"""Seereer""",
"""Sefar""",
"""Sénégal""",
"""Seoul""",
"""September""",
"""Shahi""",
"""Shakespeare""",
"""Shetland""",
"""Shevchenko""",
"""Shevoroshkin""",
"""Shina""",
"""Shlomo""",
"""Shmuel""",
"""Shona""",
"""Siberian""",
"""Sidak""",
"""Simon""",
"""Sinclair""",
"""Singlish""",
"""Sinosphere""",
"""Siouan""",
"""Siouan-Catawban-Yuchi""",
"""Sioux""",
"""Siraiki""",
"""Skardu""",
"""Slavic""",
"""Somerset""",
"""South""",
"""Southeast""",
"""Southern""",
"""Spanish""",
"""Spokane""",
"""Steffen""",
"""Stewart""",
"""Stokholm""",
"""Stoney""",
"""Stxolilal""",
"""Südtirol""",
"""Südwestdeutschland""",
"""Sundanese""",
"""Surbtaler""",
"""Svartvik""",
"""Swedish""",
"""Swish""",
"""Swiss""",
"""Sydney""",
"""Tacheles""",
"""Tajik""",
"""Talmud""",
"""Targumim""",
"""Teke""",
"""Teton""",
"""Tibeto-Burman""",
"""Timucua""",
"""Tirahi""",
"""Tiroler""",
"""Tohfa-e-Dil""",
"""Tomahitans""",
"""Toronto""",
"""Torricelli""",
"""Torwali""",
"""Toscana""",
"""Totanac""",
"""Totonaco""",
"""Trumai""",
"""Tsonga""",
"""Tswana""",
"""Tübingen""",
"""Tucson""",
"""Turkic""",
"""Turkish""",
"""Tuscan""",
"""Tutelo""",
"""Tyneside""",
"""Tyrol""",
"""Ukish""",
"""Ukrainian""",
"""Ukranian""",
"""Umbundu""",
"""Umoⁿhoⁿ""",
"""Ungarn""",
"""Urdu""",
"""Ushojo""",
"""Viehhändlersprache""",
"""Viking""",
"""Vitalij""",
"""Vlaanderen""",
"""Vorarlberger""",
"""Walderbach""",
"""Wales""",
"""Wallis""",
"""Walman""",
"""Walter""",
"""Warps""",
"""Wasco-Wishram""",
"""Washington""",
"""Weinreich""",
"""Welshness""",
"""Wenker""",
"""Wenkers""",
"""Wenkersatz""",
"""Wenkersätzen""",
"""Wenzel""",
"""West""",
"""Westgermaanse""",
"""Westgermania""",
"""Westhoek""",
"""Whitman""",
"""Wichita""",
"""Widdowson""",
"""Widuwilt""",
"""Wiener""",
"""Wigalois""",
"""Wilhelm""",
"""Wilson""",
"""Windsor""",
"""Winnebago""",
"""Wirnt""",
"""Wisconsin""",
"""Wiyot""",
"""Wolfgang""",
"""Wotapur""",
"""Würzburg""",
"""Wyclifite""",
"""Xhosa""",
"""Yehuda""",
"""Yekl""",
"""Yerushalmi""",
"""Yiddish""",
"""York""",
"""YouTube""",
"""Yuchi""",
"""Yurok""",
"""Zaire""",
"""Zealand""",
"""Zipfs""",
"""Zirndorf""",
"""Zores""",
"""Zürichdeutschen""",
"""Bayesian""",
"""Catawba""",
"""Creoles""",
"""Indo-Aryan""",
"""Northern""",
"""Otoe""",
"""Proto-Siouan""",
"""Western""",
"""Chinese""",
"""cherokee""",
"""Kimarang""",
"""Frege""",
"""Balinese""",
"""Irish"""
  ]
  

EXCLUDES = []